CHANGELOG
----------------------

[2013-04-01: Sasha Vasko]
 * AfterStep 2.2.12 release
 * updated configure script to remove old privacy notice and add install
   instructions.
 * Added tools/git-cl.sh for ChangeLog generation and updated Makefile.in
   accordingly

[2013-03-25: Sasha Vasko]
 * Fixed _NET_CLIENT_LIST and _NET_CLIENT_LIST_STACKING publishing on 64bit
   oses to convert Window Ids to 32bit. Fixes window lit not showing in
   gnome-panel and other GNOME apps. Added handling of _NET_WM_STATE_FOCUSED as
   per Extended WM Hints spec. Added corresponding ClientMessage handling.
   Fixed handling of AS desktop number to GNOME desktop number translation.
   That fixes window focusing using GNOME pager and window list.

[2013-03-21: Sasha Vasko]
 * added instruction for installation under different environments
 * Added configure check for GSettings. Apparently it's missing in older
   libgio.

[2013-03-20: Sasha Vasko]
 * Fixed includes for GSettings stuff in afterstep/dbus.c Added couple web
   backgrounds

[2013-03-15: Sasha Vasko]
 * Updated Quit menu to differentiate Logout/QuitWM/Restart
 * Changes to integrate with KDE: Fixed desktop switching, added integration
   with KSMServer

[2013-03-14: Sasha Vasko]
 * Fixed compile - instead of linking to glib we now link to gio - was causing
   compile problems without svg support

[2013-03-12: Sasha Vasko]
 * Replaced old IRC icon Fixed memory leak in Feel/ComplexFunction parsing -
   need to init functions list. Added functionality to Wharf to check if
   Logout/Restart/Shutdown/etc are available. Fixed Wharf to hide NOP buttons.

[2013-03-11: Sasha Vasko]
 * Updated IRC icon

[2013-03-10: Sasha Vasko]
 * Added code to convey remapping of the functions to modules through non-con
   file.

[2013-03-09: Sasha Vasko]
 * Added missing file SpeechBubble

[2013-03-08: Sasha Vasko]
 * changes to convey to modules which functions are disabled through file in
   non-c

[2013-03-05: Sasha Vasko]
 * Implemented Suspend and Hibernate command using UPower through dbus Added
   icons for sleep, shutdown and better icon to replace MusicalNote
 * Implemented SystemShutdown command to utilize gnome-session to 	request
   system shutdown/reboot/suspend. Implemented Logout command to logout session
   when running under gnome-session Made Restart command disabled when running
   under gnome-session Added Logout icon, from Open Clipart Library (author
   warszawianka) Added change_func_code function to change the meaning of a
   function (only works if called before the parsing)

[2013-03-04: Sasha Vasko]
 * Adjusted icon finding algorithm to not try .Z .gz extension when png, tiff
   or jpeg is present Removed $PATH from image search paths since it was
   causing executables to be probed. Added check for image already loaded
   Disabled icon theming whenever filename contains directory names Disabled
   search whenever image filename is a full path.

[2013-02-28: Sasha Vasko]
 * Added menu exclusions by item's category, not just item name Fixed icon
   loading to hit places, devices, actions and categories Fixed minor bug in
   endless recursion on loading CategoryTree Added submenus to System Settings
   menu

[2013-02-25: Sasha Vasko]
 * Fixed re-rendering of transparency in ASMount on background change
 * Applied Debian patch 13, fixing feel.DEFAULT and adding feel.Debian
 * Added xterminal menu entry as per Debian patch 10
 * applied debian patch 06-AsDocGen fix for NROFF generation
 * applied patch 00 from .deb partially - all except deb-specific stuff

[2013-02-21: Sasha Vasko]
 * Added web backgrounds for Mountains and Water

[2013-02-16: Sasha Vasko]
 * Fixed startup code to wait for autostarted windows to finish mapping before
   switching to normal running mode. Fixed hard to trigger race condition
   capable of locking Afterstep into select() from modules before we are
   actually ready to send.

[2013-02-13: Sasha Vasko]
 * Added dbus functionality to query ConsoleKit 	(to be used with
   Shutdown/sleep/hibernate functionality) Traced the issue with gnome-session
   restoring or not restoring the last 	session to patch in Ubuntu disabling
   the functionality

[2013-02-11: Sasha Vasko]
 * Fixed bug in uninitialized variable in sassion state saving code. Added code
   to check if gnome-session has autosave-session, and skip session managed
   windows in this case. Updated config.h.in
 * re-indent on libAfterStep, libAfterConf and libASGTK
 * re-indented afterstep libs

[2013-02-08: Sasha Vasko]
 * reformated/indented afterstep proper
 * Minor bugfixes in session shutdown code work workspace file writing and
   timer setup.

[2013-02-01: Sasha Vasko]
 * Rewrote handling of window groups; Changed saving session to save only one
   command for each window group (with --sm-client-id) Fixed pointer placement
   to obey avoid cover

[2013-01-31: Sasha Vasko]
 * Tweaks to session state saving and restoring Better shutting down of apps on
   session end.
 * Implemented proper session shutdown with closing of running apps

[2013-01-30: Sasha Vasko]
 * Fixed Gnome session management support to send EndSessionOk message to the
   correct interface and our client path
 * Fixed move/resize code to properly account for virtual coordinates and
   changes in viewport. Minor tweaks to Makefiles for shorter output

[2013-01-28: Sasha Vasko]
 * Fixed debian alternatives installation with hopefully correct path
 * Completed gnome session management protocol support implementation. May need
   to add requirement for notiofications daemon in .session file

[2013-01-27: Sasha Vasko]
 * small big in environment rewriting code

[2013-01-25: Sasha Vasko]
 * Partially sorted out session manegement with Gnome Session Manager including
   registration, end of session, as well as Notifications. Still work in
   progress, some interfaces have to be implemented

[2013-01-24: Sasha Vasko]
 * Added functionality to display Minipixmap for any web background that was
   previously donloaded Added AfterStep.session file for gnome-session Fixed
   locations and contents of .desktop file to get session management to work
   somewhat. AfterStep should be started through gnome-session if available.

[2013-01-22: Sasha Vasko]
 * Fixed vertical layout of ASMount
 * Added popular backgrounds from vladstudio.com
 * Added web backgrounds from Digital Blasphemy and vladstudio.com

[2013-01-19: Sasha Vasko]
 * Added MyStyles for ASMount Started implementation of Notification messages
   using dbus

[2013-01-18: Sasha Vasko]
 * Fixed segfault when Module config file is missing

[2013-01-17: Sasha Vasko]
 * Fixed all looks except for DEFAULT missing MenuBalloons Fixed segfault in
   Backgrounds Menu Fixed web backgrounds, now Preview works as well.
 * Added 2 web backgrounds from flickr.

[2013-01-04: Sasha Vasko]
 * Attention: This is commit has bugs! There is a Segfault in Menu
   functionality

[2013-01-02: Sasha Vasko]
 * added unexpand script to handle broken indenting in the source code

[2012-12-28: Remco Rijnders]
 * Improved allocation logic of buttons on the WinList
 * Remove unused Options code
 * Reindented WinList.c

[2012-12-27: Sasha Vasko]
 * Implemented functionality to use urls as the source of ForeignBackground
   (utilizing wget) with local caching of downloads

[2012-12-27: Remco Rijnders]

[2012-12-26: Sasha Vasko]
 * Fixed compile warnings in libAfterBaseand libAfterImage
 * Fixed bug in check_astbar_point and updated base.in to work with icon themes
 * Added missing ASMount.c
 * Added icons and buttons for ASMount
 * Added Icon theme support, ASMount config file handling, GLIB detection minor
   cleanups and bugfixes.

[2012-12-24: Sasha Vasko]
 * Updated build files for new version of AS and to include ASMount
 * Added ASMount module for storage Volume manipulation

[2012-11-16: Remco Rijnders]
 * Update Release Guide to use git, change reference to freshmeat
 * Remove obsolete files -- everyone who is going to upgrade from these
   versions already has

[2012-11-15: sasha]
 * Added ASMount tool to handle dbus volume management stuff
 * applied docs patch from Remco Rijnders removing old READmes

[2012-11-15: Remco Rijnders]
 * Updated TEAM members file
 * Include warning to outdated localised README files
 * Update README file
 * Remove old ChangeLog file and add pointer to VCS for it in current changelog

[2012-11-14: sasha]
 * Added patch to compile with libexecinfo. Contributed by Naohiro (gentoo)

[2012-11-05: sasha]

[2012-10-17: sasha]
 * updated to fix compilation problems related to newer autoconf, plus session
   .desktop file

[2012-09-06: Remco Rijnders]
 * Update support information

[2012-07-12: sasha]
 * fixed compilation of ASRun when gtk is unavailable
 * fixed compilation of ASRun when gtk is unavailable

[2012-07-03: sasha]
 * updated todo

[2012-06-27: born2late]
 * fix so afterstep will compile without gtk

[2012-02-29: born2late]
 * version of the aterm logo with higher contrast (through shadow/glow)

[2012-02-01: born2late]
 * yeah, fixme count lowered after a looong time
 * fixed wrong description of this item

[2011-12-09: speedy]

[2011-12-08: speedy]
 * bring modules under one topic
 * added docs for Banner, afterstep. cleaning up documentation menus.

[2011-12-07: speedy]
 * added Ident and GWCommand  under ASDocGen

[2011-12-06: speedy]
 * changed link to sourceforge bug tracker
 * updated thumbnail cache to actually work without debian submenu

[2011-12-05: speedy]
 * added debian patches 20, 31, 35; gentoo patches ldflags and libpng15

[2011-12-01: speedy]
 * more tweaks from debian, most of patch 12
 * added debian sensible browser, debian patch 05
 * added debian tweaks and fixes, patches 01,11,21,33,34,36,38
 * added debian gcc warning, segfault, and compile fixes
 * added debian typo fixes from patches 22, 24, 28, 29, 37

[2011-06-29: sasha]
 * no message

[2011-01-28: sasha]
 * Added check if the header was already included
 * Moved BMP related code to bmp.c as windows headers conflict with libjpeg

[2011-01-14: sasha]
 * Updated the ChangeLog for release
 * AfterStep release v 2.2.11

[2011-01-13: sasha]
 * Changed version to 2.2.11 and fixed build to compile ASWallpaper

[2010-10-06: sasha]
 * fixed bug in window circulation causing second window skipped all the time

[2010-09-23: sasha]
 * fixed memory leak in xcf file loading
 * fixed memory leak in tga image loading
 * fixed minor memory leak in gif saving code.
 * fixed memory leak in xml processing on image loading
 * fixed major memory leak at vectorize_asimage
 * Fixed BMP writing to not set compression to 1 - we don't use any

[2010-09-15: sasha]
 * fixed possible dereferencing of NULL pointer in asimage_destroy (minor)

[2010-09-08: sasha]
 * trimmed some dead code
 * fixed visual2visual_prop bug in *size usage
 * fixed param hidden warnings
 *  corrected usage of get_xpm_string() to use proper enum value

[2010-09-03: sasha]
 * Fixed possible memory leak in xpm code when image is too big
 * fixed unlikely but possible (if height>width) buffer overrun bug in gradient
   generation code
 * Fixed unlikely but possible use of uninitialized variable in
   ASImage2xpmRawBuff
 * Fixed unlikely but possible use of uninitialized variable in
   ASImage2xpmRawBuff

[2010-06-22: vae]

[2010-05-20: sasha]
 * updated to libjpeg v.8b

[2010-01-29: sasha]
 * added transupp to libjpeg just in case
 * upgraded built-in libjpeg to version 8

[2009-12-31: sasha]
 * Fixed bug in handling of icon size when icon size provided in ExtWM property
   is corrupt
 * added more debugging to figure out how zero length icon properties crash
   afterstep

[2009-12-23: sasha]
 * MOre flexible handling of titlebar button info sharing between modules to
   accomodate for wide range of configs

[2009-12-11: sasha]
 * fixed segfault in on look change where previous look has obsolete font
   settings

[2009-11-12: sasha]
 * fixed export.c to properly assign default export values using union members
   - contributed by Axel Naumann

[2009-10-14: sasha]
 * fixed annoying ICC warnings in mystrdup use without libAfterBase

[2009-10-13: sasha]
 * minor fix in afterbase.c to correct ambiguity in evaluation order

[2009-10-05: sasha]
 * fixed -v command line arg handling

[2009-09-30: sasha]
 * applied contributed WarpPointer patch to make warping of pointer on viewport
   change a feel option

[2009-08-25: sasha]
 * fixed ascompose to build without X libs
 * fixed X Connection initialization to set up global vars in ALL cases - that
   was causing ASGTK apps to fail
 * fixed ascompose to build without X libs

[2009-07-20: sasha]
 * fixed missing include for session.h causing grief to package managers

[2009-07-15: sasha]
 * added SkipPager database flag to exclude windows from the Pager's view

[2009-05-04: sasha]
 * updated ChangeLog for the release
 * AfterStep release v 2.2.9

[2009-04-03: sasha]
 * added detailed instruction for ascolor usage

[2009-04-02: sasha]
 * cleaned up WinTabs tab grouping - added config options to switch it on and
   set group name separator

[2009-04-01: sasha]
 * fixed segfault in Session Manager registration when session manager is not
   available or sm_client_id is otherwise empty
 * disabled minipixmap loading when MenuMiniPixmaps are off

[2009-03-18: sasha]
 * added ifdef to avoid double fclose under MSVC2005 and newer
 * added ifdef to avoid double fclose under MSVC2005 and newer
 * added ifdef to avoid double fclose under MSVC2005 and newer

[2009-03-06: born2late]

[2009-03-02: born2late]
 * just checking if commit is working after this long time

[2009-02-11: sasha]
 * Got rid of dpy global variable in libAfterBase and libAfterIMage for good.
   Moved it into libAfterStep instead, as it incorporates screen handling
   functionality.

[2009-01-30: sasha]
 * fixed warning in jpeg2ASImage

[2009-01-16: sasha]
 * fix to fill_hline_colored to work on scratch canvas + some debugging of
   reported fill bugs on 64bit systems

[2009-01-13: sasha]
 * fixed aliasing for drawing with brush wider then 1x1; Fixed areas of low
   intensity inside solid lines
 * fixed clipping in straight ellips drawing where y+ry > height
 * added missing declaration of Bool asim_set_custom_brush_colored()

[2009-01-12: sasha]
 * somewhat fixed drawing with ARGB brush over ARGB canvas; Still unclear what
   would happen if those are different ;

[2008-12-17: sasha]
 * added RegisterClient message to dbus stuff
 * fixed memory leak in ASImage2gif file needed to be closed even after Egif
   closes it too
 * fixed Makefile to work on FBSD/Gentoo

[2008-12-16: sasha]
 * added --sm-client-id startup option to AfterStep

[2008-12-05: sasha]
 * more gnome interaction stuff
 * compie bug fix

[2008-12-04: sasha]
 * added rudimentary dbus connectivity
 * added rudimentary dbus connectivity

[2008-12-02: sasha]
 * fixed silly bug in asvector where inserted elems would not increase size of
   the vector

[2008-11-12: sasha]
 * fixed references to the global variable dpy in GLX code

[2008-11-06: sasha]
 * fixed a segfault in WinTabs and tabs rearranging on removal from the group
 * fixed a segfault in WinTabs and tabs rearranging on removal from the group

[2008-09-30: sasha]

[2008-09-16: sasha]
 * fixed focusing of the tabs on new window swallow when it gets added to
   unselected group
 * tweaks to layout of the grouped tabs

[2008-09-15: sasha]
 * fixed element re-location code in vector
 * implemented tab grouping functionality in WinTabs

[2008-08-15: sasha]
 * added utility to check if glyphs are available in the font for a certain
   char or a list of chars

[2008-07-28: sasha]
 * copyright update
 * added new function ExecInDir <dirname> <command> to run command using
   dirname as current dir. Added --cwd cmd line flag to ASRun to make use of
   ExecInDir

[2008-07-11: jeremy]
 * Fresh updates to Sound2

[2008-07-02: sasha]
 * disabled mapping on frame sooner then later as it ruins initial placement

[2008-07-01: sasha]
 * changed destroy_string to be a function instead of a macro to avoid
   excessive compiler warnings
 * compile bugs in linAfterConf

[2008-06-30: sasha]
 * added pointer warping on viewport shifts while move-resizing windows; added
   focus hiding on viewport change to prevent misdirected input
 * disabled pointer warping on viewport change

[2008-06-25: sasha]
 * tweaks to initial window mapping time

[2008-06-24: sasha]
 * fixed afterstep proper and wintabs to avoid refreshing decorations when
   window is offscreen
 * Fixed root pixmap setting - to handle XKillClient failures and not free
   pixmap after it was put on the root

[2008-06-23: sasha]

[2008-06-18: sasha]
 * Updated ChangeLog for libAfterImage 1.18 release
 * libAfterImage 1.18 release

[2008-06-13: sasha]
 * implemented EdgeResistanceToDragging setting

[2008-06-10: sasha]
 * compile bugs without X fixed
 * compile bugs without X fixed

[2008-06-02: sasha]
 * added missing scanline.h

[2008-05-30: sasha]
 * additional logic to avoid red/blue artifacts

[2008-05-29: sasha]
 * implemented some 12-bps raw image processing- demosaicing

[2008-05-15: born2late]

[2008-05-02: sasha]

[2008-04-23: sasha]
 * Fixed build on non-gcc compilers

[2008-04-17: sasha]
 * preliminary support for loading RAW camera photos stored as tiff images with
   CFA data - still need to implement interpolation, white balance, and
   leveling
 * preliminary support for loading RAW camera photos stored as tiff images with
   CFA data - still need to implement interpolation, white balance, and
   leveling
 * compile warning on signed/unsigfned comparison

[2008-04-10: sasha]
 * fixed alpha overflow in color2alpha

[2008-04-07: sasha]
 * implemented color2alpha method from GIMP without color correction that was
   damaging the image. Complete with color2alpha xml tag

[2008-04-03: sasha]
 * implemented pixelization filter

[2008-04-01: sasha]
 * some refactoring of config writing code

[2008-03-28: sasha]
 * more work on asgtklookeditor - reimplemented using MyStyleDefs and
   LookConfig

[2008-03-25: sasha]
 * compile bug on old compilers
 * fixed bug in Pager where shading/unshading causes Pager to grow in size if
   border width > 0
 * try once again to fix the sizing bug in Pager

[2008-03-24: sasha]
 * fixed handling of Pager resizing by either a geometry or wharf or wm
 * fixed bunch of compilation bugs showing up on old systems

[2008-03-21: sasha]
 * added functionality to ASLookEditor to safe MyStyles into library

[2008-03-20: sasha]
 * reimplemented MyStyle parsing using generic code; added Name and Comment to
   MyStyle;
 * keyword_macro.h

[2008-03-18: sasha]
 * prototyped support for MyStyle library

[2008-03-17: sasha]
 * hopefully fixed syslimit.h warnings on FBSD

[2008-03-07: speedy]

[2008-03-07: sasha]

[2008-03-06: speedy]
 * added some additional icon paths.

[2008-03-06: sasha]
 * fixed endless recursion into syntaxes in ASDocGen
 * minor optimization of ASDocGen
 * fixed problem with docs having spaces in filenames

[2008-03-05: sasha]
 * disabled build for Sound2 for now

[2008-03-04: sasha]
 * fixed segfault in xcf code where layer is larger then image
 * updated NEW and ChangeLogs for release 2.2.8
 * AfterStep release v. 2.2.8

[2008-03-02: jeremy]
 * Additional GTK File Sorting fixes

[2008-02-29: sasha]
 * some more brainstorming as related to aftershow design

[2008-02-28: sasha]
 * fixed window list saving into workspace_state file to skip shortlived
   windows

[2008-02-26: sasha]
 * updated afterbase.c to include new stuff from libAfterBase for xml

[2008-02-22: sasha]
 * channged handling of configureRequests to not move window around to avoid
   AvoidCover windows in layers above it
 * fixed selection rectangle sizing when desktop is not exact multiply of
   screen size

[2008-02-19: sasha]
 * xml manipulation code added

[2008-02-17: sasha]

[2008-02-16: sasha]
 * started implementing aftershow client to be used by shell scripts to
   redirect stdio to aftershow
 * fixed asfont get_glyph_map to not confuse compilers into thinking that there
   might be uninitialized stuff

[2008-02-15: sasha]
 * added code to handle client connections and input to aftershow
 * updated libAfterImage.mak

[2008-02-14: sasha]
 * added socket setup code - need to move socket.c in here in case afterbase is
   unavailable
 * more X initialization code for aftershow

[2008-02-13: sasha]
 * implemented possibility to define exact size of the virtual desktop, which
   may not be exact multiply of the screen size

[2008-02-11: speedy]
 * added additional text-based web browsers.
 * added additional text editors.

[2008-02-11: sasha]
 * implemented symlink chacking and DesktopEntry checking while determining if
   text editor or web browser require term to run

[2008-02-08: sasha]
 * started implementing aftershow daemon
 * started work on aftershow daemon
 * started work on aftershow daemon
 * fixed memory leak in ascompose processing in interactive mode
 * compile warning on solaris in pixmap.c

[2008-02-07: sasha]
 * fixed compile warning with gcc 4.3

[2008-02-06: sasha]
 * fixed compile warnings in asfont.c in win32
 * removed old png files from project
 * fixed png.h to properly include zlib.h on windows and undeffed stdint.h on
   win32

[2008-02-05: sasha]
 * changed logging to always append to log and not overwrite it
 * fixed missing parameters for spawn_child
 * hopefully fixed restarting functionality when running from under gdm and
   when AS is not in the PATH

[2008-02-04: sasha]
 * fixed previous fix for AS restart under FC

[2008-02-02: speedy]
 * added bug tracker info to About AfterStep Menu

[2008-02-02: jeremy]

[2008-02-01: sasha]
 * fixed makefile to not reference obsolete libong files

[2008-01-28: jeremy]

[2008-01-26: jeremy]
 * Added new sound conf option. Adding more error control to Sound2.

[2008-01-25: sasha]
 * added functionality to ascompose to allow for constantly updating display of
   stuff; command line should be: script.sh | ascompose -I --endless
   --click-timeout 0 -q -f -;

[2008-01-24: sasha]
 * fixed window move/resize where window would get resized even after button
   release

[2008-01-24: jeremy]
 * Additional notes added to Sound2 code, minor cleanups.

[2008-01-23: jeremy]
 * minor notes added to sound2 module files
 * global Makefile will (attempt) to compile Sound2 module

[2008-01-23: born2late]
 * actual version - not updating - maybe sasha can help

[2008-01-22: jeremy]

[2008-01-18: sasha]
 * implemented full color drawing in draw.c using prototypes from ROOT by
   Valeri Onuchin. Needs testing and and changes to aply_context()
 * changed draw.c to use 32bit values in canvas, possibly to enable rendering
   in all 4 channels in future - need more work

[2008-01-17: sasha]
 * fixed handling of grayscale PNG images with bit depth < 8

[2008-01-16: sasha]
 * partially fixed segfault on loading grayscale PNG images
 * fixed segfault on loading grayscale PNG images
 * fixed bug in Makefile
 * added flags to top level configure to force usage of builtin jpeg, png and
   zlib
 * enabled debugging for bigendian tests

[2008-01-15: sasha]
 * moved HAVE_XPM to after config.h in libAI xpm.c; updated main configure
 * exclude xpm.c from built when no xpm is requested; no longer support
   standard libgif and libxpm

[2008-01-13: jeremy]
 * Sound2 parsing out sound files better now

[2008-01-12: jeremy]
 * Removed more legacy Sound options, Sound2 reading more conf settings

[2008-01-11: jeremy]
 * unbreak AS compiling cause of sound conf changes
 * Added pcmdevice option to sound's conf
 * More sound2 module handling changes

[2008-01-10: sasha]
 * updated Team members

[2008-01-09: sasha]
 * implemented functionality to setup slicing of frame sides and titlebar
   elements
 * added code to kill Esetroot client if desktop background was set by it

[2008-01-09: jeremy]
 * More Sound2 module updates/changes to include wave header reading
 * Minor Sound2 header updates

[2008-01-08: sasha]
 * added functionality to ascompose to set XROOTPMAP property while changing
   root background

[2008-01-07: jeremy]
 * make install puts in the sound config file and desktop/sounds dir
 * Added new sound files to place Audio.c and audio.in
 * Renamed all Audio to Sound in Makefiles, etc.

[2008-01-04: sasha]
 * fixed bad set_string_val macro to properly handle NULL pointer
 * removed erroneous configure.h include in ascompose

[2008-01-04: jeremy]
 * More Sound2 config updates
 * Adding conf file support to Sound2
 * Sound2 module plays sound on window shade
 * More Sound2 module updates

[2008-01-03: born2late]
 * modifications to make it better work with php pages
 * added utf8 support according to sasha s instructions - seems to work

[2007-12-27: sasha]
 * removed config.h from installation script
 * added new convinience function to convert Lead Tools like DIBs into ASImage
   in one call; Fixed typo in ASImage2DIB.
 * Fixed major bug that maybe causing memory corruption on any system where
   malloc does not return pointer aligned on 8-byte boundary
 * sanity fix to configure

[2007-12-26: sasha]
 * fixed logic to not enlarge icons in menus if target size is too big

[2007-12-23: jeremy]
 * Added Sound2 Header file
 * Added sample .wav for any testing of Sound2 module
 * Rewrite of Sound2 Module.

[2007-12-19: sasha]
 * removed X Intinrsic header as unneeded
 * giving up on trying to figure out why asvector does not work on Power PC

[2007-12-18: sasha]
 * yet another try in resolving endiannes of the XImage encoding

[2007-12-17: sasha]
 * rewrote scanline2ximage32 to properly account for offset and hopefully fix
   byteordering issue

[2007-12-17: jeremy]
 * more sound2 module stuff

[2007-12-14: sasha]
 * hopefully fixed incorrect byte order while converting XImage on 32 bit
   visuals back to ASImage on big endian machines
 * fixed build problem in libAC
 * minor cleanups in configure script to use lowercase NO

[2007-12-14: jeremy]
 * Sound2 test code, dont try to look for and play test wav
 * Sound2 module now does events right.. i think

[2007-12-06: sasha]
 * compilation problems with missing X libs

[2007-12-05: sasha]
 * updated built-in libpng to 1.2.23

[2007-11-30: sasha]
 * synchronised xwrap.h with libAfterImage
 * updated xwrap.h to be the same as in libAfterBase and fixed compilation
   under newer MSVC

[2007-11-26: sasha]
 * Fixed memory leak in DGifCloseFile where pointer to GifFile gets overwritten
   with NULL leaving dungling memory

[2007-11-20: sasha]
 * fixed memory leak in gif import code

[2007-11-16: sasha]
 * fixed missing initialization of ASColormap structure in colormap_asimage
 * disabled performance output in transform.c

[2007-11-12: born2late]
 * added docs for bevel in different parts of window frames

[2007-10-31: born2late]

[2007-10-25: speedy]
 * added urxvt as an option for ExecInTerm
 * added urxvt to list of terms (first now, followed by aterm).

[2007-10-25: sasha]
 * added ability to load ASXML images for set size - should use .width and
   .height vars inside the image to calculate different sizes

[2007-10-16: sasha]
 * Implemented proper transfer of ASImage to OpenGL drawables using textures
   and pixel ops

[2007-10-01: speedy]

[2007-09-24: sasha]
 * implemented  Underpointer placement type

[2007-09-21: sasha]
 * altered configure to make building of apps optional - if the dir is present

[2007-09-20: sasha]
 * got rid of pesky compile warnings in selfdiag code
 * fixed compilation of self-diag code under cygwin

[2007-09-18: sasha]
 * removed __FUNCTION__ to fix compile on Solaris

[2007-09-17: sasha]
 * fixed compile errors under MSVC
 * fixed compile errors under MSVC
 * fixed compile errors under MSVC
 * fixed compile errors under MSVC
 * fixed compile errors in asstorage.c under MSVC

[2007-09-15: sasha]
 * fixed compile warnings on solaris in asvisual.c reported by ROOT project
 * fixed compile problem under VisualStudio .Net 2005, as reported by Valeri
   Onuchin
 * added functions for reading raw XPM and PNG buffers, contributed by Valeri
   Onuchin of ROOT project
 * added ASImage2xpmRawBuff() contributed by Valeriy Onuchin of ROOT project

[2007-09-14: sasha]
 * fixed compile bug when building with shmimage and without libAfterBase

[2007-09-12: born2late]
 * minor typos corrected
 * just making sure all config option are in again... did not add dirs
   Look/obsolete Wharf\ Folders and Wharf Contents, since it looks like they
   are generated by error by asdocgen
 * reverting to version 1.2
 * upsi - that is not what i wanted... gotta remove that
 * desklets update : now unified shell script to control with some help text
   output

[2007-09-06: born2late]
 * using awk instead of sed mainly now as it is way more powerfull

[2007-09-05: sasha]
 * Implemented BlurSize option in MyStyles
 * fixed one off error in blurring code  potentialy causing a segfault

[2007-09-03: born2late]
 * hopefully now working with locale !=de/at
 * now fully working calendar (at least with my locale), need others to check
   if it s really doing correctly

[2007-09-02: madarche]
 * M.-A. Darche:

[2007-09-01: born2late]
 * update to calendar desklet

[2007-08-30: born2late]
 * first checkin of desklets, gotta find a way to keep cpu load lower, 1% atm
   on my machine for both

[2007-08-23: sasha]
 * updated ChangeLog for release

[2007-08-22: sasha]
 * compile problem on solaris fixed; Feeble attempts at increasing performance
   without any results
 * compile fixes and minor optimization of the blurring code

[2007-08-20: sasha]
 * AfterStep 2.2.7 release
 * fixed bug where ExecInTerm targets wheren't properly tested for existence
 * fixed bug where ExecInTerm targets wheren't properly tested for existence
 * added logic to not reuse the icon from underlaying (disabled) contexts if
   selected context is the swallow function

[2007-08-16: sasha]
 * fixed syntetic ConfigNotify events to have proper root coordinates, and
   don't rely on cached parent's geometry
 * Corrected problems with too many or too few syntetic configure notifes set
   to the clients, especially on initial map and and move/resize
 * fixed an issue with re-swallowed clients being immidiately unswallowed again

[2007-08-15: sasha]
 * implemented proper handling of border fill for nasty terms who set parent's
   backgrounds to ParentRelative
 * added missing event mask for unswallowed from WinTabs windows
 * fixed problem with focus switching in WinTabs - it is now accepting
   WM_TAKE_FOCUS and only then does it switch the focus internally
 * fixed clearing window border when in transparent mode and handling of look
   switches - to change border color
 * added some fancy logic to determine what color to use to fill around windos
   in WinTabs
 * fixed swallowing in WinTabs after a window was unswallowed and destroyed and
   a new window with the same ID is created

[2007-08-02: sasha]
 * fixed printing of CARD32 values on 64 bit CPUs as lX
 * Fixed install targets in Makefiles to create dirs
 * Fixed install targets in Makefiles to create dirs

[2007-08-01: speedy]
 * cleaned-up Animate module docs.
 * updates to documentation.

[2007-08-01: sasha]
 * Fixed install targets in Makefiles to create dirs
 * fixed configure and deps checking in apps
 * updated documentation for libAfterImage
 * updated ChangeLog for libAfterImage release
 * Updated embedded libPNG and Zlib to latest versions; Fixed bugs in find_file
   when compiled without libAfterBase.
 * libAfterImage v. 1.15 release

[2007-07-31: sasha]
 * added some docs to libAfterImage
 * Completed refactoring gaussian blur code. It now works both in vertical and
   horizontal direction. Maximum blur radius is 128, and its bloody fast too
 * optimizations to gaussian blur and fixed mystrdup(NULL) in libAI standalone
 * fixed gaussian blur at the begining and the end; added lookup tables for
   standard deviation and multiplier, prototyped vertical pass

[2007-07-30: sasha]
 * implemented integer math version of gaussian blur algorithm
 * fixed blur function to not limit radius to 10 and properly calculate
   gaussian distribution

[2007-07-28: sasha]
 * switched timing printing off

[2007-07-27: sasha]
 * some additions to asstorage attempting to improve performance in XImage
   reading - unsuccessfull

[2007-07-26: sasha]
 * Cleaned up libAfterImage to compile without libAfterBase and added
   fiunctions to ger drawable size and window position for a specific display

[2007-07-25: sasha]
 * fixes to libAfterImage to get it compiling without libAfterBase and to
   reduce valgrind complaints about uninitiolized memory

[2007-07-23: sasha]
 * added sorting keyword by alpha to doc generation
 * added sorting keyword by alpha to doc generation
 * wintabs config should be installed

[2007-07-22: speedy]

[2007-07-20: sasha]
 * fixed many valgrind messages related to uninitialized memory in
   libAfterImage and libAfterBase; Fixed WinTabs to take into consideration
   window's gravity and frame rectangle while determining where to unswallow
   the window.
 * fixed image reloading to keep relevant flags - that was messing up wharf's
   support for look defined folder icon. That should also speedup repeated
   changes of look
 * adding support in Wharf for look-specific folder pixmap - so far only works
   2 times, then stops changing - wierd

[2007-07-19: sasha]
 * further safeguarding agains running out of storage slots in asstorage
 * further safeguarding agains running out of storage slots in asstorage
 * fixed Pager's layout when No Label is drawn

[2007-07-18: sasha]
 * fixed WinTabs changing its geometry on look changes
 * fixed random segfault in Pager caused by uninitialized MyFont structure;
   Fixed random segfault in modules, caused by double freeing of the same
   ASImage in titlebar buttons refreshing code.

[2007-07-17: sasha]
 * fixed the way dumb scaling up along Y axist was screwing up slicing of the
   small images.
 * fixed stupid dumb bug in make_scales introduced in porevious fix
 * fixed a long-standing bug with slicing images getting a vertical stripe
   tovards the end. Thanks DrCurl for your Patience
 * fixed a long-standing bug with slicing images geting a vertical stripe
   tovards the end. Thanks DrCurl for your Patience.

[2007-07-16: sasha]
 * hopefully fixed mixup with inheriting/merging fonts

[2007-07-13: sasha]
 * added a search for .svg files when icon name is missing extention make

[2007-07-12: sasha]
 * added fixes for using proper dpy (from ASVisual structure) in many cases

[2007-07-11: sasha]
 * fixed compilation without libPNG; added ability to change default asstorage
   block size
 * fixed bar rendering to have proper values used for unset hue/saturation,
   which eliminates one extra ASImage from being rendered

[2007-07-10: speedy]

[2007-07-10: sasha]
 * fixed bugs intriduced my on demand loading of MyStyle fonts - menu
   minipixmap size and corrupt memory due to double free
 * fixed compilation without X in libAfterImage
 * reduced modules memory usage by making fonts loading on demand, instead of
   on look change

[2007-07-09: sasha]
 * fixed few emory leaks (minor)

[2007-07-08: madarche]
 * M.-A. Darche :

[2007-07-07: speedy]
 * Added urxvt to menus, cleaned-up top and mlterm.

[2007-07-06: sasha]
 * fixed several critical bugs in causing double free and heap corruption,
   based on valgrind traces
 * reimplemented selfdiag code using proper techniques of backtrace_ functions

[2007-07-05: sasha]
 * fixed memory leak in self-diag functionality - memory returned from
   backtrace glibc call has to be freed. That was causing massive fragmentation
   of the heap, and memory abuse by AfterStep. Still need to fix same stuff in
   print_backtrace function
 * added functionality to use statically allocated structs for sending modules
   messages - no need to bother with heap for that.

[2007-07-05: madarche]
 * M.-A. Darche :

[2007-07-03: sasha]
 * eleminated excessive redraws when app resizes its icon while not being in
   iconic state; Eleminated excessive updates when app changes WM_HINTS
   midflight to exact same values (GTK apps)

[2007-07-02: sasha]
 * fixed handling on window layer set in gnome hints - should not divide by two

[2007-06-30: jeremy]
 * Audio module reading events better

[2007-06-22: sasha]
 * Improved on location where submenus are opened, to make sure they don't
   completely cover parents

[2007-06-18: born2late]
 * little typo correction to see if i get mail from cvs mailing list

[2007-06-10: jeremy]

[2007-06-09: jeremy]
 * changed Audio to Sound in module header.
 * sound2 module able to receive event messages now

[2007-06-08: jeremy]
 * more sound2 module testing
 * Sound2 builds.. but doesnt do anything

[2007-06-07: jeremy]
 * more Sound2 code
 * configure really makes sound2 makefile now
 * configure make sound2 makefile now

[2007-06-06: sasha]
 * Added DontCoverDesktop feel flag and fixed handling of several flags in feel
   in cases where value would be specified

[2007-06-05: born2late]
 * hopefully got check right, sorry sasha !
 * little <hr> beautification for php part (_related files)

[2007-06-01: sasha]
 * added support for x-terminal-emulator and editor from alternatives; Fixed
   handling of ampty ShadeButton setting in Pager config

[2007-05-30: sasha]
 * Fixed typo causing ttf configure parameteers being ignored

[2007-05-17: sasha]
 * updated ChangeLogs for relesae
 * AfterStep 2.2.6 relase

[2007-05-15: sasha]
 * fixed handling of AvoidCover on window move/resize
 * changed default wharf geometry to go into upper left corner
 * upgraded AS version in anticipation of release
 * added ability to Wharf to kill swallowed apps by its PID. That seems to have
   resolved a problem with trayer app
 * fixed bug where if DesktopEntry was not found - there would still be an
   emoty wharf button

[2007-05-14: sasha]
 * Fixed handling of ballons config parsing; Implemented support for ShowHints
   in WinList allowing for Name, IconName, ResClass, ResName

[2007-05-11: sasha]
 * made ShowHints more generic option allowing iut to be used in other modules
   - started modifying WinList to make use of it

[2007-05-07: sasha]
 * Implemented NoModuleNameCollisions in base config to make AS kill old
   instances of the module with same name

[2007-05-06: sasha]

[2007-05-03: sasha]
 * cleanup of the stacking order code
 * implemented IgnoreRestack to adde finer grain to IgnoreConfig -
   IgnoreRestack will only ignore Raise/Lower requests from the client
 * fixed window list publishing to use new stacking_order vector

[2007-05-02: sasha]
 * minor optimization of the alpha-blending code
 * added test container for mmx use
 * fixed MMX usage - required _mm_empty() after each mmx intrinsics use;
   Optimized window title change to not regenerate icon when not in iconic mode

[2007-05-01: sasha]
 * Implemented support for root window having different color depth - blacxk
   background on 16bpp screens should go away; temorarily disabled mmx - it
   seems to ruin images sometimes
 * fixed color printing on 64 bit system
 * replaced mmx code to use gcc intinsics

[2007-04-29: speedy]
 * updated paths for Propaganda images.

[2007-04-27: speedy]
 * added folders in Menu Desktop/Pictures for Propaganda images.

[2007-04-27: sasha]
 * fixed parsing of ARGB icons supplied by applications

[2007-04-26: sasha]
 * fixed stacking order of mozilla dialogs - it creates group member dialog
   that is not a transient, and then it creates a transient, but transient for
   the main window - not the dialog, resulting in this last transient to be
   under first dialog

[2007-04-24: sasha]
 * updated NEW file
 * fixed handling of recursive transients, as is the case with mozilla - it was
   crashing AS and messing up stacking order

[2007-04-23: sasha]
 * updated ChangeLog for 2.2.5 release
 * AfterStep release v. 2.2.5
 * fixed bug in free rectangles list compilation where we failed to remove
   rectangles completely overlapped by the window

[2007-04-20: sasha]
 * implemented proper support for window groups where group leader is an
   unmapped unmanaged window; Added support for window groups to move all
   windows in the group to a proper desktop at the same time; Added support for
   restacking window groups so that when group leader is raised/lowered - all
   the members follow, but not when one of the members does the same
 * implemented support for transient windows to follow the desktop of it's
   parent window
 * implemented proper handling of stacking order for windows with open dialog
   boxes - transients. May exhibit unusual behaviour on clients that abuse
   transients
 * stopped AfterStep from popping up a menu whenever clicked on one of the pan
   frames

[2007-04-19: sasha]
 * fixed Pager when it is started not for the first desk

[2007-04-17: sasha]
 * fixed wharf to properly resize any swallowed window that does not have User
   size set and is not a WMDockApp

[2007-04-13: sasha]
 * fixed AutoRaise for windows that got unshaded; Reduced flickering of shaped
   windows while being resized by adding extra shape rectangles to cover
   affected areas
 * performance optimization by removing triggering of useless ConfigureNotify
   events for frame subwindows
 * fixed handling of ImageMagick's configure requests by adding check for
   window actually being client's main window - it was trying to reconfigure
   it's icon window

[2007-04-12: sasha]
 * Fixed parsing of ShowHints in Wharf
 * Fixed parsing of ShowHints in Wharf
 * problem of windows launched from menu seems to have gone away on its own
 * debugged window move-resizing to properly account for window increment while
   resizing and avoid window jumping

[2007-04-11: sasha]
 * fixed compile bug - missing second arg to focus_aswindow in pager.c

[2007-04-10: sasha]
 * added some intelligence to NoCollideSpacing in WinList - to not have empty
   spaces between edges of the screen and WinList
 * fixed direction of the wharf withdrawing - it withdraws to the closer
   corner. If pressed on right half - to the right, left half - to the left
 * fixed placement bug forcing windows to be no more then phisical screen's
   size
 * fixed AutoRaise functionality to not re-raise the window after it was forced
   into background by clicking on the titlebar

[2007-04-09: sasha]
 * fixed bug crashing WinList when WinListNoCollideSpacing is set. Added
   samples for new options to wharf and winlist configs
 * implemented configurable balloons in Wharf. By default all three - name,
   comment and Exec will be shown

[2007-04-06: sasha]
 * one more fix for database matching order; Unavailable items don't make it
   into Wharf no more; started coding for customizable balloons in wharf

[2007-04-04: sasha]
 * added experimental balloon formating to include both title and the comment
   to Wharf
 * fixed stupid bug introduced while fixing handling of default database style,
   causing thick border and other crap happening

[2007-04-03: sasha]
 * fixed problem reported by born2late where default database style would
   overwrite all other styles
 * fixed problem reported by born2late where default database style would
   overwrite all other styles
 * fixes in database and wharf to get MidnightCommander with vertical title
 * added check to delayed AddWindow to make sure we have not already enlisted
   the window

[2007-04-02: speedy]
 * images looked like viewports, now are desktops.

[2007-04-02: sasha]
 * added delay before MapRequest is handled to give apps some time to finish
   updating their properties
 * fixed the ordering of database Styles to be always in sequence; Fixed code
   for properly overriding flags in subsequent styles

[2007-04-01: speedy]
 * added a menu space for clarity.
 * updated menu Custom WinList, WhaRF, Pager icon setup.

[2007-03-31: speedy]

[2007-03-30: speedy]
 * updated and added icons for Menu custom wharf, winlist, pager.

[2007-03-30: sasha]
 * IMplemented config options for WinList NoCollides, AllowCollides and
   NoCollidesSpacing
 * IMplemented config options for WinList NoCollides, AllowCollides and
   NoCollidesSpacing

[2007-03-29: sasha]
 * Changed WinList to get info about its frame geometry from X, not from AS as
   that is more up-to-date

[2007-03-28: sasha]
 * Fixed support in WinList for South/East gravity, enabling it only after the
   window is mapped

[2007-03-27: sasha]
 * Implemented support for --max-cols/rows in WinList cmdl args; Fixed align of
   the icons when align of the text is not explicitely stated in config and is
   taken for tbar props; Implemented support for East/South gravity in
   collision avoidance in WinList; Added menu to Modules menu to start
   different configurations of WinList

[2007-03-26: sasha]
 * fixed custom Wharf modules menu; Changed configure script to disable
   postcard sending by default and change wording of the privacy notice;
 * fixed geometry string compilation for East and SouthEast gravities to put
   proper sign

[2007-03-19: sasha]
 * added delay before AvoidCover gets enforced to allow apps (WinList ) to
   adjust it's position and size before forcing them into it

[2007-03-16: sasha]
 * added better calculations of minimum size of WinList while avoiding
   collisions

[2007-03-15: sasha]
 * added menu for custom Wharf layouts; fixed segfault when one of the menu
   files is unreadable; fixed deadlock in waiting for winlist

[2007-03-14: sasha]
 * better distribution of sending syntetic ConfigureNotifies
 * better distribution of sending syntetic ConfigureNotifies
 * hopefully fixed WinList collision detection algorithm to disallow using
   rectangloes that are too small
 * fixed handling of --rows and --cols by Pager and Wharf and added a submenu
   to Modules for starting different configurations of Pager
 * put back syntetic configureNotify sending whever we move/resize the window

[2007-03-09: sasha]
 * added handling of border width set through the database for WinList
 * we do not want to map WinList untill we receive the complete list of windows
 * fixed redrawing issue with WinList where canvas size does not change

[2007-03-08: sasha]
 * fixed handling of AvoidCover and SkipWinList windows in WinList's collision
   avoidance code
 * Added support for sticky windows and windows on other viewports, and
   excluded shaded windows from winlist collision algorithm
 * added code to WinList to run away from windows occupying it's space -
   experimental DO NOT USE IN PRODUCTION YET
 * added asgtklookedit to Makefiles

[2007-03-06: sasha]
 * Mystyle editor functionality fleshing out
 * Mystyle editor functionality fleshing out

[2007-03-05: sasha]
 * put some functionality behind mystyle editor design

[2007-03-03: sasha]

[2007-03-02: sasha]
 * mystyle_editor changes
 * Fixed LabelBelowDesk behaviour
 * implemented yet another mystyle editor interface using glade

[2007-03-02: born2late]
 * smaler design improvement #1

[2007-02-27: speedy]
 * added logo-ed icons for image menu folders.
 * added AfterStep_Images/.include.in
 * combined folders to shorten menu.
 * updated configure.in for User_Backgrounds, reverted configure back.
 * added User_Background .include.in for proper build.

[2007-02-27: sasha]
 * Fixed LabelBelowDesk behaviour
 * updated configure to reflect addition of the .include files to start menu
   for Backgrounds

[2007-02-26: speedy]
 * updated paths to include gentoo backgrounds too.
 * created some folder circular logic.  Will add folders back as-needed.
 * updated Pictures submenus for better viewing.
 * added a new icon for chatting and comms.

[2007-02-25: speedy]

[2007-02-24: sasha]

[2007-02-23: speedy]

[2007-02-23: sasha]
 * Fixed LabelBelowDesk behaviour
 * switched background of gtk windows to Base instead of BaseLight as it was
   making text ineligible
 * fixed drawing of root minipixmap in Pager when NoDeskLabel is used and Style
   is not set

[2007-02-22: speedy]
 * added folder icon for "Viewers".
 * Eliminated stella desktop entry; Stella-stable now includes its own.

[2007-02-22: sasha]
 * if we don't reload menu minipixmap - we need to move it over onto new image
   manager
 * added feature to be able to query filetype and only reload menu minipixmap
   if it is ASXML script

[2007-02-22: born2late]
 * last typo correction
 * dialogue almost finished - still need to figure out howto correctly
   hide/display widgets

[2007-02-21: sasha]
 * fixed Wharf so that swallowed apps will obey AlignContents when button is
   smaller then the app
 * fixed AfterStep to obey DisableKDEGlobalsTheming flag in Base config

[2007-02-21: born2late]
 * again an improved version, all switches should be in later today or tomorrow

[2007-02-20: sasha]
 *  added functionality to export ASIUmage into mask MS DIB data, contributed
   by Valeriy Onuchin of the ROOT project
 * implemented fast thumbnailing for SVG images
 * implemented fast thumbnailing for SVG images
 * work in progress

[2007-02-19: born2late]
 * only thing missing : back-(multi)gradient/pixmap interface part - still
   waiting for sasha to comment on it...

[2007-02-16: speedy]
 * updated wiki link to wiki.afterstep.org/
 * put web browsers as last look for winlist icons.

[2007-02-16: sasha]
 * different check for k!=0 added to clip_line()
 * check for k!=0 added to clip_line() and small change for compilation on
   Apple

[2007-02-16: born2late]
 * minor typo - hopefully enough for today :)
 * found that one missing - filled with mail comment from sasha
 * initial commit for design cooperation regarding gui tools with sasha vasko

[2007-02-15: sasha]

[2007-02-14: sasha]
 * implemented fast thumbnails loading for jpeg images; added width/height args
   to the <img> tag; changed all the picture minipixmaps accordingly and got
   rid of redundand .mini jpeg files
 * minor tweaks to desktop change animations for more pleasing effects
 * minor tweaks to desktop change animations for more pleasing effects

[2007-02-13: sasha]
 *  fixed handling of NoIcon in the database file

[2007-02-09: born2late]
 * further doc img updates

[2007-01-19: born2late]
 * updated images for docs... html still to follow

[2007-01-16: sasha]
 * fixed Screen Edge attraction for bottom and Right sides of the screen.
   Thanks Kobaz.

[2007-01-11: sasha]

[2007-01-06: sasha]

[2007-01-05: sasha]

[2007-01-04: born2late]
 * more actual screenshot of afterstep, lots to fix in docs to make it
   usefull...

[2007-01-03: sasha]

[2006-12-30: sasha]

[2006-12-29: born2late]
 * added a more functional version of ascp gtk branch... waiting for sasha s
   comments as usual

[2006-12-18: sasha]
 * completed implementation of DesktopEntry AfterStep builtin - to be used
   primarily in Wharf

[2006-12-12: sasha]
 * added ability to Ident to spill the data into stdout
 * Completed implementation of support for DesktopEntry in Wharf - it uses
   localized comments and Names now

[2006-12-08: sasha]
 * completed implementing CategoryTree in Wharf - TODO : implement proper
   localized titles and comments

[2006-12-02: sasha]

[2006-12-01: sasha]
 * preliminary implementation of Category keyword  in Wharf - to include whole
   Desktop Category of items; added ability to adjust number of rows/columns if
   there are too many buttons in Wharf folder
 * Wharf changes to support Category as a button function

[2006-11-27: sasha]
 * fixed Move function handling to always move relative to desktop origin -
   taking into consideration window's current viewport if its not sticky

[2006-11-24: speedy]
 * added IndexName to legacy entries to show WinList items, database updates.

[2006-11-23: sasha]

[2006-11-21: speedy]
 * added database entries for terminal-based app icons, new Pulse icon.

[2006-11-21: sasha]
 * tuned algorithm for choosing icon for a client window to try and match
   window's name to desktop entry prior to deciding to use database entry

[2006-11-20: speedy]
 * eliminated legacy xmms entry. Most distros include an xmms .desktop entry.

[2006-11-18: sasha]

[2006-11-17: sasha]
 * fixed segfault when LANG is not set
 * Updated ChangeLog for 2.2.4 release
 * AfterStep release v 2.2.4
 * minor development in ASLookEditor

[2006-11-16: sasha]
 * began implementation of look editor widget - for editing looks of course

[2006-11-15: sasha]
 * fixed segmentation fault in ASWallpaper - widget destractor may be called
   twice so all freed pointers should be reset to NULL

[2006-11-14: speedy]

[2006-11-13: sasha]
 * Fixed icons handling in modules - desktop entries where not saved propely,
   missing an EOL in some fields
 * fix3ed segfaults in winlist menu and modules menu, and added support for
   comments in modules menus

[2006-11-10: speedy]
 * added Simulation Game icon.

[2006-11-10: sasha]

[2006-11-09: sasha]
 * removed empty balloons poping up for menus with no comments
 * fixed segfault on opening of dynamic menus such as winlist and module list
 * fixed clamping code in hsv conversion of greyscale colors

[2006-11-08: speedy]
 * Changed "Destop" Menu Folder to "Desktop Setup", added locales to "Desktop"

[2006-11-08: sasha]
 * hopefully fixed wierd empty balloons poping up for menu
 * finished up SVG support implementation

[2006-11-07: speedy]
 * returned Destop and Windows menu folders to original names.

[2006-11-07: sasha]
 * preliminary implementation of svg support in libAI using librsvg - may need
   some cleaning up to be done
 * added check for librsvg to configure in preparation for support for SVG
   image format

[2006-11-05: speedy]
 * added more localizations.
 * additional game icons.
 * added locale comments to entries.

[2006-11-04: speedy]
 * added internationalization support to menu entries.

[2006-11-03: speedy]
 * added some icons for games.
 * fixed typo with Desktop Windows dir.
 * changed configure to reflect start/0_run rename to start/3_run.
 * changed .include files to use standard_categories.
 * updated .include files to use entries in standard_categories.
 * changed folder order through renaming.
 * changed order by renaming.
 * added directory entries for AS desktop stuff.
 * added subcategories to the included .desktop game entries.
 * added a pair of dice for games icons.

[2006-11-03: sasha]
 * fixed segfault when locale is not set and added special case handling to hsv
   transformation to only adjust value on greyscale pixels
 * fixed segfault when locale is not set and added special case handling to hsv
   transformation to only adjust value on greyscale pixels

[2006-11-02: sasha]
 * implemented better support for CategoryTree in .include so that items
   available in subcategories do not show up in the top level category
 * implemented better support for CategoryTree in .include so that items
   available in subcategories do not show up in the top level category

[2006-10-31: sasha]
 * implemented balloons for menu items

[2006-10-31: born2late]
 * of course dyslexia is with me
 * added doc for value 5 to turn winlist text off, still need to know what 4 is
   used for

[2006-10-28: sasha]

[2006-10-27: sasha]
 * added translations and comments to many standard settings
 * implemented FolderReference keyword in .include file allowing to get
   submenu's name, comments and icon from specified .dektop entry, including
   localized name and comment

[2006-10-26: sasha]
 *  got to the point where AS menu actually displays localized names for menu
   items from .desktop - will keep on working

[2006-10-25: sasha]
 * added code to support UTF8 in menu items and comments (using .desktop
   entries)

[2006-10-20: sasha]
 * added support for boolean values being set as =1  in .desktop files
 * added support for Hidden and NoDisplay flags in .desktop files

[2006-10-19: sasha]
 * fixed memory leaks in libAI on image slicing

[2006-10-18: sasha]
 * fixed name conflict of the System category and System categories tree -
   causing trouble for non kde and non-GNOME items

[2006-10-13: sasha]
 * added definitions for xinerama rectangles if available
   xroot.xinerama_screens_num, xroot.xinerama_screens[0].x etc.

[2006-10-12: sasha]
 * fixed floating point exception gets thrown by libAI upon having to scale
   image up more then 255 times its height
 * Added look.Smooth and fixed segfault happening when MyStyle image needs to
   be semitransparent, flipped and scaled all at the same time

[2006-10-11: vae]
 * ChangeLog revisions for 2.2.3
 * AfterStep release v 2.2.3

[2006-10-10: sasha]
 * Fixed libAI to fail when subimage does not exist in the image file -
   otherwise there is no way to determine how many images are there
 * added support for reading and saving animation repeat counts in gif images

[2006-10-09: speedy]
 * added entries for Wharf systrays.

[2006-10-06: sasha]
 * fixed some desktop entries being lost while category trees are being merget
   together. Should reuse same hash value everytime
 * fixed ordering of the menu data structure so that magic number now comes
   first, as it supposed to - It was breaking menu pinning and some other
   things

[2006-10-04: speedy]
 * added Scavenger game.

[2006-10-03: speedy]
 * added a KDE folder for menus.
 * added correct name for KDE folder
 * commented-out MiniPixmapSize. Icons in certain menus were too large.

[2006-10-03: sasha]
 * added redundand logic to force desktop entries into hierarchy even if there
   is a name clash - using either generic name or comments or a generated name

[2006-10-02: speedy]
 * added additional menu folder options (Yellow, OpenBlue, OpenRed).
 * added some additional Mini folders to enhance menus.
 * cleaned-up the formatting for better alignment.
 * cleaned-up formatting for better alignment.
 * cleaned-up formatting for better visual alignment.
 * added a space between module functions and modules for clarity.
 * added menu tooltip Comments.
 * added menu tooltip Comments.
 * added menu tooltip Comments.
 * added menu tooltip comments.

[2006-10-02: sasha]
 * updated NEW and Changelogs
 * fixed unavailable items from desktop entries being shown as available in
   menus

[2006-09-29: sasha]
 * removed # StartsOnDesk comments from some lines - no inline comments for
   database
 * fixed geometry string formatting for workstation state saving for windows
   with south and east gravities; added south/east values to geometry display
   while dragging

[2006-09-28: sasha]
 * fixed balloons not being withdrawn upon LeaveNotify events in AS proper
 * completed debugging menu tips/comments. See
   start/Desktop/MenuOptions/.include for example

[2006-09-27: sasha]
 * implemented tips for menu - needs some work  for formating options and not
   reshowing it excessively

[2006-09-26: sasha]
 * debugged balloons config parsing by AS proper - added test container to AS
   makefile

[2006-09-25: sasha]
 * work in progress - adding libAfterConf support to afterstep proper

[2006-09-21: sasha]
 * pile of changes to infrastructure in preparation to menu tips implementation

[2006-09-21: madarche]
 * M.-A. DARCHE : - Added support for wmload, yet another loadmonitor, in the
   MonitorWharf.

[2006-09-20: speedy]
 * updated Ghost icon to Ghost2.
 * added new Ghost2 icon for clarity.
 * changed ghost icon to display better.

[2006-09-20: sasha]
 * fixed titles of submenus generated from Popup spec in file
 * added the ability to have several kind of balloons per app

[2006-09-19: sasha]
 * finished debugging recent submenu items adjustability on the fly as well as
   debugging of Popup in a file

[2006-09-18: sasha]
 * added functionality to allow for specifying entire popups in menu entry
   files

[2006-09-15: speedy]
 * added Lightswitch icon to toggle menu items.
 * added Lightswitch icon image.

[2006-09-15: sasha]
 * added ability to change number of recent submenu selections at runtime -
   need to add corresponding menu items
 * changed Menu Options to be able to simply togle them on/off; Added ability
   to parse_math to use logical Not on variables and have - sign in front of
   the variable
 * fixed infinite loop under win32 in import.c

[2006-09-14: speedy]

[2006-09-14: sasha]
 * added aditional menu options to those selectable from the menu
 * added aditional menu options to those selectable from the menu

[2006-09-13: sasha]
 * fixed reading and writing animation delay in gif images

[2006-09-12: speedy]
 * changed unicode editor icon, unicode term icons, added mlterm.
 * added Unicode icon, Unicode editor xml icon.

[2006-09-12: sasha]
 * added submenu to Desktop to be able to toggle some menu options off/on
 * fixed compile bug in ASRun

[2006-09-11: sasha]
 * added ability to obtain animation delay when reading gif images
 * fixed ASRun to create dirs for config file if needed

[2006-09-07: sasha]
 * improved look.Tiny to use tbar buttons contrast with focused titlebar
 * improved look.Tiny to use tbar buttons contrast with focused titlebar
 * fixed extra = in check for shared images under cygwin
 * implemented feature to be able to suppress text labels in WinList
 * inserted minipixmap folder themability into all of the looks
 * Fixed all folder icons to use proper srcid param instead of wrongfull refid

[2006-09-05: speedy]
 * changed menu item order, putting start and stop tools on top.

[2006-09-03: speedy]

[2006-09-02: speedy]
 * smoothed icons.  Should look better visually.
 * smoothed the icons a bit.  A bit better visually.
 * eliminated .xpm extension for TouchLeftHand icon.
 * renamed to leave-off the .xpm extension.
 * changed Xterm icon to Xorg logo.
 * changed Xorg logo.
 * updated Xorg logo for a cleaner look.
 * rounded corners on Eterm icon, added cleaner Xorg logo.

[2006-09-01: speedy]
 * xml script referenced "Brushes" instead of "Cardgames".
 * added AquaBlue default, added script to scale... icons were full-size.
 * added a variable mini folder to keep the same look as other menu folders.
 * added variable folder to be in line with other menu icons.
 * added a variable to be in line with other menu folders.
 * added a generic xml icon folder to align with the rest.
 * fixed a typo (reacll to recall).
 * renamed xml icons for variable folders.
 * renamed xml icons for variable names.
 * renamed xml icons for variable folder naming.
 * changed xml icon names for variable folders.

[2006-09-01: sasha]
 * implementing themability of the folder icons in menus

[2006-08-30: sasha]
 * changed XML variables from strings to defines
 * changed XML variables from strings to defines

[2006-08-29: sasha]
 * added function Set to AfterStep functions to be able to change value of xml
   vars; added default_src param to <recall> tag to be able to fall back on
   something if none of the sourceid's is available

[2006-08-28: sasha]
 * added example to if tag docs
 * added <then><else> and <unless> tags handling

[2006-08-24: sasha]
 * fixed GIF graphics control extention's size to be 4 bytes - that was messing
   up dumb MS Photo Editor
 * updated libAfterImage.mak to reflect changes in libungif
 * removed includes for stdint.h

[2006-08-18: sasha]
 * added <if> asxml tag to conditionally execute stuff
 * added <set> tag to asxml to be able to set variables to evaluated
   expressions in xml scripts
 * implemented ability for WinList to use Defaults section in its config and
   read look/feel items from the look/feel files

[2006-08-16: sasha]
 * added LZ compression to builtin libungif, as patent is expired already

[2006-08-15: speedy]

[2006-08-14: speedy]
 * added mini FolderAqua for Picture menus
 * added height to be scaled.  Image was screwed in menu.
 * added icons to folder menus.
 * smallminipixmaps screws-up spacing. revert to "minis".
 * Updated folder icons.
 * Forms not currently used.  Removing from menus.
 * No longer in use.  Remove from menus.
 * not currently working.  Remove from menus.
 * not currently working.
 * added .desktop entry for games, updated xtools.desktop description.

[2006-08-14: sasha]
 * fixed ascmap.c to not leak memory in SortedColorHash buckets

[2006-08-13: speedy]

[2006-08-12: speedy]
 * removed. Images weren't clear when scaled.
 * added clearer locked and unlocked icons with folders.
 * added clearer looking locks to folders.
 * added more scalable lock icons for folders.
 * updated .include. Copied wrong file.
 * forgot a couple of commas.
 * added additional browsers for compatibility.
 * removed static entries for .desktop, added Category AfterStepXMouseTools.
 * removed static entries for .desktop entries, added Category AfterStepXTools.
 * added Category for AfterStepInfo.
 * removing static entries, replacing with .desktop entries.
 * added a left-hand mirror of normal/Touch.
 * added xtools.desktop and aboutinfo.desktop menu entries.

[2006-08-11: speedy]
 * restarttwm and restartwm not needed.
 * Exit form request not working.  Removed.

[2006-08-10: speedy]
 * changed WWW icon to Info.  Too many WWW icons look bad.
 * added FolderAqua icon to WinList.
 * About AfterStep menu items now point to links correctly.
 * removing old About AfterSTep entries.
 * removed .png extension.
 * remove the .png extension.
 * changed browser order, should be a bit more methodical.

[2006-08-09: speedy]
 * added new icons for desktop config files.
 * updated icons for starting and stopping modules.
 * added icons for Starting and Stopping modules.
 * typo. wrong directory for icon (large, not normal).
 * added icons for X utils.
 * added icons for X Utils Menu.

[2006-08-08: speedy]
 * added icon for wintabs.
 * added AquaFolder for Arrange, changed fullscreen icon to match re-size.
 * added folders for Forms and Scripts.
 * added folder icon for Stop folder.
 * added folder icons for locked and unlock screensavers.

[2006-08-08: sasha]
 * implemented changes to automate config parsing for modules and also
   implementing support for parsing module options from look and feel - only
   WinList does that for now.

[2006-08-07: speedy]
 * too many capital letters.  These really aren't titles.
 * updated icons for Quit menu.
 * cleaned-up and removed old order convention.
 * added Category for "AfterStepDesktop".
 * updating to .desktop menus.
 * added .desktop entries for Desktop menu.
 * added TuxXmas (for xsnow) and Camera4 icons.
 * added open and closed lock folders.
 * updated pulldown gadgets (move, resize, etc.)
 * added new folder for pallette.
 * ColorScheme Icon looks bad over folder.  Switch to Pallette.
 * ColorScheme icon looks bad on top of folder icon.  Switch to Pallete.
 * replacements for bad setup icons.
 * icon setup doesn't work. removed.
 * updated X logo with some transparency.
 * XWindow icon covers too much area.  Adding updated X logo.
 * MonaLisa icon covers too much.  Switching to Mona.
 * EyeInMonitor2 too big.  Switching to View-based folder.
 * typo. GNOME, not GNONE.
 * removed unneeded file.
 * removed .png extension from name.
 * removed .png extension.
 * updated Desktop folder menus.
 * added new folder icons for Desktop.
 * smaller GNOME icon and new Touch icon.
 * get rid of plain Document icon and replace with snazzy Pen1.
 * Let's use the XV icon included in AS.
 * Typo in file. MoonInMonitor vs. MonitorInMoon.
 * Typos in icon names.
 * updated aterm icon to 48x48 to fit in menus better.
 * Typo. Icon names should read FolderAqua rather than AquaFolder.
 * Typo. icons should start with FolderAqua rather than AquaFolder.

[2006-08-04: speedy]
 * added System Settings folder for Settings and SystemSetup Categories.
 * removed Development, Settings, SystemSetup Categories.
 * new folder for Development software.
 * added paths for system and gnome icons.
 * added additional categories Settings, Development, SystemSetup.
 * odd behavior. Default to Folder name rather than assign name.
 * cleanup menus.
 * removed static menu items for .desktop entries.
 * added .desktop entries for office and Educational Categories.
 * added TryExec for freedesktop compliance.
 * removing static menu items for .desktop entries.
 * removing static menu items for .desktop entries.
 * removed static menu items for .desktop entries.
 * removed static menus for .desktop entries.
 * removed static menus, replacing with .desktop
 * setting dirs for desktop files

[2006-08-03: sasha]
 * fixed handling of TryExec and CheckAvailability in .desktop files
 * fixed handling of TryExec and CheckAvailability in .desktop files

[2006-07-27: sasha]
 * typo in definition of ExcludeGNOMe causing GNOMe entries to be dropped

[2006-07-21: madarche]
 * M.-A. DARCHE : * Added latest Thunderbird configuration in wharf * Specified
   specific Thunderbird logo in wharf * Made Thunderbird be used first before
   Mozilla (just like it is done for   Firefox and Mozilla)

[2006-07-20: madarche]
 * M.-A. DARCHE :

[2006-07-18: sasha]
 * added defaults syntax to WinList config
 * added warning for bad color names
 * fixed handling of the text rendering where first character has a large
   negative lead, such as 'j'

[2006-07-16: madarche]
 * M.-A. DARCHE:

[2006-07-07: sasha]
 * minor changes to config parsing code

[2006-06-26: sasha]
 * backrolled one of the incorrect fixes for firefox - sending syntetic
   configure notifies, as it was breaking override redirect window placement by
   the apps

[2006-06-16: sasha]
 * Fixed problem with Java windows getting remapped when they are being
   withdrawn. Java tends to change its hints just before unmapping window
   causing AS to do XMapSubwindows on entire frame - which would in turn remap
   client , while it was just unmapped by java. Bunch of idiots

[2006-06-12: sasha]
 * added Style to database to resolve issues with Open Office assigning Dialog
   type to its windows in random order

[2006-06-08: sasha]
 * fixed handling of the focus for globally active input model - java apps
   should work fine now

[2006-06-07: sasha]
 * implemented *WharfStretchBackground flag to wharf config - upon which
   wharf's background is rendered similarly to menu when
   TextureMenuItemsSeparately is not set
 * Fixed handling of Configure Request to allow size change even if
   IgnoreConfigureREquests is sset in database, otherwise it was breaking GTK
   apps (firefox notably) due to the fact that they don't check if resize
   request had indeed been honored by WM
 * hopefully fixed messed up wharf subfolders on look and colorscheme change
   (reported by born2late)

[2006-06-06: sasha]
 * Implemented support for TextureMenuItemsIndividualy 0 - which is same
   background for all menu items

[2006-06-05: sasha]
 * implemented rendering of menus without every item being done individually

[2006-06-02: sasha]
 * Implemented new option for MyStyle - Overlay <type> <"other_mystyle">

[2006-06-01: sasha]
 * added more syntetic configureNotifies sends to hopefully fix problems with
   window size/position

[2006-05-31: sasha]
 * disabled gtk color mangling by default

[2006-05-30: sasha]
 * manually applyed patch from CaT to disable gtkrc mangling by default

[2006-05-23: sasha]
 * fixed Changelog generation script and updated ChangeLogs for the release
 * AfterStep release v 2.2.2

[2006-05-18: sasha]
 * fixed look.QNX - still gives wierd effect in vertical tbars thgough

[2006-05-17: sasha]
 * implemented automatic image reloading on colorscheme change in Wharf

[2006-05-15: sasha]
 * fixed columns and rows being resized to negative values in render_astbar
 * made libAI tolerable to negative size for image transformation functions -
   not to crash

[2006-05-12: sasha]
 * fixed gigantic memory leak causing background images to get lost on desktop
   change

[2006-05-11: born2late]
 * found a bug in description - removed

[2006-05-05: sasha]
 * fixed bunch of memory leaks, still need to figure out why desktop
   backgrounds don't get freed

[2006-05-04: sasha]
 * fixed memory leaks in xml image parsing, wm_wprotocols debugging code, menu
   minipixmaps, hints and several other places

[2006-05-02: sasha]
 * fixed handling of tbar_props in order to re-read them only on change of that
   specific property
 * fixed handling of tbar_props in order to re-read them only on change of that
   specific property

[2006-04-28: sasha]
 * added look.Abi contributed by Carl Bolduc (DrCurl)
 * added look.Abi icons

[2006-04-27: born2late]

[2006-04-25: born2late]
 * added vae as dev.

[2006-04-21: sasha]
 * fixed erroneous pixmap destruction by modules for tbar props; memory leaks
   in WinTabs; shaped MyStyles for WinTabs tabs; UrgencyHint cleared handling
   when there is no Extended WM state

[2006-04-19: sasha]
 * done debugging Wharf memory leaks
 * fixing Wharf's memory leaks - need to get Folders syntax to deallocate
 * fixed all the memory leaks in Pager
 * Fixed deallocation of the MyLook in modules - required setting magic number
   on MyLook structure of ASDefaultScr
 * fixed handling of UrgencyHint setting on non-new window

[2006-04-18: sasha]
 * debugging memory leaks - some small ones are found if desktop-entry code
 * debugging memory leaks - some small ones are found if desktop-entry code

[2006-04-17: sasha]
 * completed implementation of the urgent window handling in WinList

[2006-04-14: sasha]
 * mostly done implementing support for urgent windows in WinList - need to add
   blinking now

[2006-04-12: sasha]
 * added support for more hints in Ident and implemented proper handling of
   transient windows abusing USPosition

[2006-04-06: sasha]
 * further drvelopment of urgency handling as well as fixes for previously
   introduced bugs

[2006-04-05: sasha]
 * added ability to autoformat text inserting line breaks in order to fit it
   into certain width
 * added state flags and some hints for urgency handling

[2006-04-04: sasha]
 * adding BACK_URGENT as a possible MyStyle

[2006-04-03: sasha]
 * fixed handling of SkipPager/SkipTaskbar hints where two atoms had same value
 * changed version on default wallpaper

[2006-04-01: sasha]

[2006-03-31: sasha]
 * debugging disappearing Extwm state flags
 * rearranging Desktop menu
 * added installation into alternatives list, added Games menu under
   Applications

[2006-03-29: sasha]
 * disabled Parser debugging

[2006-03-28: sasha]
 * implemented nicer timestamping of the debug traces
 * fixing loggin timestamps
 * fixed WinTabs and Ident coming up in a wierd state

[2006-03-24: sasha]
 * cirtain fixes to bugs reported on ML

[2006-03-23: sasha]
 * implemented filtering of BackgroundForeign backgrounds to include only whats
   supported

[2006-03-22: allanon]
 * Fixed bug causing png compression to always be zero for
   save_asimage_to_file().

[2006-03-21: allanon]
 * Added more features to AfterImage. Created AfterImage::Font to support font
   loading and text drawing.
 * Added scale().
 * Added the beginnings of an AfterImage drawing class.

[2006-03-20: sasha]
 * implemented OrthogonalFolderOffset just for born2late

[2006-03-16: sasha]

[2006-03-16: allanon]
 * Added test script. To use: perl test.pl Added image_composite().
 * Implemented a couple more glue functions for libAI.

[2006-03-15: allanon]
 * Initial checkin of afterimage module. It doesn't do much yet.
 * Fix compilation on systems without X installed.

[2006-03-11: sasha]

[2006-03-10: sasha]
 * fixed potential segfault on no decorations + messed up modules due to recent
   changes in ExtWM hints
 * implemented support for Window Opacity when x composite manager is available
   (xorg servers)

[2006-03-09: sasha]
 * debugged handling of database style options in Wait function

[2006-03-07: vae]
 * ChangeLog commit for 2.2.1

[2006-03-07: sasha]
 * upped version number to 2.2.1

[2006-03-06: sasha]
 * hopefully fixed inconsistency where *MyName Keyword would match wrong
   keyword on named items
 * improved colorization of gtk-2.0

[2006-03-04: sasha]

[2006-03-03: sasha]
 * fixed segfault when icon title uses same canvas as icon and it gets destroed
 * developed test tool for debugging icon_canvas destruction while window
   remains. Happen On PropertyNotify with FollowTitleChanges allowed
 * fixed icon not being set when app requests an icon in ext WM hints
 * debugging sigsegv in icon canvas
 * fixed doublequotes finding function to return NULL properly
 * fixed usage of .debug member of ptabs to be used only when link.h is
   available

[2006-03-03: born2late]

[2006-03-01: sasha]

[2006-02-28: sasha]
 * fixed performance problems related to dead windows PropertyNotifiyes and
   Title changes for regular windows
 * added check for validity of the text (no negative size)
 * hopefully improved performance on titlebar changes
 *  minor fixes to hints manager handling of windiow names + disabled
   colorscheming of KDE and GNOMe apps
 *  minor fixes to hints manager handling of windiow names + disabled
   colorscheming of KDE and GNOMe apps

[2006-02-27: sasha]
 * maybe fixed names refresh

[2006-02-23: sasha]

[2006-02-22: sasha]
 * some development in ascp related functionality
 * fixes indefinate Wait - should be limited to 10 seconds

[2006-02-20: sasha]
 * began implementing interface for config options as xml_tree convinient for
   config panel

[2006-02-15: sasha]
 * fixed all the errors reported by propriatery source analyser
 * fixed handling of some feel flags
 * fixed handling of UTF8 strings in serialization code - it was messing up
   with signs

[2006-02-13: sasha]
 * minor cleanups
 * made ExtWM names take precedence over ICCCM names
 * made ExtWM names take precedence over ICCCM names
 * minor fixes to hopefully get AS not to segfault on name changes in gaim

[2006-01-26: sasha]
 * fixed Pager changing its geometry on colorscheme changes

[2006-01-25: sasha]

[2006-01-23: sasha]
 * Implemented proper printing of free storage - it looks like the config that
   was parsed. Everything should work now

[2006-01-20: sasha]
 * implemented handling of foreign options while parsing into xml

[2006-01-19: sasha]
 * added ability to load comments from config files into xml parser. wharf
   config now gets parsed properly - need to implement writer

[2006-01-18: sasha]
 * rewrote parsing and token functions to use consistent approach to quotes
   handling - may break some stuff
 * fixed dos format for parser_xml

[2006-01-14: sasha]

[2006-01-12: sasha]
 * added missing parser driver files

[2006-01-11: sasha]
 * split storage dependant portion of the parser
 * split storage dependant portion of the parser

[2006-01-10: sasha]
 * started writing code for reading AS config as tree of xml elems
 * changed titlebar props setting to use different values for NoBevel and
   NoAlign being set and for when those values are unset altogether

[2006-01-10: born2late]
 * added myself and sasha to credits of icons

[2006-01-09: vae]
 * ChangeLog

[2006-01-09: sasha]
 * addind docs
 * fixed focus wharf tile not getting focused when button is odd
 * updated NEW file
 * new docs
 * added docs to new baloon options for WinTabs
 * added docs for new WinList options
 * added docs for new Wharf options
 * added new balloon options docs
 * added new database options
 * addednew functions docs

[2006-01-06: sasha]
 * fixed menu pin button showing up in regular windows
 * fixed broken names in merge-extwm_hints
 * added kde and gtk rc templates to Config Files menu
 * got rid of ald animations using xlock - were just clattering the menu
 * Redid Screensaver menu to use xscreensaver. KDE screensavers are crap - have
   to implement some wierd api prolly to be able to use them

[2006-01-05: sasha]
 * added submenu to Desktop for opening different config files in editor; Added
   functionality to ASRun to autoupdate menu when new feel or look is added
 * added submenu to Desktop for opening different config files in editor; Added
   functionality to ASRun to autoupdate menu when new feel or look is added
 * implemented ability in ASRun to open AS config files checking presence and
   copying from shared location if needed
 * implemented ability in ASRun to open a ile in editor and kde screensaver in
   fullscreen window

[2006-01-05: fabs]
 * fixed some memory-leaks playing around with valgrind.

[2006-01-04: sasha]
 * disalowed maximizing of fullscreen windows

[2006-01-04: fabs]
 * Rewrote Arrange to use libAfterStep/ascommand.h and added lots of features
   to libAfterStep/ascommand(.c/.h).

[2006-01-03: sasha]
 * fixed gtkrc template processing
 * fixed segfault when focused MyStyle is undefined
 * hopefully fixed suupport for UTF8 titles when built with --enable-i18n - no
   need to translate ExtWM names, as those are already in UTF8
 * fixed bug in handling of length of UTF8 text while determining the text size
   - should translate length in chars into byte length

[2005-12-30: sasha]
 * implemented *WharfOddTile mystyles to allow for having every other tile in
   Wharf have different style

[2005-12-30: born2late]

[2005-12-29: sasha]
 * fixed availability check
 * adde ExecBrowser ExecEditor commands as well as Base file settings for gtkrc
   destination and disabling of kdeglobals mangling
 * done debugging Fullscreen mode

[2005-12-28: sasha]
 * debugged Fullscreen to work, although toggling state don't work well
 * implemented support for fullscreen windows (experimental) - needs debugging
 * gnome-panel placement; need to implement support for full screen windows
 * menu entries addedd

[2005-12-27: sasha]
 * added some stuff to menu
 * made ASRun not dependant on GTK, added icons for KDE and GNOME search tools;
   added proper availability checvk for desktop entries requesting it
 * added search menu to provide shortcuts for file/web searching utilities

[2005-12-24: sasha]

[2005-12-23: sasha]
 * added ability to ASRun to recognize URLs and launch browser for those
 * added Start menu command for ASRun
 * implemented small applet to run arbitrary command
 * making up menu structure
 * making up menu structure

[2005-12-22: sasha]
 * fixed handling of submenu items with bigger icons , not to disrupt the size
   of items in parent menu; Fixed some layout issues in astbar rendering
   causing cells being bigger then tbar
 * changed Editors menu to use .desktop files
 * added new icons for VIM, NEdit and emacs

[2005-12-21: sasha]
 * some additions to backgrounds selection curtesy of ShadowGod
 * changed color in kcsrc to grayeish

[2005-12-20: sasha]

[2005-12-19: sasha]
 * make KIPC message go to all top-level windows. Hopefully fixed segfault on
   colorscheme change
 * made KDE update on colorscheme change
 * getting a destroyed MyStyle when colorscheme is changed

[2005-12-17: sasha]

[2005-12-16: sasha]
 * adding missing xml.*
 * implemented KDE config files manipulation using xml structures; moved xml
   parsing into libAfterBase

[2005-12-15: sasha]
 * implemented support for some KDE hints and signaling KDE apps to update
 * messing around with KDE support

[2005-12-14: sasha]
 * implemented kcsrc template handling
 * changed ratio for foreign background clipping

[2005-12-14: born2late]

[2005-12-13: sasha]
 * added kcsrc_template for KDE colors theming
 * Made GTKRC update signaling automagic on colorscheme or look changes
 * rewrote Makefiles abit to make output more readable. Upgraded version to
   2.2.0

[2005-12-12: sasha]
 * implemented new built-in function: BackgroundForeign that auto scales
   background images into minipixmaps and possibly resizes them to better fit
   the screen

[2005-12-10: sasha]

[2005-12-09: sasha]
 * fixed gnome-2.0_template to exclude questionable light colors
 * fixed KDEDIR and GNOMEDIR when missing to resort to defaults
 * added submenu to Pictures menu for KDE wallpapers
 * added KDE logo icon
 * made AS generate 2 gtkrc files for 1.x and 2.x and place them directly into
   ~/ dir, so that refresh functionality works - it seems that stupid GTK don't
   reread rc files unless its timestamp changed, and furthermore it don't
   checks symlinked or included file's timestamp. Dumb.
 * FIXED GTKRC _TEMPLATE TO WORK WITH GTK

[2005-12-08: sasha]
 * debugging GTK rc file reloading
 * added built-in function SignalReloadGTKRCFile to send signal to gtk apps to
   refresh rc
 * added built-in function SignalReloadGTKRCFile to send signal to gtk apps to
   refresh rc
 * added built-in function SignalReloadGTKRCFile to send signal to gtk apps to
   refresh rc

[2005-12-07: sasha]
 * hopefully fixed root selection buttons size in ASFileBrowser
 * fixed WorkspaceSaving for term windows to include name - helps with TermTabs
   being present, but may cause problems if window name changes while AS is
   down
 * some debugging of ASFileBrowser and addition of the XML view
 * fixed Makefile to properly test for old installation being available

[2005-12-06: sasha]
 * fixed workspace saving code to properly escape wildcards and other crap in
   command line args with quotes
 * added icons to stop/start modules menu and made icons in Winlist menu scale
   down

[2005-12-06: born2late]
 * thanks to speedy0 for the idea to add some instructions to each module, this
   is the first example, others to follow.

[2005-12-05: sasha]
 * updated Pager's icon

[2005-12-04: born2late]
 * addition to start menu changes
 * addition to start menu changes

[2005-12-02: sasha]
 * implemented proper checks for readline lib and added linkage params to
   WinCommand
 * fixed typo in Makefile creating /usr/bin/mkdir for no reason
 * fixed typo in Makefile creating /usr/bin/mkdir for no reason
 * added icons for some modules
 * addition to better check for share image directories
 * addition to better check for share image directories

[2005-12-01: sasha]
 * added ability to run apps belonging to some desktop category as a complex
   function. Added KillAllModulesByName to be able to stop all modules. Added
   usefull menu items to startmenu to use the above

[2005-11-30: sasha]
 * added new function called Category to execute all entries from certain
   desktop category in batch process
 * Fixed several deps in libAfterImage which were failing to compile without
   libAfterBase

[2005-11-29: sasha]
 * upgrading WinCommand to allow for interactive mode
 * split install target for afterstep config files into several smaller
   targets: install.data for images and fonts, install.config  and install.menu
 * implemented better handling of the <text> tag  - with honoring of the alpha
   component of the fgcolor

[2005-11-23: sasha]
 * upodated configure to set desktop number in modules.desktop.in
 * upodated configure to set desktop number in modules.desktop.in
 * changed start/Modules to use modules list loaded from .desktop file

[2005-11-22: sasha]

[2005-11-16: sasha]
 * added .desktop file for AfterStep modules - need to figure out icons and
   make it actually load on startup
 * changed clipping attr in scale tag to src_ to avod collision with
   <composite> tag attributes
 * implemented slicing with scaling in MyStyles as well. Added stuff to decor.c
   to do slicing of the tbar images

[2005-11-15: sasha]
 * fixed SIGFPE in scale_asimage2 on clip_width and clip_height being 0

[2005-11-14: sasha]
 * added clip_x, clip_y, clip_width and clip_height to scale tag
 * added ability to scale the middle of the sliced image - use scale=1 in the
   slice tag - still need to add this to MyStyles

[2005-11-11: sasha]
 * fixed segfault in ASGTKxml viewer/editor due to wrong parent class

[2005-11-09: sasha]
 * some changes to XML editor to allow incorporating it into other widgets
 * Added TitleBalloonTextPaddingX / Y and BalloonTextPaddingX / Y options to
   leave space between balloon edge and the text. Added code to determine
   minipixmap size based on display DPI

[2005-11-07: sasha]
 * Added FolderOffset option to Wharf config to specify distance at which new
   subfolder will be open from the edge of the parent

[2005-11-04: sasha]
 * more file browser stuff
 * more file browser stuff

[2005-11-01: sasha]
 * implemented faster dir scanning for image list; added time and size to be
   displayed on file list; added 3 new members to TermDef data struicture for
   future simplier config parsing

[2005-10-31: sasha]
 * added ability to load all files in ASGTKImageDir as well as have details
   columns

[2005-10-26: sasha]
 * added some functionality to ASFileBrowser - its actually usable now

[2005-10-25: sasha]
 * added ASGtkDirTree widget to libASGTK

[2005-10-25: born2late]

[2005-10-24: sasha]
 * fixed bug where with turned off balloons mouse clicks would get lost as
   subwindow is reported as  0

[2005-10-21: sasha]
 * completed adding controls to the root selection frame of the file browser

[2005-10-20: sasha]
 * ASFileBrowser made root selection buttons part of a group
 * hopefully resolved root menu poping up on clicks on balloon window's

[2005-10-19: sasha]
 * ASFileBrowser stuff
 * compile bugs
 * changed visualselect4html to unziped format so we don't have to use binary
   storage in CVS for it
 * added prototype of the ASFileBrowser tool to be used to view AfterStep
   images and stuff
 * fixed doc_html target to not spill lots of tar messages

[2005-10-18: sasha]
 * changed TTF font renderer to use advance.x attribute of the glyph as the
   step instead of old way of width + bitmap_left
 * added support for a GTK clear_look engine in gtkrc_template
 * implemented horizontal font kerning support for TTF fonts. Most font's don't
   have that info in them though

[2005-10-17: born2late]
 * added images files for visualselect (html part only of docs)
 * tar.gz without images
 * make sure visualselect4html graphic files are also copied

[2005-10-12: born2late]
 * now visualselect is also in html docs.

[2005-10-05: sasha]
 * fixed potential segfault in gradient parsing where number of offsets is
   greater the colors
 * Implemented saving of the list of running modules upon shutdown, so that
   modules will start on exact same location as they were at the time of
   shutdown, as well, as to keep the number of running modules. See autoexec
   file for comments.

[2005-09-29: sasha]
 * Fixed wierd shaping artifacts in triangular wharf items with xeyes in
   particular

[2005-09-28: sasha]
 * put icon on foreground in all cases
 * changed text in banner to not have a minor version in it
 * implemented support for icons in winlist

[2005-09-28: born2late]
 * hopefully get it right this time...

[2005-09-27: sasha]
 * rewrote WinList config parsing and merging code to use same names for member
   vars as keywords and macros to cut down on redundand code

[2005-09-27: born2late]
 * hopefully get actual version displayed in banner

[2005-09-26: sasha]
 * added bunch of config options to set how icons should be used in WinList

[2005-09-23: sasha]
 * fixed desktop categories loading from cached files; Implemented support for
   Desktop categories in Ident module and fixed its use of Database
 * fixed segfault in select_client_icon_argb()
 * added check to see if whats configured in database for the app Icon can
   actually be loaded as an image. If not then apps's specified icon will be
   used

[2005-09-22: sasha]
 * implemented caching of desktop entries - need to debug loading code
 * added bunch of new config options to docs and removed several obsolete
 * added some delay to Pager moving windows to attempot and make it less CPU
   intensive
 * added some delay to Pager moving windows to attempot and make it less CPU
   intensive
 * added ability to have client icons in Open Windows menu
 * fixed client icon image handling to not check KeepIconWindows, as this flag
   pertains only to client provided icon windows. Now icon from database will
   be used only if it came not from the default style, in case client has an
   icon of its own. Still need to add checks for icon in .database entry
 * debugging NET_WM_ICON support - mostly works

[2005-09-21: sasha]
 * implemented support for 32bit ARGB icons supplied by an app in _NET_WM_ICON
   property

[2005-09-21: born2late]
 * same propportions as mini-icons Desktop and RemoteControl

[2005-09-19: sasha]
 * changed parsing of <slice> xml to match docs and use x_start instead of
   start_x etc.

[2005-09-16: sasha]
 * fixed bug in F_SET_NAME handling when fdata->text was saved for later use,
   yet allowed to be freed

[2005-09-15: sasha]
 * added dynamically generated RestartModule menu - needs to be debugged still
 * fixed endless loop on Exec lines in .desktop files that contain quotes
 * added RestartModuleList menu item
 * fixed buffer overflow bug in new module cmd line code; added missing .depend
   files

[2005-09-14: sasha]
 * Fixed possible segfault or endless loop in desktop category list parsing
   code.
 * added ability to transmit module's command line back to AfterStep

[2005-09-13: sasha]
 * fixed generation of PHP data catalogue to properly set <IMG> source
 * minor corrections over born2late changes
 * implemented dynamic stop module list menu using new function StopModuleList
 * changed Modules/Stop menu to be dynamically generated

[2005-09-13: born2late]
 * completion of data file catalogue
 * changes to asdocgen - make data file catalogue php output work. various doc
   updates...

[2005-09-06: sasha]
 * added code to PrintDesktopEntries to be able to print beginning at some
   arbitrary directory with the tree
 * added XSpacing and YSpacing keywords to WindowBox definition to allow for
   variable spacing between windows that get tiled

[2005-08-31: sasha]
 * added Makefile changes to build and install helper app PrintDesktopEntries
 * implemented multiple aliases to desktop categories and added more X-KDE
   stuff
 * de

[2005-08-31: fabs]
 * maximization now also works correctly with virtual window-boxes.
 * fixed memory leak.
 * Windowboxes which have the virtual-flag set and are not on the current
   viewport will be considered last.
 * removed misleading comment and added another which should be there to the
   xinerama-code.

[2005-08-30: sasha]
 * desktop entries are now tagged as GNOME or KDE to allow for proper sorting
 * fixed compilation bugs in Desktop.c

[2005-08-29: sasha]
 * Added two new Database settings UseCurrentViewport Nad UseAnyViewport for
   apps like GIMP that abuse USPosition; Added ability to filter desktop entry
   to see if they belong to KDE/GNOME

[2005-08-27: sasha]

[2005-08-26: sasha]
 * fixed Desktop Entry parsing bug to acciount for all kinds of wierd spellings
   of [DesktopEntry]
 * Completed implementation of the desktop categories in AS menu; May need
   debugging ; added 2 new functions : SmallMinipixmap and LargeMinipixmap

[2005-08-25: sasha]
 * added supports for desktop categories to afterstep proper - need to debug
   memory allocation and add scaling to minipixmap

[2005-08-25: fabs]
 * fixed tiny bug: When having compiled with enable-xinerama and not actually
   using xinerama, afterstep would segfault on maximization. This is fixed now.

[2005-08-23: sasha]
 * working on integrating desktop categories into AfterStep proper - added all
   the paths into configure.h.in

[2005-08-22: sasha]
 * added ability to parse desktop entries from flat file and added
   standard_categories file to afdterstep dir

[2005-08-22: fabs]
 * windows are no longer maximized accross multiple heads when using xinerama.
   Wasn't able to test this code. Code tested by Nebukadneza.

[2005-08-19: sasha]
 * debugging category tree merging

[2005-08-17: sasha]
 * added sume wicked stuff for aliasing categories

[2005-08-16: sasha]
 * more work on menu hierarchy from desktop entries
 * moved appropriate functionality for desktop entry and category into
   libAfterStep

[2005-08-15: sasha]
 * disabled GLX by default
 * implemented desktop category handling with merging and fast extraction using
   hashes

[2005-07-24: fabs]

[2005-07-19: vae]
 * AfterStep Release v 2.1.2 Changelog
 * AfterStep Release v 2.1.2

[2005-07-19: sasha]
 * fixed writing out non-configurable/gtkrc and added simple template
 * Fixed initial placement of non-sticky windows when geometry is off visible
   viewport but within the desktop boundaries

[2005-07-18: sasha]
 * Fixed FocusOnMap handling due to erroneous reporting of window as Mapped,
   even if MapNotify has not arrived yet, which s the case when MapRequest is
   being handled

[2005-07-15: sasha]
 * Added ability to creata gtkrc files with colorscheme colors

[2005-07-14: sasha]
 * Made FocusONMap to force activation of the window even if its not under
   pointer
 * Made FocusONMap to force activation of the window even if its not under
   pointer

[2005-07-14: fabs]
 * fixed autoexec.in which I broke earlier ;)
 * Added keybindings for GWCommand and FocusOnMap in database.

[2005-07-13: sasha]
 * Added GwCommand and ASWallapaper to start menu and wharf
 * relocated ASWallpaper to more appropriate src/tools and god rid of empty
   support.c and callbacks.c

[2005-07-13: fabs]
 * Increased usability in GWCommand ;)
 * Added WinCommand-docs.

[2005-07-12: sasha]
 * completed ASWallpaper - added button for minipixmap updating; implemented
   new gradient saving into file; info messages etc.

[2005-07-12: fabs]
 * WinTabs now uses libAfterConf to parse command-line args.

[2005-07-11: sasha]
 * implementing xml generation for gradient editor
 * rearranged controls in gradient editor. added ability to have math
   expressions in integer config values

[2005-07-08: sasha]
 * implemented most functionality for gradient editor

[2005-07-08: fabs]
 * fixed potential stack-based buffer-overflows.

[2005-07-07: sasha]
 * added more controls to gradient editor

[2005-07-06: sasha]
 * adding subwidgets to gradient editor dialog
 * implemented solid color xml image wizard dialog; began implementing gradient
   editor widget

[2005-07-05: sasha]
 * changed color selector to be a child of a dialog, so it could be run modal,
   fixed shading in dirlist, added new buttons to main ASWallpaper screen

[2005-07-01: fabs]
 * added group-functionality. Unfortunately, WinTabs still sometimes freezes
   when launched with --pattern.
 * added posix-regular-expression support.

[2005-06-30: sasha]
 * made widgets in MakeXML dialog sensitive to checkbox selection
 *  completed implementing Make XML wizard with both minipixmaps and main
   wallpaper xml generation
 * reverted back to wild_reg_exp for compatibility reasons - Posix regexps
   should be implemented inside wild_reg_exp to allow for usage of traditional
   AfterStep patterns

[2005-06-30: fabs]
 * when regcomp fails, rexp-pointers are nulled. Before, I just had the
   function return which was wrong.

[2005-06-30: born2late]
 * added swallowwindow option - from information from sasha@irc

[2005-06-29: sasha]
 * implementing make xml wizard

[2005-06-28: sasha]
 * added color selector to xml editor so that its possible to select AS
   colorscheme colors as well as regular ARGB colors
 * fixed xml editor's size to fit on smaller screens and implemented tag
   insertion with the proper indenting

[2005-06-27: sasha]
 * added help window and contents to as image xml editor
 * Changed the order in which window boxes are being looked at - first in feel
   will now be chencked first
 * made afterstep check for the most appropriate window box, while maximizing
 * added ability to choose most appropriate window box for maximization

[2005-06-26: fabs]
 * added resize-feature to both WinCommand and GWCommand.
 * fix to make it compile on that old BSD box.
 * tiny fix to allow compilitation on that old FreeBSD.
 * removed redundant ";" to allow compilation on FreeBSD 4x
 * added -smart flag to arrange. If specified, a sane number for mn (maximum
   number of windows that are tiled into one direction) is calculated: mn =
   (int) sqrt(number_of_windows).

[2005-06-24: sasha]
 * fixed scrolling in xml editor and lists; added supported tags list and
   ability to insert tag templates into xml scripts
 * changed menu item height limitation to be 1/16th of the screen height, which
   is 30 in case of 640x480 or 48 in more usuall case of 1024x768
 * Added WinCommand and ASWallapepr to the build process

[2005-06-24: fabs]
 * WinCommand updated. It now has all the functionality GWinCommand has. Both
   are now ready for distribution.

[2005-06-23: sasha]
 * implemented XML validation button and selection rendering button in XML
   editor; Fixed main window destruction to not loose any unsaved XML in XML
   editor if its open
 * Fixed WinTabs to not immidiately reswallow windows that were explicitely
   unswallowed, even if they match the pattern
 * made image view more flexible allowing for selectrive tilng/scaling to
   aspect or to view

[2005-06-23: madarche]
 * M.-A. DARCHE: Made the keybinding on "Pause" toggles xscreensaver instead of
   xlock.

[2005-06-22: sasha]
 * Implemented SaveAs functionality in XML editor; Need to add callbacks to
   refresh main Image Browser on save events
 * improved layout of the xml editor -buttons are now greyed out instead of
   hidden

[2005-06-21: sasha]
 * improved layout of XML editor

[2005-06-20: sasha]
 * began implementing xml editor widget for ASWallpaper - don't really save
   anythging yet

[2005-06-19: fabs]

[2005-06-18: madarche]
 * M.-A. DARCHE: Added the function "Resize-or-Top" and used it for the
   following key-bindigs.

[2005-06-18: fabs]
 * fixed small syntax-error which kept lib from building.
 * apparently setting the radio-buttons did not emit "toggled". Set
   GWCommandState.area manually.
 * added method to register defaults for each action. Colorized widgets
   according to color-scheme.
 * toggle-buttons "on this screen"/"on this desk"/"on all desks" now work.
   default is "on this screen".

[2005-06-18: born2late]
 * added IconsGrowVertically docs.

[2005-06-17: sasha]
 * ASWallpaper mostly complete except for XML editing/creation functionality
 * added functionality for Appluy and delete buttons
 * added ASGTK lib to GWCommand
 * fixed combobox active entry extraction code to work under GTK 2.4

[2005-06-17: fabs]
 * fixed things suggested by sasha.
 * Added move-handler, center and center jump.

[2005-06-16: sasha]
 * mostly completed layout for ASWallpaper and functionality in Image Browser -
   now need to implement actuall file copying and AS message sending

[2005-06-16: fabs]
 * GWCommand is now almost completely functional.
 * added tested function ascom_get_win_names.
 * moved InitMyApp and ConnectX out of the library and into the app.
 * tested ascommand.c/operations.c extensively, fixed some smaller things and
   added operations: send_to_desk and center.

[2005-06-15: sasha]
 * fixed handling of transparent aterm's swallowed in WinTabs using fast
   transparency
 * Implemented safer detection of AfterStep XML image type to differentiate
   from XML and HTML docs; Added more controls to ASImageBrowser
 * debugged directory listing in image browser; added new file types for HTML
   and XML to stop treating them as image scripts; Added keycombo to switch
   windows in WinTabs - Alt +(key to the left from 1)
 * segfault under high load where first XGetProperty succeeds but the second
   one fails in get 32bit proplist - double freeing of a buffer

[2005-06-15: fabs]
 * You can now negate the selection. Things like "select all windows on this
   desk which do not match 'mozilla' and iconify them" are now possible.

[2005-06-14: sasha]
 * added directories listing and panned views to ASGTKImageBrowser

[2005-06-14: fabs]
 * Rewrote selection-code in ascommand.* and improved WinCommand.
 * Rewrote WinCommand to use newly created libAfterStep/ascommand.c-part of
   libAfterStep.
 * removed main in ascommand.c which I forgot to do earlier.
 * Added ascommand.c, operations.c and headers to libAfterStep.

[2005-06-13: sasha]
 * added widget for image directory list and image browser dialog

[2005-06-13: fabs]
 * Implemented IconsGrowVertically.

[2005-06-12: fabs]
 * growth from bottom to top now works correctly given that geom->height is
   large enough to hold the requested number of rows.

[2005-06-10: sasha]
 * began implementing ASImage directory listing with preview and stuff
 * moved generic functions for libAI and gtk integration into separate module
 * implemented GTK widget for image viewing , usefull for image browsers

[2005-06-10: fabs]
 * fixed bug triggered by IconBox 300 +1 1200 -65. Sasha: Please verify these
   changes. - fabs

[2005-06-09: sasha]
 * more configure tweaks to get to link to libASGTK
 * moved shareable code from ASWallaper into new libASGTK
 * extra repaint in Wintabs was required

[2005-06-08: sasha]
 * changed ASWallpaper to use FileSelection dialog
 * Applyed many fixes based on output of automated analysys tool, provided by
   sdague
 * continued debugging of ASWallpaper - still segfaults
 * updated changelog for release of libAfterImage
 * libAfterImage release v.1.07
 * fixed segfault on closing of asview

[2005-06-07: sasha]
 * debugging ASWallpaper
 * debugging ASWallpaper
 * fixed sigsegv in args processing
 * fixed makefile for GWCommand and added AS integration code to it

[2005-06-07: fabs]
 * Added resize-handler to WinCommand.c and moved LoadColorScheme beneath
   gtk-initialization to get around segault.
 * Initial revision of GWCommand.c + changes in WinCommand.c.

[2005-06-06: vae]
 * AfterStep release v 2.1.1
 * fixing cvs instruction for exporting on Release Guide
 * ChangeLog update for 2.1.1
 * AfterStep release v 2.1.1

[2005-06-06: sasha]
 * adding filechooser dialog to ASWallpaper

[2005-06-06: fabs]
 * Added "-pattern" support to Arrange and changed docs accordingly.

[2005-06-06: born2late]
 * added docs for arrange module - eventually check layout

[2005-06-03: sasha]
 * implemented rudimentary Targa files reading
 * fixes in libAfterImage for compilation and installation without libAfterBase
   - eliminated debug output, type casts, etc.
 * Fixed create_visual_pixmap to work with root = None; Fixed scale_pixmap to
   scale even in one direction only; Fixed configure to set path to
   libAfterBase to more sensible values

[2005-06-02: sasha]
 * implementing import of TGA files
 * fixed bug in calculation of monochromatic color scheme where shade of the
   InactiveText was used instead of its background; Added check for base
   brightness in determining of how to colorize main gtk window

[2005-06-01: sasha]
 * implemented proper colorscheming of gtk widgets

[2005-05-31: sasha]
 * added support for NET_WM_STATE Extended WM hints to WinTabs - it propagates
   it down to children

[2005-05-26: sasha]
 * fixed focused window style in look.Breeze
 * added code to Wharf and WinTabs to kill swallowed clients for sure

[2005-05-25: sasha]
 * fixed gc creation code to not create a new window each time gc needs to be
   created
 * implemented Sliced images as BackPixmaps in MyStyles
 * fixed merge function selection code in composite tag handler

[2005-05-24: sasha]
 * rewrote xml handling code and broke some stuff

[2005-05-23: sasha]
 * implemented slice_asimage function as yet another method of enlarging images
   where corners remain unchanged, but middle part gets tiled
 * implemented slice_asimage function as yet another method of enlarging images
   where corners remain unchanged, but middle part gets tiled
 * added --skip-transients option to WinTabs
 * added Makefile for WinCommand

[2005-05-22: sasha]

[2005-05-22: fabs]
 * Deiconify window-code added to cascade_window. I had only added it to
   tile_window earlier.

[2005-05-21: born2late]
 * added the most asked question on irc by newbies

[2005-05-20: sasha]
 * Fixed bug in tiling of ARGB32 data in libAI and implemented dynamic resizing
   of preview in ASWallpaper

[2005-05-20: fabs]
 * applied patch from FreeBSD-package-maintainer.
 * some cleaning, a bug-fix.
 * Deiconify iconified windows when they're being tiled/cascaded.

[2005-05-19: sasha]
 * Improvements to enable gtk apps to interoperate with libAS
 * new layout with list management buttons and resizeable preview

[2005-05-18: sasha]
 * Implemented background list in ASWallpaper as a GtkTreeView
 * fixed configure script to display proper messages while testing for gtk
   availability
 * hopefully fixed check for gtk2.0 to not kill configure
 * some prelimenary work on Wallpaper chooser layout

[2005-05-17: vae]
 * AfterStep release v 2.1.0 - changelogs - vae
 * AfterStep release v 2.1.0 - vae

[2005-05-17: sasha]
 * further development of Desktop Categories and entries ssunsystem
 * changed default WinList config to use regular name instad of iconic name
 * added proper config handling on ReparentNotify to WinTabs
 * wrote release guide for Vaevictus

[2005-05-16: sasha]
 * Added prototype of the GTK based tool for selecting AfterStep backgrounds
 * Implementing WinTabs functionality to survive the AS restart - in order to
   preserve swallowed clients; Fixed handling of icon name and name in hints to
   separate the two

[2005-05-13: sasha]
 * made WinTabs to delete all the clients on closing

[2005-05-12: sasha]
 * Got rid of Cascade and Tile modules as Arrange no completely replicates
   them; Prototyped  parser for GNOME/KDE .desktop entries , so we can maybe
   plug it into a menu/wharf
 * made WinTabs to honor ParentRelative way of transparency in terms

[2005-05-12: fabs]
 * All features should be done now except for -flatx and -flaty
 * fixed bug: -noresize -tile and -tile -noresize did not produce the same
   results before.

[2005-05-11: sasha]
 * some stuff from debian patches
 * Implemented exclude-pattern in WinTabs;implemented swallowing only from one
   desktop in WinTabs;Added proper usage functions to Pager and WinTabs

[2005-05-11: fabs]
 * added -nostretch.
 * added myself.
 * Added -noresize-flag and changed cascade_window/tile_window to respect it.

[2005-05-11: born2late]
 * some fixes to pager docs (fixmes)
 * some fixes to pager docs (fixmes)

[2005-05-10: sasha]
 * more sensible Tile setting
 * added new config options from 2.0.5
 * added empty Syntax for Arrange module and Arrange dir with templates in
   ASDocGen sources

[2005-05-10: fabs]
 * Introduced -alldesks. Corrected behaviour of -desk to do what it said in the
   1.8 manpage.

[2005-05-09: sasha]
 * fixed initial client name handling in WinTabs to get everything from
   property, in case AS has not completed sending us the info
 * fixed Wharf to render wmfire properly
 * added Clean module config
 * compile bugs
 * compile bugs
 * implemented Base config option NoSharedMemory to allow for switching shared
   images support on and off based on config settings
 * additional tweaks in WMDockApp checking code

[2005-05-09: fabs]
 * still need to figure out when to quit module.

[2005-05-08: fabs]
 * Used wd->desk instead of extwm-hints, introduced tile_width/tile_height
   instead of abusing max_width/max_height like before, added comments where
   things weren't obvious.

[2005-05-06: sasha]
 * fixed several Sgfaults in ASConfig
 * Fixed ASConfig compile error
 * Fixed focus shortcuts handling for shaded focused windows when ClickToFocus
   is used
 * Fixed input focus of shaded windows - needed to have KeyPressMask on frame
   window set

[2005-05-06: fabs]
 * Added -desk-feature, fixed bugs. Should work pretty well now.

[2005-05-05: sasha]
 * additional safeguards from wierd and plain broken wmdock apps that do wierd
   things like animating icon window that is the child of main window, yet is
   not properly sized, and other stupid things like that
 * implemented additional sanity checks to accomodate wierd wmapps that tend to
   draw on its icon even if the main window should be rendered to
 * implemented additional sanity checks to accomodate wierd wmapps that are too
   lazy to set its own size properly, despite setting min_size hints
 * added sanity checks to make sure no client can be a parent of iots own icon
   window
 * fixed sticky window iconification and deiconification after desktop was
   switched

[2005-05-05: fabs]
 * fixed minor bugs.

[2005-05-05: born2late]
 * typo corrections

[2005-05-04: sasha]
 * Updated ChangeLogs for 2.00.05 release
 * AfterStep 2.00.05 release

[2005-05-04: born2late]
 * added askwharf - possible gui frontend for postcard.sh

[2005-05-03: sasha]
 * typho in asinternals.h
 * improved Pager's handling of viewport switching with Button3
 * Fixed bugs in scroll function handling
 * changed the way DefaultFrame is handled, not fetch it by name each time,
   instead of storing direct pointer, which was causing double deallocation of
   it
 * Fixed segfault in shared memory cleanup code; Still segfaulting on restart
   in FramesList cleanup code

[2005-05-03: born2late]
 * typo cosmetics

[2005-05-02: sasha]
 * added ability to wharf to close subwharfs, and also to terminate subwharfs
   when Wharf is stopped.
 * fixed missing support for SuppressIcons keyword

[2005-05-02: fabs]
 * Added experimental tiling-support.

[2005-04-30: sasha]

[2005-04-29: vae]
 * added some sweet placement.c changes, specifically adding functionality for
   ReverseOrderVertical and ReverseOrderHorizontal

[2005-04-29: sasha]
 * fixed Wharf config - apparently to long a command line causes it to crash
 * added image path to ASImageManager's search path, so that referensed images
   could be found from local dir.
 * changed asview.c to open display prior to the image so that display size
   variables would get set properly
 * Added REverseOrderHorizontal and ReverseOrderVertical to windowbox flags (
   in config only )
 * added image path to ASImageManager's search path, so that referensed images
   could be found from local dir.
 * Fixed name alignment to follow global look too
 * implemented in Pager support for global titlebar options such as spacing,
   align, bevel and icon of the shade button

[2005-04-28: sasha]
 * name of cascade option fixed from Arrange
 * Implemented ButtonAlign, ButtonBevel and ButtonIconSpacing options in look
   for flexible config of minimized window's buttons
 * applied patch converting array of ids to bidirectional list
 * fixed icon_canvas segfault
 *  amybe fixed stack coruupotion due to icon title and icon proper being same
   canvas

[2005-04-27: sasha]
 * wierdness in XSync
 * some look and icons fixes
 * tidyed up menu entries for Cascade, Tile, Gnome and Zharf
 * fixed handling of F_MOVE and F_RESIZE where pixel values are used; Applied
   changes to Arrange module to do cascading contributed by fabs; Added code to
   Arrange module to Avoid AvoidCOver windows

[2005-04-26: sasha]
 * typho in configure.c
 * debugged icons handling when. Still need to work on SeparateIconTitle
 * fixed handling of ButtonSize setting - it was ignored
 * updated winlist config to use different MyStyles on some looks

[2005-04-25: sasha]
 * changes to fix Pager in look.QNX and to make modules not disappear under
   cover window
 * added .width and .height and .button.width and .button.height xml vars
 * added .font.size and .font.size xml variables available withon AfterStep
   only
 *  added ability for WinList to use ASTBar properties advertised by AfterStep
   from look. Fixed look.Glass and look.Unity
 * added checks to not show empty menus

[2005-04-22: sasha]
 * added ShowUnavailable configure option to enable showing unavailable items
   in menu as greyed out entries
 * Fixed off-by-one bug in ASStorage causing wierd artefact and possibly
   segfaults, due to occupied slots being reused improperly

[2005-04-22: born2late]
 * updated forcesize info based on comments of sasha on irc

[2005-04-21: sasha]
 * improved speed of wharf button focusing by using canvas swapping feature
 * hopefully fixed Segfault when window changes name at the time of destruction
 * implemented ExecInTerm parameters optional for different term types using
   syntax: if(term){opts}
 * implemented ExecInTerm parameters optional for different term types using
   syntax: if(term){opts}

[2005-04-20: sasha]
 * fexed BadMatch bug in Pager when some window would make it into stacking
   order several times
 * implemented helpfull hints for cases where we deffer execution of wait for
   window to appear

[2005-04-19: sasha]
 * Fixed numerous bugs in WinTabs - should work great now

[2005-04-19: born2late]
 * make php output be in sync with website copyright layout again
 * added new config options to docs.

[2005-04-18: sasha]
 * seems to have resolved all java sizing issues now; Fixed menu minipixmaps to
   get scaled to minipixmap.width
 * Added MinipixmapSize to look config to override default 48x48;
 * Fixed WinTabs swallowing by pattern when name type is not set; Fixed WinTabs
   focus handling to include own windows; Fixed WinTabs selected tab handling
   for the last tab

[2005-04-15: sasha]
 * Implemented tab name tracking in WinTabs and fixed multirow tabs layout;
   Implemented SizeInc handling for apps that support it
 * Fixed bug in TermCommand parsing; Added InheritDefaults option to MyFrame

[2005-04-14: sasha]
 * added TitleHSpacing and TitleVSpacing to MyFrame; Fixed spacing of different
   titlebars; Implemented proper focusing in WinTabs; Implemented better
   support for tbar props;

[2005-04-14: born2late]

[2005-04-13: sasha]
 * fixed broken initial placement with java apps in jre 1.4 - All that is
   needed is to set WM_STATE property just after reparenting while server is
   still grabbed
 * fixed broken initial placement with java apps in jre 1.4 - All that is
   needed is to set WM_STATE property just after reparenting while server is
   still grabbed
 * added --pattern and --geometry cmdline opts to WinTabs
 * Added checks for NULL dirtree in menu melting code; Added handling of
   configure events to WinTabs
 * Fixed handling of window name change - should not update hints flags or
   functions - that may break some things. Implemented pressing on Buttons in
   WinTabs;Enabled Balloons by default
 * debugging java behaviour

[2005-04-13: born2late]
 * updates and changed filenames so they do not conflict with asdocgen under
   windows
 * added useless introduction to docs

[2005-04-12: sasha]
 * added X property to convey titlebar look guidelines to moidules

[2005-04-11: sasha]
 * began implementing new property to pass info about window titlebar config
   over to modules for consistent look/feel
 * fixed segfault when wrong op= to composite tag is used
 * Implemented IgnoreConfig database flag to block ConfigureRequests from some
   confused apps such as java 1.4, browsers, etc.
 * debugged title layouting in WinTabs

[2005-04-08: sasha]
 * Some WinTabs debugging
 * replaced lots of mallocs with callocs to ensure that memory gets zeroed out

[2005-04-07: sasha]
 * fixed root menu not working
 * added CREDITS files for everyone who ever contributed a background or
   something
 * added OceanWave background image - needs some work
 * completed look.Tiny

[2005-04-06: sasha]
 * fixed fonts in look.Transparent; Fixed layout of text in WinList
 * new backgrounds and debugged condensed vertical tbar

[2005-04-05: sasha]
 * java placement debugging and artifacts with condense Titlebar
 * added look.Tiny and debugged frame bevel handling in MyFrame

[2005-04-04: sasha]
 * added pre-resizing of frame subwindows ahead of the resizing of actuall
   frame window to make window-resizing look faster and smoother
 * fixes and improvements to get WinTabs module to work properly
 * removed inline's froom functions all exported functions in libAfterImage

[2005-04-01: sasha]
 * implemented SwallowWindow AfterStep Built-in - now need to work on WinTabs
 * debugged handling of ClickToFocus event processing code

[2005-03-30: sasha]
 * implemented PopUp syntax with function data given the priority. Debugged
   right mouse click actions in Wharf

[2005-03-29: sasha]
 * implemented ExecInTerm function and ability to specify Wharf's button action
   on right mouse click

[2005-03-29: born2late]
 * added wharf mystyles to docs.

[2005-03-28: sasha]
 * added failover option to keycode parsing
 * added failover option to keycode parsing
 * added failover option to keycode parsing
 * fixed data install, to simply copy default config files from other dirst,
   instead of maintaining copies
 * fixed root background changin
 * added standard options --geometry --myname --gravity and Pager and Wharf's
   specific options --rows --cols to override whats in config files, so that we
   can have easy layout from autoexec

[2005-03-25: sasha]
 * minor fixes

[2005-03-22: sasha]
 * Updated ChangeLogs for 2.0.4 release
 * AfterStep 2.00.04 release
 * made desktop cover tint to be similar to Base color from selected
   colorscheme
 * changed bars/empty to proper tiles/empty in look.Breeze
 * fixed doc/Makefile to check for /html/ to exist
 * added look.Breeze buttons
 * added look.Breeze bars
 * cleaned up stale help files; got rid of sgmltools deps; updated .spec file;
   changed version number to 2.0.4

[2005-03-21: sasha]
 * added generation of FAQs to ASDocGen
 * fixed segfault with glx enabled

[2005-03-17: sasha]
 * fixed libraries listed by libAfterImage config script to include X libs to
   avoid linkage problems
 * implemented dynamic linking to several global vars exported from
   libAfterStep to prevent compilation and linkage errors
 * hopefully cleaned up shared memory usage

[2005-03-16: sasha]
 * optimization of shared memory
 * some debugging of asstorage code, possibly fixing segfault
 * added look.Breeze from zipht
 * hopefully fixed balloons blinking with xawtv
 * hopefully fixed balloons blinking with xawtv

[2005-03-15: sasha]
 * hopefully fixed compile problem with gcc 4 related to declaration of array
   of undefined element size

[2005-03-14: sasha]
 * fixed memory corruption in pager.c
 * fixed handling of special sequences in xml source of ASDocGen+ fixed
   handling of several term tags within single varlist entry

[2005-03-11: sasha]
 * made use of _AS_BACKGROUND property to hold copy of _X_ROOTPMAP so that we
   don't have to listen to all those PropertyNotifies on root window - modules
   don't need to wake up as often now
 * copied DefaultFancy.ttf to libAfterImage/apps/test.ttf to avoid possible
   licensing issues. Those are the same anyways, only DefaultFancy includes
   Public Domain notice
 * Fixed not switching focus due to usage of CurrentTime occasionally

[2005-03-11: born2late]

[2005-03-10: sasha]
 * added ability to choose random tint color for desktop cover, and added more
   tracing for XSetInputFocus as it seems to not switch focus properly
 * compile bug

[2005-03-09: sasha]
 * some memory hole plugging and leaks debugging - nothing major so far

[2005-03-08: sasha]
 * debugging memory utilization
 * added afterbase_config.h to define several macros that change features in
   compiled afterbase
 * added afterbase_config.h to define several macros that change features in
   compiled afterbase
 * added explicit sign convertions to most of geometry and moveresize function
   to try and nail down potential signed/unsigned bugs
 * fixed compile warnings for Alpha's cc
 * fixed few compile warnings

[2005-03-07: sasha]
 * remedied situation with Animate module rendering AS unresponsive, by
   decreasing sleep time and making lock_on_send mechanism more fine-grained
   allowing to lock only on some messages
 * Fixed bug causing empty workspace_state when first window in the list is
   module
 * Fixed bug causing empty workspace_state when first window in the list is
   module
 * fixed problem with wharf swallowing apps that were mapped on different
   desktop

[2005-03-05: sasha]

[2005-03-04: sasha]
 * fixed signed/unsigned conversion bug in rectangle calculation code causing
   windows to be placed on top of each other in SmartPlacement
 * implemented hopefully more intelligent logic for SmartPlacement

[2005-03-03: sasha]
 * compile fix in selfdiag
 * fixed calculation of the windowbox width and improved logic in smart
   placement
 * updated the UPGRADE file to 2.0 based on recomendations of Andrew Sullivan

[2005-03-02: sasha]
 * updated ChangeLog file to 2.00.03 release
 * AfterStep 2.00.03 release
 * updated NEW file to 2.00.03 release
 * fixed longstanding bug with windows not being properly delisted from
   iconbox. Thanks Debian users

[2005-03-01: sasha]
 * added more text in ASDocGen sources
 * added support for IMAGE_PATH env var to all apps in libAfterImage enabling
   them to view images installed in different afterstep directories
 * some docs additions
 * fixed bugs: segfault and mem corruption in ASStorage when compressed size
   exceeds buffer size; Proper encoding usage in winlist menus - for UTF8
   encoded window names; Proper encoding usage in balloons - it was using ASCII
   regardless; Proper font in Pager with support for international chars
   instead of 5x8; Handling of $HOME at the beginning of include statements of
   .include files

[2005-03-01: born2late]

[2005-02-28: sasha]
 * added experimental image transfer code using OpenGL API
 * more performance testing with OpenGL
 * more performance testing with OpenGL
 * gl timing

[2005-02-26: sasha]

[2005-02-25: sasha]
 * added prototype of image transfer to X using GLX - to see if its any faster
 * fixed compile warning
 * fixed rectangle list compilation for placement purposes - some rectangles
   were being lost
 * updated configure to exclude Save

[2005-02-25: born2late]
 * monkey error corrections
 * windowbox almost complete now
 * hopefully i can sort my mess out one day

[2005-02-24: sasha]
 * updated doc source tree
 * updated doc source tree
 * updated doc source tree
 * Fixed left buttons align in QNX theme to work for vertical tbars
 * fixed bug screwing up titlebar on look change if frame decor size had
   changed

[2005-02-23: sasha]
 * removed unneeded Save module
 * fixed handling WharfNoBorder
 * Fixed handling of RandomPlacement - it should not fallback to Manual
 * fixed handling of DefaultGeometry in database
 * implemented scratch canvas functionality in draw.c to facilitate fill
   operation on some countours; Added draw.h header
 * fixed bug in PutHome having random concatenation symbol in the middle

[2005-02-22: sasha]
 * changed ~ to //home/sasha
 * fixed afterstep defaults
 * added FONT_PATH and IMAGE_PATH to set of envvars put out by AfterStep
 * compilation warnings and bugs submitted by Valeriy Onuchin

[2005-02-18: sasha]
 * implemented new feture allowing for Hue/Saturation adjustment of the
   titlebars using TitleHue and TitleSat in MyFrame. Fixed look.Unity to take
   advantage of this

[2005-02-17: vae]
 * added one more comment
 * added postcard.sh ... configure needs to fix FILE.  and it needs to be put
   into /usr/share/afterstep/autoexec as xterm -e postcard.sh with the path and
   stuff.

[2005-02-17: sasha]
 * fixed compile error in screenshot function and ugly string code in the same
   place
 * completed look.Unity
 * added look.Unity's frame

[2005-02-16: sasha]
 * completed look.Unity titlebar
 * added remaining buttons to look.Unity
 * look.Unity progress; Fixed align flags translation for vertical tbars; Added
   new feature Left/RightBtnAlign to MyFrame

[2005-02-16: born2late]
 * typo correction

[2005-02-15: vae]
 * xprop needed two calls, not one, now.

[2005-02-10: born2late]

[2005-02-05: born2late]
 * hopefully extracted _all_ info from NEW file.

[2005-01-31: born2late]
 * MyBackground doc fills

[2005-01-28: vae]
 * Added my beautifully pilfered mozilla logos

[2005-01-26: sasha]
 * added checks for environ decl, and implemented fallback procedure

[2005-01-21: sasha]
 * fixed wm restart process to pass proper environment to the process,
   including DISPLAY var
 * added recovery code for malformed gifs not having zero length block at the
   end of compressed data

[2005-01-20: sasha]
 * fixed compile warning in desktop switching function
 * updated ChangeLog for 2.00.02 release
 * AfterStep 2.00.02 release

[2005-01-19: sasha]
 * fixed bug preventing maximized apps from being properly placed

[2005-01-18: sasha]
 * fixed configure for CYGWIN to build proper lib type. Implemented Image
   writing into memory buffer in PNG format - see ASImage2PNGBuff example in
   asvector.c
 * fixed configure for CYGWIN to build proper lib type. Implemented Image
   writing into memory buffer in PNG format - see ASImage2PNGBuff example in
   asvector.c
 * added ability to bundle included sumenu's items under private user items
 * fixed handling of <term> tag while generating man pages - nested
   doublequotes should be escaped
 * fixed handling of Desk function arguments

[2005-01-14: sasha]
 * changed everything to make possible libAfter* as a DLLs - Scr substituted to
   a pointer and same for MyArgs

[2005-01-13: sasha]
 * bunch of fixes to enable shared libs under CYGWIN - but there is still a
   problem of linking apps becouse of the Scr variable
 * applyed 64bit AMD patch from Sean Dague

[2005-01-12: sasha]
 * Fixed bug in makefiles installing shared libraries
 * fixed long standing bug with AS not restarting itself properly. Upped
   version to 2.00.02 in preparation to release
 * fixed Makefiles and -config scripts

[2005-01-10: sasha]
 * ellipses, damn it
 * fixed Wharf's animation delay to be in milliseconds and not in 0.06 sec
   increments
 * fixed aftereffect of having RaiseToClick working on menu windows
 * fixed aftereffect of having RaiseToClick working on menu windows
 * fixed wm restarting with other wms
 * fixed handling of ClickToRaise - now its only used if there are no other
   actions bound to a click. This also fixes ability to move/resize windows
   without raising them.

[2005-01-08: sasha]

[2005-01-06: sasha]
 * more bloody ellips
 * more bloody ellips

[2005-01-04: sasha]
 * mostly done with ellips implementation using doubles - runs faster the
   approximation through beziers

[2004-12-29: sasha]
 * some funky stuff to try to get alternative ellips algorithm going - doesn't
   work yet

[2004-12-28: sasha]

[2004-12-26: sasha]

[2004-12-26: born2late]
 * fixing afterstep restart config issues

[2004-12-23: sasha]
 * completed implementation of ellips and circle primitives

[2004-12-22: sasha]
 * improved cubic splines to not use recursion and implemented circle drawing
 * improved cubic splines to not use recursion and implemented circle drawing
 * Implemented antialiased cubical Bezier curves  drawing
 * implemented anialiased line rendering

[2004-12-21: sasha]
 * implemented anialiased line rendering
 * implemented anialiased line rendering
 * implemented anialiased line rendering
 * implemented anialiased line rendering

[2004-12-20: sasha]
 * fixed afterstep-config to include extra X libs; implemented prototype
   anialiased drawing code

[2004-12-18: madarche]
 * M.-A. DARCHE: The file src/Banner/.depend should not be managed through CVS.
   It is either useless now or is a generated file.

[2004-12-17: sasha]
 * added test code for drawing
 * added drawing functionality
 * fixed performance hog introduced by data[1] changed to data[0] in asstorage
   during round of warnmings fixes
 * changed WinList to not delay redrawing of the bars
 * added one more hint to identify AS module windows as such, thus fixing bug
   in workspace saving where modules would get save d as well

[2004-12-15: sasha]
 * some kode to proxy keypresses and clicks to swallowed apps

[2004-12-14: sasha]
 * added ability to pull cmd line from /proc filesystem by pid
 * fixed segfault when DontDrawBackground is requested in look
 * Fixed segfault bug in iconification code when StickyIcons are disabled

[2004-12-14: born2late]
 * hopefully nice docs
 * missing crosslinks in doc

[2004-12-13: sasha]
 * minor fixes to iconbox handling
 * fixed scaping in ASDocGen and image/include4 file installation with leading
   .

[2004-12-10: sasha]
 * More compilation warnings fixed
 * ttf always on under win32 and typo fix in mmx initialization code

[2004-12-10: born2late]
 * forgotten cvs commits
 * again clean up of docs hopefully
 * clean up of docs and added links to _related

[2004-12-09: sasha]
 * added list of standard X colornames
 * numerous fixes from FonsRademaker and Valeriy Onuchin - to make it compile
   under win32

[2004-12-08: sasha]
 * fixed bunch of warnings for different compilers

[2004-12-08: born2late]
 * get quit->restartsession do what it's supposed to

[2004-12-07: sasha]
 * Fixed main makefile to not violate sandbox and simplify package creation for
   gentoo and others

[2004-12-06: sasha]
 * hopefully fixed bug where icon title would show up even if IconTitle is not
   set

[2004-12-06: madarche]
 * M.-A. DARCHE: - Captured image filenames have now different prefixes,
   "capture_window",   "capture_framedwindow" and "capture_screen".
 * M.-A. DARCHE: - Renamed in the non-configurable/0_feel "Take screen shot"
   menu entries into:   * Capture window image   * Capture framed window image
    * Capture screen image - The order is also changed so that it is more
   logical, from narrow (window) to   wide (screen) focus. This order should be
   more logical and thus more user   friendly.

[2004-12-02: madarche]
 * M.-A. DARCHE: - Wording "Capture window + frame image" -> "Capture framed
   window image".

[2004-12-01: sasha]

[2004-11-30: sasha]
 * AfterStep 2.00.01 release
 * AfterStep 2.00.01 release
 * added a configure option --disable-data-reinstall just for MG_Tak - it
   prevents image, font files from being copied over existing ones, and
   prevents HTML catalogue from being generated;

[2004-11-29: sasha]
 * Updated the copyright
 * fixed Wharf not having a proper shape if Animation is disabled - so called
   MG_Tak bug
 * Fixed bug in afterstep not sending proper notifications about which window
   is currently focused
 * changed default output format for screenshots to be PNG

[2004-11-26: sasha]
 * fixed memory leak at add_line_mono

[2004-11-26: madarche]
 * M.-A. DARCHE: - Renamed "Take screen shot" menu entries into:    * Capture
   window image    * Capture window + frame image    * Capture screen image -
   The order is also changed so that it is more logical, from narrow (window)
   to   wide (screen) focus. This order should be more logical and thus more
   user   friendly.
 * M.-A. DARCHE: - Added term keybindings - Added commented XMMS keybindings
 * M.-A. DARCHE: - Added a Maximize key binding - Added menu display on Menu
   key
 * M.-A. DARCHE: EdgeResistance 800 80 -> EdgeResistance 800 4
 * M.-A. DARCHE: CirculateSkipIcons seems a better default (more usable
   desktop).
 * M.-A. DARCHE: Xzap 12 -> Xzap 2 Yzap 12 -> Yzap 2
 * M.-A. DARCHE: - Added support for Psi (Jabber instant messager) in the
   database file - Reorganization of the database file by themes

[2004-11-24: sasha]
 * Arrange work

[2004-11-23: sasha]
 * updated version to 2.00.01
 * fixed handling of pointer cursors in tbar buttons and on frame window's
   border
 * added Arrange module to replace Cascade and Tile
 * fixed background flipping and bevel on Vertical tbar windows
 * fixed possible segfault in data HTML cataloguing code
 * added comments to vectorize_asimage

[2004-11-22: sasha]
 * fixed handling of shaped canvasses when shape is empty - that was causing
   double animation in Wharf
 * implemented vectorize_asimage and some minor fixes to Wharf
 * eliminated wharf folder moveresize to -1000-1000 when withdrawn and
   implemented proper withdrawing of subfolders

[2004-11-19: sasha]
 * Fixed tiling with negative offset - unsigned/signed conversion problem
 * fixed root background cuting for transparency for off-screen windows
 * Debugged conversion from alt.argb32 to other stuff, like XImage etc. using
   ASImageDecoder - see example in asview.c
 * Implemented ASImageDecoder support for alt.argb32 format

[2004-11-18: sasha]
 * optimized redrawing when folder is open repeatedly
 * Fixed shaped window handling at the time of mapping, for windows without
   title
 * Fixed shaped window handling at the time of mapping, for windows without
   title
 * Finally found a bug in Wharf causing subfolders with swallowed apps not to
   show up after first animation
 * fixed bug where smaller windows would get displaced on Warping if they are
   right on the edge of the screen
 * hopefully fixed wharf's animation

[2004-11-17: sasha]
 * Wharf animation debugging for folders
 * fixed empty shapes of folders while animating
 * fixed empty shapes of folders while animating
 * fixed placement of labels larger then titlebar and increased threshold of
   light background

[2004-11-16: sasha]
 * added MyStyles for aterm
 * changes to accomodate new aterm code
 *  Fixed ascmap to not segfault under MSWin and fixed fill_asimage to use
   proper width when x > 0  - reported by Valeriy Onuchin;

[2004-11-15: sasha]
 * fixed shading translation into tint
 * fixed some code in pixmap handling used in aterm
 * changed Pager invocation in start menu to use desktop number specifyed to
   configure script

[2004-11-15: born2late]

[2004-11-14: born2late]
 * typo corrections
 * minor corrections
 * this hopefully finally fixes the <hr> issue for the php index/glossary

[2004-11-12: sasha]
 * synch

[2004-11-11: born2late]
 * missing /

[2004-11-10: sasha]
 * fixes to afterimage include files to properly install and enable other apps
   to use it

[2004-11-09: sasha]
 * fixed timing issue in WinList
 * fixed Makefile in libAfterConf to properly check for afterconf-config
   existence
 * fixed animation in Wharf to be sign-safe

[2004-11-08: sasha]
 * fixed Makefile.common.lib to propertly install -config scripts
 * fixed Makefile.common.lib to propertly install -config scripts

[2004-11-05: sasha]
 * better shell used while running apps - we actually try to use same shell we
   were started with now

[2004-11-02: sasha]
 * Fixed bug in frame handling to get north side of the frame to show up, even
   when NoTitle is requested
 * added descriptions to bunch of functions

[2004-11-02: born2late]
 * finally under 300 FIXME in ASDocGen !

[2004-11-01: sasha]
 * Fixed parsing of WindowBox
 * Fixed Wharf animation for horizontal folders with east gravity
 * fixed shape of the shaded windows when ComdenseTitlebar is on

[2004-10-29: sasha]
 * xmlrpc compile fixes
 * fixed data installation in Makefile
 * Fixed bug in Wharf animation causing it to not show up properly

[2004-10-28: sasha]
 * fixed handling of condensed tbar shape on title change
 * fixed handling of CondensedTitlebar where title is bigger then the window
   size
 * disabled screen grabbing when window function is run as the result of
   keypress, yet no window is focused; Fixed hilite of deiconifiued windows

[2004-10-27: sasha]
 * began implementing XML-RPC interface to ASConfig
 * Added new feel options AnimateDeskChange to enable animation of dektop when
   desk is changing and background is the same - removing this option gets rid
   of animation - something MG_Tak wants
 * added phony module.clean targets for proper make clean
 * fixed install script for ASDocGen not to export and assign shell vars at the
   same time

[2004-10-26: sasha]
 * developed xml protocol for accessing ASConfig
 * Fixed handling of RightTitlebarLayout, added examples and explanation to
   look.DEFAULT

[2004-10-25: sasha]
 * Added wharf to ASConfig
 * split ASConfig into files for easier navigation

[2004-10-25: born2late]
 * from Changelog 2003-12-01 :) i did not find it documented elsewhere...
 * typo correction
 * from Changelog 2003-10-22 :) i did not find it documented elsewhere...

[2004-10-22: sasha]

[2004-10-20: sasha]
 * restructured main Look/Feel configs to be more flexible and sort items by
   destination

[2004-10-19: sasha]
 * investigated approach where module's options get spil into look, feel and
   private stuff and go into respectful files
 * Fixed bug in RightTitleLayout being ignored

[2004-10-19: born2late]
 * import from NEW (v.1.20) file
 * updates to docs
 * clean up wrong links in html part of the docs

[2004-10-18: sasha]
 * added indexing in function to try and prevent functions with name signifying
   urgency from being eleminated as duplicates
 * completed implementing menu handling with sorting, order and F_TITLE

[2004-10-15: sasha]
 * added new feel options
 * Fixed handling of BorderWidth in hints
 * fixed libAfterImage makefile for win32 to include asstorage.c; fixed
   compilation problem and excessive debug output under windows

[2004-10-14: sasha]
 * implemented menu melting in ASConfig using include files
 * possibly resolved problem with ASDocGen not being run when compiled with
   shared libraries

[2004-10-13: sasha]
 *  implemented most of the menu parsing into property list

[2004-10-12: sasha]
 * fixed problem with inherit clauses of MyStyles not having quotes;
   Implemented lots  of new stuff in ASConfig as well, as redone property tree

[2004-10-11: sasha]
 * more ASConfig implementation

[2004-10-09: born2late]
 * documentation updates...
 * missing config options in documentation (from NEW file)

[2004-10-08: sasha]
 * Fixed problem in base loading where there were no sanity checks for
   DesktopScale value; Fixed a bug in ASStorage where small images < 15 pixel
   widths would come out broken; Implemented partially property tree printing
   in ASConfig; Added ASStorage functionality to be able to query original size
   of the stored data

[2004-10-07: sasha]
 * more ASConfig development

[2004-10-06: sasha]
 * added some more code for property tree building
 * added WinTabs module example
 * bugfix in parser.c

[2004-10-06: born2late]
 * again docs, removed bug in api docs (html)
 * more docs + modified look.legacy

[2004-10-01: sasha]
 * started work on ASConfig module

[2004-09-30: sasha]
 * fixed spec.in file to properly handle man pages and prefix
 * fixed segfault on solaris in ASDocGen

[2004-09-28: sasha]
 * fixed compile problem with --enablegdb

[2004-09-27: sasha]
 * updated changelog
 * AfterStep 2.00.00 Release
 * changed versions to 2.00 and 1.00 for libraries
 * cleaned up stale TODO items
 * implemented deiconification when window is activated
 * fixed segfault when window in stacking order is not yet known to us
 * improved on animation to be smooth and avoid excessive redrawing
 * fixed recently intoduced bug in asstorage causing major slowness; added some
   logic to prevent costly maintenance operations from happening too often
 * fixed animation process to work correctly for different gravity types

[2004-09-25: sasha]

[2004-09-24: sasha]
 * fixed segfault in asstorage when diff buffer does not gets reallocated
 * rewrote wharf animation to be smoother - still something is wron on initial
   map
 * fixed button ungrabbing on windows withdrawing that was causing wierd
   BadAccess errors in Wharf

[2004-09-23: sasha]
 * added minipixmap image prescaling to speed up menus on smaller screens
 * implemented preloading of menu pixmaps - speeding things up considerable;
   fixed segfault in asstorage - still unclear how that could happen - may see
   some image corruption instead
 * improved handling of the frame resize to minimize drawings - we used to
   redraw it twice before

[2004-09-22: sasha]
 * debugging initial window frame rendering - something is fishy there
 * some performance optimization based on gprof stats, as well as memory leak
   cleanups
 * fixed atom name for _NET_WM_WINDOW_TYPE

[2004-09-21: sasha]
 * completed moving gradiented textures into directory of their own
 * added mandatory -O3 in libAfterImage and libAfterBase improving performance
   significantly;
 * fixed performance hog in asstorage, as well as segfault in the same place;
   Implemented shaped image rendering directly into XImage, added menu
   shortcuts for Left and Right keys
 * implemented keyboard navigation of the menus

[2004-09-21: born2late]
 * added rox-filer and corrected wmxmms to start with single click

[2004-09-20: sasha]
 * implementing keyboard shortcuts
 * tweaks for more optimal transparency updating, including menu; fixed
   ASDocGen to treat quotes and special characters in Glossary
 * Fixed type of _WIN_CLIENT_LIST property, discontinued _NET_WM_PROTOCOLS
   property as per specs

[2004-09-19: sasha]
 * fixed possible data loss in asstorage for the very first block

[2004-09-17: sasha]
 * added support for several Extended WM properties needed for Pagers
 * updated MyStyle to latest stuff
 * Fixed property type for WM supporting check property - implemented setting
   client list property

[2004-09-17: born2late]

[2004-09-16: sasha]
 * lots of optimizations of focus change handling in WinList and AfterStep,
   shape handling optimizations in Pager and other tweaks

[2004-09-16: born2late]
 * added link in developer index to data files + docu update
 * again filling of new docsystem from NEW file or 1.8.11 man pages
 * again filling of new docsystem from NEW file or 1.8.11 man pages
 * again filling of new docsystem from NEW file or 1.8.11 man pages

[2004-09-15: sasha]
 * playing with submenu gravity - something fishy
 * fixed wharf so that focused tile works with swallowed applets
 * added NoBorder flag to MyFrames, improved performance and feedback in data
   doc generation

[2004-09-14: sasha]
 * fixed shape handling of the canvas's border - fixes border in Pager and
   windows - need to do something about window border in frames
 * added code to background handling, to not interrupt the animation when
   desktop is switched before it completes

[2004-09-13: sasha]
 * Completed implementing ASDocGen support for cataloguing data files; Fixed
   icon files with hardcoded color values and missing files
 * Fixed Key press handling when there are no windows focused
 * Changed ASDocGen to not create files writeable by the world

[2004-09-11: madarche]
 * - Since AS forms are not working (at least at this time), replacing
   TakeScreenShot, TakeWindowShot and TakeFrameShot by their equivalent in
   shell   scripts using X xwd program + ImageMagick for conversion. - Made the
   xlock command really lock the screen, otherwise it wouldn't be   useful
   since one can already have a screensaver starts itself automatically   after
   some time with no events.
 * # Commenting the following keybindings because they trap Mozilla history #
   navigation keybindings: #Key Left        A       M       Scroll -10 +0 #Key
   Right       A       M       Scroll +10 +0 #Key Up          A       M
   Scroll +0  -10 #Key Down        A       M       Scroll +0  +10

[2004-09-10: sasha]
 * Added generation of image catalogue into ASDocGen
 * cleaned up files - moved robodoc functionality into its own file out of
   ASDocGen.c

[2004-09-10: madarche]
 * Disabling those bindings since the "Alt + tab" combo does already the same
   and it takes bindings used by Emacs. #Key Meta_L      A       A
   WarpFore #Key Meta_R      A       A       WarpBack
 * Those settings make a more sensible choice for most users who want an
   intuitive AfterStep right out of the box (they will be able to modify this
   config later on if they are not pleased with it): SmartPlacement
   RandomPlacement #NoPPosition

[2004-09-09: sasha]
 * trying to fix GTK-perl

[2004-09-08: sasha]
 * fixed windows popping up under currenbt windows, viewport on restart, cover
   animation
 * changes to feel file for better shortcuts for desktop switching; Fixes to
   ASStorage to properly handle reference counting without leaving leftovers

[2004-09-02: sasha]
 * Lots of tweaks to desktop switching, initial placement handling and
   move-resizing

[2004-09-02: born2late]
 * some fiddling with php pages for better integration on wao

[2004-09-01: sasha]
 * fixed focus handling when switching between monitors; Added desktop cover to
   desktop switching- not sure if it worth it
 * Implemented large portion of Ident module, still need to implement printing
   some portions of ASDatabase records matching; Improved some things in
   hints.c so it could be used elsewhere

[2004-08-31: sasha]
 * updated Colorscheme docs
 * updated Makefiles to generate docs before install phase

[2004-08-30: sasha]
 * updated configure scripts
 * got Ident to compile
 * improved AfterStep.desktop and implemented installation for gdm and kdm

[2004-08-28: sasha]

[2004-08-28: born2late]
 * again filling of new docsystem from NEW file or 1.8.11 man pages

[2004-08-27: sasha]
 * fixed docs script
 * temporary removed ident.o
 * reimplementing Ident module
 * fixed handling of twoway tinting for transparent BackPixmaps in MyStyle
   property
 * added images directory to ASDocGen so that images could be included into
   docs
 * got rid of NoBorder and NoWithdraw in Wharf config options
 * Added support for <imagedata> tag
 * fixed for proper doc installation
 * updated doc sources

[2004-08-27: born2late]
 * again filling of new docsystem from NEW file or 1.8.11 man pages
 * again filling of new docsystem from NEW file or 1.8.11 man pages

[2004-08-26: sasha]
 * more tuneup of wharf animation speed
 * fix to Makefile to install man pages and HTML help pages
 * replaced find -printf with basename, to make it work on bsd flavors

[2004-08-25: sasha]
 * more xft development
 * Some changes to DeadPipe to prtevent it from reentering self

[2004-08-24: sasha]
 * more WinList performance tweaking and afterstep even handling
 * added more logic to avoid excessive redraws of WinList
 * Implemented memory debugging for buffer underruns with --enable-audit under
   win32; Found memory corruption caused by merging image of size 0, which
   fixes segmentation Fault in WinList

[2004-08-23: sasha]
 * Fixed make install in libAfterImage; Added missing files to libAfterImage's
   project files; Fixed segfault in afterstep when clicking happens too fast
   and there is no more window by the time function is executed
 * applied patch for interlaced GIF support from Maxim Nikulin

[2004-08-20: sasha]
 * new development to add interface with XRender extention for text rendering
 * added more logic to Mkaefile for data files to copy files using proper
   permissions - start menu is the only one that gets copied using CP

[2004-08-19: sasha]
 * Makefile fixes for proper installation of config files
 * fixes to Makefile for better dirs creation
 * fixed segfault in AfterStep when pixmap path or FontPath are empty
 * fixed potential segmentation fault in asfont.c at the time of text rendering

[2004-08-17: sasha]
 * fixed compile bug in asstorage.c
 * disabled clocking of transformations and text drawing
 * AfterStep 2.00.beta5 Release

[2004-08-16: sasha]
 * Changed version number to beta5, Changed AfterStep.spec to be updated
   automagically with proper version number; Updated afterstepdoc script to
   select web browser from mozilla, firefox, konq, opera, netscape
 * changed default background to use StormySkies image as the base
 * added new background - StormySkies contributed by Ales Ledvinka
 * implemented adaptive delays in Wharf animation to account for rendering
   overhead for tiles; Added new feature to Wharf - *WharfFocusedTile MyStyle,
   making wharf behave similar to a menu - changing color of active tile when
   pointer is over it

[2004-08-13: sasha]
 * fixed bug in asstorage causing segfaults if block is used completely;
   Improved Wharf's handling of animation - should now be much smoother

[2004-08-12: sasha]
 * fixes to docs to format properly into PHP. Fixes to AsDocGen to have nice
   indexes and proper references from devel docs to user and back

[2004-08-12: madarche]
 * Updating file's doc + NoTitle, NoHandles for XMMS playlist since XMMS has
   its own look

[2004-08-11: sasha]
 * add deps to ASDocGen
 * Implemented new generated doc installation in Makefiles, added more
   libAfterImage docs, fixed formatting in asimage.h and asfont.h

[2004-08-10: sasha]
 * Fixed bug in ASStorage causing negative sizes in slots and as the result
   garbadge in images
 * Fixed bug in ASStorage causing negative sizes in slots and as the result
   garbadge in images

[2004-08-09: sasha]
 *  fixed segfault bug in transform.c if image creatrion fails
 * fixed some docs generation
 * updated to produxce better organized indexes; Fixed bug in literal handling;
   Moved over description of the database config from xml into ASDocGen

[2004-08-06: sasha]
 * added some docs
 * added xml source for documentation into CVS and updated Look in libAfterConf
   to be same as in src/afterstep/configure.c

[2004-08-05: sasha]

[2004-08-03: sasha]
 * added Outline functionality to the MyStyle code
 * Implemented 3 new types of text: OutlineAbove, OutlineBelow, OutlineFull
   that does outlining of text, also enabled alpha tinting of the text at the
   time of rendering

[2004-08-02: sasha]
 * added memory cleanup code to ascompose, and added missing free calls to
   storage destruction code
 * fixed thresholding code in asstorage needed for rectangular shape stuff
 * Improved reference counting in ASStorage to accomodate to wierd storage
   states where some blocks have no space left for reference

[2004-07-30: sasha]
 * reimplemented image reading using new functionality of ASStorage using
   bitmap stuff and grayscale images using reference counters
 *  fixed handling of the menu size calculation - wrong style was used

[2004-07-29: sasha]
 * debugging the size of AS menus; added storage printing function

[2004-07-28: sasha]
 * disabled debug output
 * rewrote ASImage contents storing code to utilize generic ASStorage
 * added 32bit store function

[2004-07-23: sasha]
 * completed implementation of ASStorage, including compression scheme for
   bitmapped data

[2004-07-21: sasha]
 * Completed implementing RLEDIFF compression and ; Completed debugging of
   asstorage with RLE DIFF compression

[2004-07-20: sasha]
 * implemented decompression
 * Implemented RLE diff compression code in ASStorage

[2004-07-16: sasha]
 * started implementing compression using zlib

[2004-07-15: sasha]

[2004-07-14: sasha]
 * applyed patch from CaT(tm) :) implementing sorting order by alpha in winlist
   menu and winlist menu without icons
 * completed debugging and implementing asstorage

[2004-07-14: born2late]
 * some changes to better fit wao
 * animate and base updates

[2004-07-13: sasha]
 * Implemented and debugged storage defragmentation; Moved xml parser enums
   back to .h and added missing typedefs
 * Fixed guarded memory handlinbg for blocks of whole number of pages; Debugged
   some of the aspects of ASStorage memory handling - must implement
   defragmentation now
 * changed /ML flags to /MD ( based on Bertrand Bellenot suggestion)
 * accepted patch from Bertrand Bellenot (Root) for libAfterImage under Win32;
   Updated MSVC project files with new files

[2004-07-13: born2late]
 * updated wharf, feel and look docs

[2004-07-12: sasha]
 * debugged storage storing, started implementing fetching
 * added better testing code

[2004-07-09: sasha]
 * partially debugged ASStorage implementation
 * Added xmlized doc sources
 * added temporary XMlized versions of man pages to be transfeormed into
   ASDocGen stuff

[2004-07-07: sasha]
 * storage splitting

[2004-07-06: sasha]
 * ASAStorage slot selection code added
 * Continued implementation of ASStorage
 * implemented test container for asstorage ala XP

[2004-07-05: sasha]
 * started implemnting proper storage for ASImage data

[2004-07-04: sasha]

[2004-07-03: sasha]
 * Updated configure scripts; spilt image decoder/encoder from asimage - need
   to rearrange to get it to order
 * done most of the coding required for proper handling od static ASImages

[2004-07-03: madarche]
 * - Added a new example of tiling: tiled gradient - Reorganized the file so
   that the first code snippet is the simpler and then   following examples
   become harder.
 * - made the given examples to be valid XML - corrected the typography so that
   it's correct English typography, there   shouldn't be any space before a
   ":".

[2004-07-02: sasha]
 * implemented crosslinking docs

[2004-07-01: sasha]
 * fixed flush_ashash, to properly clear members
 * fixed segfault in ASDocGen index generation and possibly fixed bug in
   flush_ashash
 * implementing urls for keywords, intellifgent handling of the NAME section,
   etc.

[2004-06-30: sasha]
 * Added nested subsections, partly debugged quotations, other doc gen tweaks

[2004-06-29: sasha]
 * progress in implementing static ASImages
 * processing of robodoc comments mostly works - need to add some fine- tuning
   to generate URLs, section titles, and possibly varlists

[2004-06-28: sasha]
 * debugging handling of robodoc comments in source files

[2004-06-25: sasha]
 * prototyped doc generation for robodoc comments

[2004-06-24: sasha]
 * Rearranged ASDocGen code so its more manageable, and started implementing
   doc generation using robodoc comments inside the sources
 * Disabled stripping of binaries when enable-gdb is requested
 * fixed bug in debug prints in mylook.c visible on solaris

[2004-06-23: sasha]
 * Implemented NROFF formating of generated docs, and updated Look config in
   libAfterConf

[2004-06-21: sasha]
 * added support for UTF-8 when its requested in LC_LANG setting

[2004-06-18: sasha]
 * Added html stylesheets to embedded in docs
 * beautification of the PHP and HTML code

[2004-06-17: sasha]
 * Implemented Glossary for PHP and implemented Index

[2004-06-16: sasha]
 * Completed implementing Glossary generation in ASDocGen, also fixed some ugly
   HTML code generation

[2004-06-15: sasha]
 * Implemented splitting PHP docs into separate files for each module
 * Implemented splitting PHP docs into separate files for each module

[2004-06-15: madarche]
 * Corrected minor typos, essentially to check my newly available write access
   :-)

[2004-06-14: sasha]
 * debugging ASDocGen segfault
 * implementing multifile php generation

[2004-06-11: sasha]
 * Added PHP fuunctionality to doc generation

[2004-06-10: sasha]
 * improvements for memory consumption using mirrored tiles
 * added new totals to audit memory printing
 * added xml tag <release> so that temporary images could be unload to free up
   some memory
 *  completed debugging Titlebar Layout setting in MyFrame
 * Implemented XML output in ASDocGen and perfected generation and HTML

[2004-06-09: sasha]
 * debugging TitlebarLayout - compile_tbar_layout does not work right
 * Implementing document generator into HTML format
 * fixed bug in ImageManager creation when getenv may return NULL for
   IMAGE_PATH

[2004-06-08: sasha]
 * Fixed race condition with modules using LOCKONSEND and display being grabbed
 * added ability to XML parser to recognize known tags; Added framework code
   for converting source xml into html docs to ASDocGen
 * Began implementing documentation generation system

[2004-06-07: sasha]
 * Fixed initial desk/viewport setting upon startup
 * fixed background reloading on colorscheme change

[2004-05-24: sasha]
 * fixed scaling algorithm to properly scale images with height <= 3

[2004-05-21: sasha]
 * Completed updating for Audio module

[2004-05-20: sasha]
 * Implemented new feature allowing changing order of items in titlebar -
   LeftTitlebarLayout and RightTitlebarLayout in MyFrame; Fixed bug in
   place_aswindow where it would never default onto manuall placement causing
   big windows to be silently killed without displaying them; Fixed bug in
   custom colors cleanup code to not treat color values as pointers; Updated
   docs and xml image docs in particular from patch submitted by
   ma.darche@cynode.org; Added Audio config to libAfterConf, and copied Audio.c
   from experimental branch, in order to convert it to 2.0

[2004-05-19: sasha]
 * Completed Animate porting - configuration file is installed now, and
   deiconification animation is good
 * completed debugging Animate module

[2004-05-18: sasha]
 * updated dependancies, and completed reimplementing Animate module - still
   needs some debugging though
 * fixed erroneous uncommented line in shared memory XImages

[2004-05-17: sasha]
 * began updating to 2.0 stuff
 * cleaned up C++ comments

[2004-05-14: sasha]
 * completed debugging of fast desktop switching using pixmap caching on server
 * completed debugging of fast desktop switching using pixmap caching on server

[2004-05-13: sasha]
 * debugging background changing
 * hopefully fixed detection of freetype library on debian sarge

[2004-05-12: sasha]
 * updated configure scripts and partly fixed freetype autodetection for debian
   - still need ft2build adding to freetype.h detection code
 * implemented fast(er) desktop switching by caching background pixmaps - there
   are some quirks that needs to be ironed out still

[2004-05-11: sasha]
 * fishing out segfault in get_text_size
 * Implemented memory debugging under cygwin and fixed discovered bug in
   MyStyle parsing

[2004-05-10: sasha]
 * debugging memory audit
 * Implemented Transient button functionality in Wharf, missing from 1.8

[2004-05-07: sasha]
 * minor TODO changes

[2004-04-29: sasha]
 * Implemented ability to use tab stops while drawing text, and cleaned up new
   api calls; Fixed Wharf Bevel setting

[2004-04-19: sasha]
 * Implemented ability to load any font as monospaced using scaling of glyphs
   and other techniques, making it possible to use libAfterImage for text
   output in applications such as text editors and terminal emulators

[2004-04-16: sasha]
 * Debugged Bookmarking mechanism- was forgetting to create a copy of bookmark
   string while storing it in hash table

[2004-04-15: sasha]
 * Fixed Wharf bevel and Align options to be flag and not print silly warnings
 * updated default look/feel/background in non-configurable of the distro to be
   the same as in other places
 * Fixed bug in handling of Viewport setting in database when only one of the x
   or y is set.It was using X set flag for y value and wise versa

[2004-04-12: sasha]
 * Updated NEW file to eliminate typhos and syntax errors (contributed)

[2004-04-06: vae]
 * patch to fix sandbox issues (gentoo)

[2004-03-31: sasha]
 * Fixed potential segfault in asfont.c when font is NULL; Fixed including of
   afterbase.h in asapp.h to be done only when compiled as part of AfterStep

[2004-03-30: sasha]
 * Added another subfolder for background images - 4 mirrored tiles as
   suggested on AS ML
 * fixed potential compile problem in DEBUG statememnt that comes up on some
   wird compilers, notably on Solaris 2.5

[2004-03-29: sasha]
 * Debugged Restart functionality to prevent AS from crashing

[2004-03-22: sasha]
 * Fixed segfault when compiled with --enable-different-looknfeels due to
   attempted config loading before initialization of AS is complete

[2004-03-19: sasha]
 * added includes for xmd.h prior to jpeglib, to prevent multiple definitions
   of INT32
 * added missing include for system's zlib.h in png.h
 * removed unneeded io.h from libungif

[2004-03-18: sasha]
 * removed XPM versions of images, as we now have libPNG embedded into
   libAfterImage
 * Found and fixed very wierd heap corruption bug, causing segfault whenever
   bevelled rectang is drawn
 * Added builtin libungif to libAfterImage, and enabled support for it by
   default in configure

[2004-03-17: sasha]
 * added MSVC nmake  makefiles
 * Added aditional sanity checks to MyStyles property reading code, to make
   sure we do not go over the size of the buffer
 * fixed libAfterImage to properly handle path in win32

[2004-03-16: sasha]
 * fixed crashing on restart while destroying desktop cover objects
 * Incorporated libpng, libjpeg and zlib into libAfterImage, in case it is not
   available on the target system, or we are compiling under win32

[2004-03-11: sasha]
 * Completed implementing conversion from ASImage into DIB and implemented
   sample win32 image viewer application as an example and testbed.

[2004-03-10: sasha]
 * started implementing ASImage2DIB converter
 * moved some of the bmp functionality into bmp.c/h
 * removed 0x0D that came from MSVC porting
 * changes to make libAfterImage compile under MSVC in win32
 * began porting libAfterImage into win32

[2004-03-09: sasha]

[2004-03-08: sasha]
 * testing commit mailing
 * Fixed detection of running window managers at startup
 * Fixed detection of running window managers at startup

[2004-03-05: sasha]
 * AfterStep 2.00.beta4b Release
 * AfterStep 2.00.beta4 Release
 * Updated version to 2.00.beta4b
 * Fixed compilation in Feel.c with --enable-gdb; Fixed local selection if only
   the country is specified such as en_US - RedHat seems to have this; Fixed
   segfault in spawn_child with locale specified it was attempting to check if
   pointer is isspace() triggering bug in glibc

[2004-03-04: sasha]
 * AfterStep 2.00.beta4 Release
 * Fixed annoying type-punning warnings; Fixed annoying -rdynamic warnings on
   CYGWIN; Changed default compression ratio for screenshots to give very high
   quality; Fixed configure.in to properly work with latest autotools
   supporting PACKAGE_ stuff; Fixed configure to remove -g if enable-gdb is not
   requested; Fixed root image grabbing using overlay window to not use Backing
   Store; Fixed ascompose to set USPosition when geometry is requested; Fixed
   Banner to set its title ; Upgraded version to beta4

[2004-03-03: sasha]
 * Don't have to unmap Wharf folder at the end of animation
 * fixed theme dir perms.
 * Fixed Wharf animations
 * debugged Wharf's handling of RootClipArea, and enforced ConfigureNotify
   handling for folder to preceede buttons; Debugged WinList's handling of root
   background refreshes - must rerender buttons and canvas if transparent;
   Fixed handling of Root pixmap grabbing code to actually clip it to
   RootClipArea in mystyle.c

[2004-03-02: sasha]
 * Fixed handling of window functions selected from window's menu; Fixed
   look/Legacy to run properly; Fixed handling of cursor pointers - should be
   configured in feel, not in look
 * replacing image using binary format
 * replacing image using binary format

[2004-03-01: sasha]
 * better Banner
 * removed redundand ifdefs for I18N
 * debugged and optimized Banner and ascompose

[2004-02-27: sasha]
 * renamed Banner.in into Banner.sh.in
 * debugging Banner's makefile
 * added missing usage text to ascompose and fixed Makefile to install Banner
 * Implemented new Banner using ascompose
 * improved ascompose
 * debugged mask to rectangles list functionality in asimage.c

[2004-02-26: sasha]
 * added support for shaped windows to ascompose; Debugged channel->rectangle
   set conversion in libAfterImage - still have some vertical stripes
 * Fixed <rotate> tag in asxml to properly swap width and height in case of 90
   or 270 degree rotation
 * Fixed <rotate> tag in asxml to properly swap width and height in case of 90
   or 270 degree rotation

[2004-02-23: sasha]
 * fixed java window size bug

[2004-02-21: sasha]
 * Added old look.Legacy
 * added code to AfterStep to publish Image and Font path in env vars; Added
   feel.ICCCM that has no keyboard bindings; Added window centering code to
   ascompose; Added missing cursor definitions to look.QNX;

[2004-02-20: sasha]
 * Added ability to wait for data placed in X clipboard and then displaying it
   if its in XML format

[2004-02-19: sasha]
 * added ability to use same window for different images
 * fixed display closing when running in loop
 * added interactive error reporting functionality
 * added interactivity functionality to ascompose

[2004-01-31: sasha]

[2004-01-28: sasha]
 * Added check for free bsd and added /usr/local/include to cppflags
 * Fixed missing $ in check for not empty obj list
 * minor bug in detection of HAVE_DECL_ELFW - should check if its 0 or 1

[2004-01-27: sasha]
 * now hopefully workplace state restoration should work fine - fixed complex
   function name parsing, for cases when its nested within anopther complex
   function. Also added checks to not remove -g even if --enable-gdb is not
   specified ( due to requests from debian folks)

[2004-01-23: sasha]
 * debugging is_executable_in_path under OSX

[2004-01-22: sasha]
 * fixed handling of the window name change by application to update its hints
   flags and function mask; Fixed Wait function where window name  would differ
   from wait parameter
 * added ability to override RecentSubmenuItems in .include files; Implemented
   aditional logic in avoiding cover code to shift windows in most optimal
   direction only. Seems to fix problems with WinList and Pager fighting for
   the space

[2004-01-21: sasha]
 * fixed bug where empty locale would be specified while starting a module
   causing Pager to have 255 desktops and other wierdness
 *  yet another check of link.h header to fix compilation failures
 * fixed minor compile bug in wmprops.h WMPropsAtoms declaration

[2004-01-20: sasha]
 * added checks for required structures and types in elf.h for selfdiag code
 * added checks for required structures and types in elf.h for selfdiag code
 * added checks for required structures and types in elf.h for selfdiag code
 * added checks for required structures and types in elf.h for selfdiag code
 * added checks for required structures and types in elf.h for selfdiag code

[2004-01-14: sasha]
 * fixed handling of client window context when mouse is pressed inside
   client's subwindow
 * updated NEW with recent changes
 * hopefully fixed situation when one could not change the background, when it
   was not unloaded due to small enough size

[2004-01-13: sasha]
 * fixed bug in shared image variant of background xfer
 * further performance tweaks for root background transfer. Added config option
   to disable it (DontAnimateBackground)
 * disabled animating for tiled pixmaps as it seems to cause slowness
 * converted cover sliding to use timers, tweaked background transfer to do a
   nicer animation

[2004-01-12: sasha]
 * hopefully optimized ximage transfer by using reusable memory and added
   ability to postpone background switching task to be done later
 * fixed MyStyles in Pager and button sizing in WinList

[2004-01-08: sasha]
 * cleaned up canvas.c so it depends on absolute minimum of other parts of
   libAfgterStep, and we can extract it and reuse in aterm and other apps
 * fixed libAfterStep installation procedure and some of the headers to make it
   useable in external apps

[2004-01-07: sasha]
 * Split ASCanvas code from Tbar for convinience

[2004-01-06: sasha]
 * fixed get_font to not crash when X is missing; Fixed ascolor to not open any
   connections to AS when -n option is used

[2004-01-05: vae]
 * fixed database conflict with gaim

[2004-01-02: sasha]
 * Fixed keyboard presses handling to not require window selection when there
   is a focused window; Updated .spec file to better handle libraries and stuff
   ( thanks to Andre Costa )

[2003-12-23: sasha]
 * AfterStep 2.00.beta3 Release
 * AfterStep 2.00.beta3 Release
 * Fixed README.SOLARIS and libAfterImage's Makefile if's

[2003-12-17: sasha]
 * added width/height value "proportional" to <scale> tag to keep image ratio
   while scaling

[2003-12-10: sasha]
 * cleaned up configure script from unused defines and got rid of acconfig.h as
   required by autoconf 2.57; Added check for _Xsetlocale to disallow
   --enable-xlocale when its not available in Xlib

[2003-12-09: sasha]
 * got rid of Wait3 testing in configure - should speed it up a bit

[2003-12-08: sasha]
 * fixed handling of trailing whitespace at the end of the tag in XML processor
 * added support for C control codes in printf format strings in asxml, added
   safeguards to check for proper number of parameters in printf format string
 * fixed support for input from stdin and output onto stdout in ascompose

[2003-12-05: sasha]
 * Cleaned up configure to not have ugly -I.. -I../.. and not do any detection
   of libAfterImage/Base - we should always use what we came distributed with
 * fixed without-x compile problem in asvisual.c
 * fixed stddef.h bug in libAfterBase and without-x compile problem in
   asimage.c
 * added <print> tag to asimage xml to enable output of internal variables such
   as image size

[2003-12-04: sasha]
 * Fixed extern in autoconf.h to compile in any combo of headers

[2003-12-03: sasha]
 * added afterstep-config

[2003-12-02: sasha]
 * Added common ASConfig that includes all the AfterStep config syntaxes

[2003-12-01: sasha]
 * Added new database option : LongLiving and ShortLiving: ShortLiving windows
   are always placed automatically and do not affect AvoidCover stuff.
   Hopefully fixed bug where transient windows would not get autoplaced
 * Fixed segfault when withdrawn window's outdated PropertyNotifys are handled
   for WM_NAME

[2003-11-28: sasha]
 * added afterimage-config

[2003-11-27: sasha]
 * Fixed handling of root background when only one desk has image defined for
   it

[2003-11-21: sasha]
 *  fixed compilation with i18n enabled; Fixed NET_SUPPORTING_WM_CHECK stuff to
   hopefully satisfy Open Office

[2003-11-18: sasha]
 * added docview model prototype for ascp
 * Completed implementing desktop cover and progress display for long
   operations

[2003-11-14: sasha]
 * Added cover window to meaningfully show user that AfterStep is reloading
   config or starting up or doing anything else that takes time
 * split ascp to have 2 front ends - gtk and fltk
 * Fixed unsigned math problem in calculating cliw size of the label

[2003-11-13: sasha]
 * replaced AfterStep logo with better PNG one
 * Fixed ViewportX and ViewportY swapping; Fixed transparency rendering to
   account for bevel outline offset
 * fixed problem with long text overlapping bevel

[2003-11-12: sasha]
 * Fixed layout code to properly align backgrounds and buttons on vertical
   titles, as well as spacing and margins for buttons
 * Fixed snapping for AvoidCover windows to not stop 1 pixel away from the
   window

[2003-11-10: sasha]
 * debugged Pager's placement. Debugged frame subwindows when NoHandles is
   requested; Still Debugging why there is a gap between windows while
   move/resizing to near Pager

[2003-11-07: sasha]
 * Added ActiveDeskBevel and InActiveDeskBevel to Pager's options; Debugged
   bevel drawing when tbar has different bevels for focus and unfocus states(
   should get rid of wierd black frame when one of the states is None)

[2003-10-22: sasha]
 * Implemented new feature allowing titlebars being smaller then the size of
   the window: CondenseTitlebar Left|Right|Center in MyFRame
 * Fixed bug in bar layout code that would incompletely allocate spare space
   between resizable columns/rows with more then two of those

[2003-10-21: sasha]
 * Most of WinTabs is done - need to figure out some of the transparency stuff

[2003-10-20: sasha]
 * added focus switching

[2003-10-18: sasha]
 * added code for withdrawing when there are no swallowed windows

[2003-10-15: sasha]
 * Implemented tabs layout code for WinTabs. Implemented tabs removal on
   DestroyNotify

[2003-10-10: sasha]
 * added code to avoid placing windows where AvoidCover windows are on initial
   placement
 * implemented checking for other AvoidCover windows, prior to letting window
   move resize/place itself - thus fixing problem with Wharf messing up WinList
   on withdrawing
 * fixed bug in Pager where it would always startup with one desk, as it was
   stupid enough to check for desk number to begin with space

[2003-10-09: sasha]
 * Fixed Pager layout problem when number of desks does not match config file;
   Fixed Pager sizing when there are more then 1 column; Fixed swallowed window
   size handling in Wharf to honor ConfigureRequests; Fixed synthetic
   ConfigureNotify sending in Wharf to do it when size has not change; Fixed
   command line parsing in Pager to handle args passed in by AS; Fixed bugs
   introduced while fixing 64-bitness in XChangeProperty

[2003-10-08: sasha]
 * Hopefully fixed 64-bitness problems in XGetProperty
 * make sure get_caller_func() does not return NULL
 * make sure get_caller_func() does not return NULL
 * fixed nasty bug preventing AS from working on louse 8bit displays ( many
   thanks to heviarti)

[2003-10-07: sasha]
 * Moved window data name fetching by type into aswindata, and started
   implementing swallowing in WinTabs
 * corrected Makefiles and fixed compile bugs in WinTabs prototype
 * updated configure to create Makefile in src/WinTabs
 * Added prototype and configuration parsing for new WinTabs module;
   Implemented proper shape clearing
 * Added prototype and configuration parsing for new WinTabs module;
   Implemented proper shape clearing

[2003-10-06: sasha]
 * fixed problem with shape not properly cleared as look changed

[2003-10-03: sasha]
 * Implemented new look.QNX with all the supporting files; Added ability to
   separately configure layout of buttons on the left and right (spacing and
   offsets);Updated database to remove extra buttons from the menus

[2003-09-26: sasha]

[2003-09-25: sasha]
 * AfterStep 2.00.beta2 Release
 * AfterStep 2.00.beta2 Release
 * AfterStep 2.00.beta1 Release
 * AfterStep 2.00.beta2 Release
 * AfterStep 2.00.beta2 Release
 * Some minor tweaks to cursor coloring and HSV manipuylation for grayscale
 * Implemented automagic generation of the ChangeLog
 * generating ChangeLog

[2003-09-24: sasha]
 * Completed look.Glass ; renamed PointerFore, PointerBack to CursorFore,
   CursorBack to match old Cursor option; Moved Cursor definitions from feel
   into look Completed Colorscheme's support for Cursor's color

[2003-09-23: sasha]
 * Added look options for mouse pointer coloring: PointerFore and PointerBack;
   Repaired code to update window's decorations when stickiness flag is
   toggled;

[2003-09-22: sasha]
 * Added cursors to default feel file; enable cursor switching while hovering
   over different elements of the interface; Added code to change color of the
   cursor according to what colorscheme is set to - may need to tweak a bit ,
   or make colors configurable
 * Fixed locale parsing from LANG variable; Fixed module startup to pass on
   current locae specified on command line

[2003-09-19: sasha]
 * added debugging code for cursor loading

[2003-09-16: sasha]
 * fixed bug with windows teleporting back to original position, if
   moved/resized too fast

[2003-09-15: sasha]
 * updated configure scripts
 * Fixed configure.in to properly enable i18n in libAfterImage as requested.
   Internationalized text should be displayed properly now, even if its not in
   UTF8; Update src/test to work with new libs and added test code for i18n
   testing
 * Fixed unquoted string in i18N code reported by Alex Mezin

[2003-09-14: sashav]
 * Added checks for locale and proper initialization of libAfterImage t3ext
   drawing in accordance to its value; Fixed problem with EdgeScroll being
   mangled when just look changes; Fixed recently introduced bug causing wierd
   corners in framned windows upon the look change
 * Fixed typoe for msg type in SendString being declared as some wierd type of
   unsigned long long  - possibly causing wierdness on 64 bit machines

[2003-09-13: sashav]
 * implemented feedback functionality via sending the e-mail to sasha :)

[2003-09-12: sasha]
 * added configure option to send e-mail back to developer on installation;
   Fixed canvas border width handling while resizing and in Pager;

[2003-09-11: sashav]
 * fixed handling of WM_PROTOCOL changes where WM_COMMAND would get lost and
   session management would stop working; Found bug with huge impact - all the
   geometry calculations were off as we were forgetting border width of the
   frame window; Fixed handling of button presses on border of the frame

[2003-09-10: sashav]
 * Fixed workspace state save/restore to allow terms to exec command using -e,
   and to have argv's with spaces in them; Fixed frame corner sizing to make it
   same width as is tbar size;

[2003-09-10: sasha]
 * fixed NeXTish colorscheme somewhat
 * Fixed workspace state save/restore to allow terms to exec command using -e,
   and to have argv's with spaces in them; Fixed frame corner sizing to make it
   same width as is tbar size;

[2003-09-09: sashav]
 * More fixing Pager's geometry; Added -i cmd line parameter to ascompose to
   allow for 'include' files (such as colorschemes, etc.); Updated configure
   scripts to properly detect headers when its run from libAfterBase; Updated
   version to beta2; Updated TEAM file

[2003-09-08: sasha]
 * Fixed Pager to properly account for label size while sizing min-desktop
   windows
 * Fixed Pager to properly account for label size while sizing min-desktop
   windows

[2003-09-07: sashav]
 * somewhat debugged Pager's geometry handling - need to add some code to
   properly recalculate Pager's geometry if its soecified as ratio of the main
   desktop vs. exact geometry

[2003-09-03: sasha]
 * added new AfterStep log icon; fixed wharf config file

[2003-09-02: sasha]
 * added new xml tag : <color> to define symbolic color names
 * changed handling of tiled images to clip it properly when Right/Left align
   is used

[2003-08-30: sashav]
 * debugged workspace state handling code, and improved Wait loop

[2003-08-29: sasha]
 * mostly implemented new workspace state saving and restoring

[2003-08-28: sashav]
 * more 64 bit fixes

[2003-08-28: sasha]
 * fixed workspace status generator to not save xrm params, as noone seems to
   support thoise
 * added caching of pixmaps for unfocused bas in window decorations to speed up
   fast focus switching
 * 64-bit fixes: CARD32 instead of Window type
 * 64-bit fixes: CARD32 instead of Window type
 * 64-bit fixes: properties and strlen warnings
 * 64-bit fixes: converted intermodule communications to always use 32bit
   values
 * more 64 bit fixes

[2003-08-27: sashav]
 * 64-bit compilation fixes
 * synching
 *  fixed segfaulting in Pager on look switches or after window restacking
 * Fixed handling of hints flags - it was doing nothing before if flags == 0 -
   was screwing MOtif Hints like totatlly; Fixed shaped window handling in
   WinList; Added check to not do too much redrawing when WinLIst is receiving
   window list - may want to do the same in Pager

[2003-08-27: sasha]
 * 64-bit compilation fixes
 * Fixed slowness in intermodule communications manifesting itself when
   desktops are switched
 * fixed handling of non-default MyBackgrounds, and proper adding of
   DeskConfigs while switching desks
 * synching
 *  fixed segfaulting in Pager on look switches or after window restacking
 * Fixed handling of hints flags - it was doing nothing before if flags == 0 -
   was screwing MOtif Hints like totatlly; Fixed shaped window handling in
   WinList; Added check to not do too much redrawing when WinLIst is receiving
   window list - may want to do the same in Pager

[2003-08-26: sasha]
 *  added parameters to import funcions, to allow for sized image/preview
   stuff; Removed compression buffer from ASImage structure to save up some
   memory; Hopefully fixed hints handling on 64 bit hw

[2003-08-24: sashav]
 * fixed event handling when windows is getting mapped - no more lost events
   due to not selected mask ; Fixed initial status when mouse pointer is out of
   the screen; Fixed ICCCM size hints handling to have BaseSize and MinSize
   interchange each other when one is ommited - fixes GIMPs initial placement

[2003-08-23: sashav]
 * added new 3 icons to complete the set of default icons: switched AfterStep
   to use ~/.afterstep instead of ridiculous ~/GNUstel/L/A stuff

[2003-08-22: sasha]
 * Fixed handling of shaped windows - shape is not erroneously cleared, and
   client's shape is subtracted from decoration's shape
 * fixed autodetection of zipped xpms and added 6 more icons to default iconset

[2003-08-21: sashav]

[2003-08-21: sasha]
 * more improvements to asimbrowser

[2003-08-20: sasha]
 * fixed makefile for ascp, when fltk is not found; added better Style for
   BitchX to database; remnoved scrollbar from BitchX in Wharf
 * implemented html generator for icons list (asimbrowser); TODO: replace all
   asimage_decode_line with Image Output thingy, or implement support for
   back_color

[2003-08-19: sasha]
 * implemented image list loading from dir listing
 * fixed Pager fighting with WinList for space. Fixed a bug in status
   initialization where Layer would be changed to 10000 no matter what is set
   in database

[2003-08-18: sasha]
 * Fixed ability to have different backgrounds on different desktops by default
 * configure regenerated
 * changes to configure to properly handle user set LDFLAGS
 * configure regenerated
 * changes to configure to properly handle user set LDFLAGS
 * configure regenerated
 * changes to configure to properly handle user set LDFLAGS
 * configure regenerated
 * changes to configure to properly handle user set LDFLAGS

[2003-08-17: sashav]

[2003-08-16: sashav]
 * fixed segfault when desk is switched out oif Pager's scope
 * fixed compile on FBSD due to double semicolon
 * fixed compile bug when dirent.h is in sys/dirent.h
 * hopefully fixed situation where Pager crashes as destroyed window is still
   being referenced by the desk

[2003-08-15: sashav]
 * applied 5 patches from Stasinos Konstantopoulos
 * more work on compilation issues, notably fixed errors on old debian 2.2

[2003-08-15: sasha]
 * applied 5 patches from Stasinos Konstantopoulos
 * configure
 * configure
 * updated configure scripts to autoconf 2.57
 *  more messing aruound with system headers and compilation
 *  more messing aruound with system headers and compilation
 * updated configure scripts
 *  more messing aruound with system headers and compilation
 * updated configure scripts
 *  more messing aruound with system headers and compilation
 * more work on compilation issues, notably fixed errors on old debian 2.2

[2003-08-14: sashav]

[2003-08-14: sasha]
 * adjusted wharf's timings
 * disabled gif/ungif by default
 * disabled gif/ungif by default - needs to be reenabled manually
 * compilation warnings fixed
 * updated configure
 * hopefully fixed all the strict aliasing breakage errors with newer gcc

[2003-08-13: sasha]
 * bugfixes in Pager and Wharf, and fixed handling of malloc.h
 * Fixed handling of the shape while switching colorschemes/looks
 * fixed minimization when Icon box is too small; Fixed partial maximization
 * fixed minimization when Icon box is too small; Fixed partial maximization
 * fixed compilation bugs while using specs in RH

[2003-08-12: sasha]
 * removed offending varargs include that was not needed anyways, but was
   breaking compile with gcc 3.3.1

[2003-08-11: sashav]
 *  cleanup in preparation to beta1 release

[2003-08-11: allanon]
 * fail gracefully if merge is requested and no images can be loaded

[2003-08-10: sashav]
 * menu cleanup and Pager shape cleanup too

[2003-08-09: sashav]
 * added cleanup code for shared memory

[2003-08-08: sashav]

[2003-08-08: sasha]
 * added doc files
 * added safety check for shared memory utilization
 * added safety check for shared memory utilization
 * added safety check for shared memory utilization

[2003-08-08: allanon]
 * install xml files individually; copying "*" includes directories, which
   causes the copy to fail
 * install.doc now works in directories which have no docs

[2003-08-07: sasha]
 * fixed bug in ASImage to shape conversion causing disappearing titlebars in
   glass look
 * Fixed bug in window movement resizing when wviewport is switched in the
   middle - window stays on old viewport now. Cleaned up old unused files.

[2003-08-01: sasha]
 * rewrote shaped windows handling to use rectangles everywhere, and
   intelligently merge them together, thus greately reducing memory utilization
   and avoiding flickering and other nasty artifacts. That's it, last commit
   before beta1 release :) - I'm off for vactaion, coincedentally :)

[2003-07-30: sasha]
 * Fixed initial menu placement to keep entire menu frame on the screen
 * fixed avoid cover window shifting to keep windows on current viewport; Fixed
   frame shape handling to allow for proper shade animation with shaped frames;
   Fixed WinList obeing MaxSize and MinSize

[2003-07-29: sasha]
 * added bunch of ascs vaiables for asxml to allow for hsv transformation of
   various colors

[2003-07-25: sashav]

[2003-07-25: sasha]
 * Fixed window manager's restarting and manager's selection handling; Fixed
   sleep_a_little thingy; Fixed menu mapping and mouse overing

[2003-07-24: sasha]
 * makefile fixes and firestreak background fix
 * added missing .depend file
 * added minipixmap to colorschemes menu; ascolor can now write out minipixmap
   xml file
 * Completed and debugged implementation of scrollable menus; Fixed
   transparency updating on frame move in tbars; Added minipixmaps to
   Plain_Textures backgrounds menu

[2003-07-23: sasha]
 * added feature allowing for the menu minipixmaps to come from files with
   specified extension, such as .mini

[2003-07-22: sasha]
 * done for the day
 * added few more backgrounds to satisfy those who like simple stuff
 * fixed error message while trying to load X11 font with part of the name
   truncated as the result of size parsing
 * fixed error message reporting improper use of
   TitleButtonBalloonBorderColor/Width

[2003-07-21: sashav]
 * added plain texturesbackgrounds; Fixed Makefile for image files installation

[2003-07-21: sasha]
 * fixed bug in frame resizing where upper corners would grow larger; Fixed bug
   with initial window mapping when using rubberband to place window
 * added plain texturesbackgrounds; Fixed Makefile for image files installation

[2003-07-19: sashav]
 * fixes to shading and window resizing
 * fixed look.Glass

[2003-07-18: sashav]
 * completed implementation and debugging of shared memory extensions use in
   afterstep proper; Fixed compression of xml images - save a bundle or root
   pixmaps

[2003-07-18: sasha]
 * Completed implementing frame in look.Glass. Fixed bugs in HSV conversion in
   color parser
 * completed implementation and debugging of shared memory extensions use in
   afterstep proper; Fixed compression of xml images - save a bundle or root
   pixmaps

[2003-07-17: sashav]
 * completed implementation of support for shared memory XImages

[2003-07-17: sasha]
 * fixed several titlebar layout problems and more look.Glass development
 * Fixed bug in asimage2ximage where asv->dpy was used instead of asv; Fixed
   bug in Pager's handling of folders while checking availability
 * completed implementation of support for shared memory XImages

[2003-07-16: sashav]
 * updated configure; wharf config

[2003-07-16: sasha]
 * added look.Glass (look-alike of 23 Oz Glass E theme); Fixed shaped windows
   bug in mystyle image rendering (alpha channel was being lost); Added ability
   to adjust hsv of the color; fixed bug in window decorations handling -
   background images
 * updated configure; wharf config

[2003-07-15: sashav]
 * mostly completed wharf config

[2003-07-15: sasha]
 * implemented better support for shaped titlebars - titlebar could be
   assembled from 5 parts now.
 * fixed configure and updated wharf looks a bit
 * mostly completed wharf config

[2003-07-14: sashav]

[2003-07-14: sasha]
 * menu handling of NOP items - should be shown as disabled; wharf config
   cleanup
 * added icons for terms and added better availability check to Wharf and
   AfterStep - Wharf now allows to choose from one of the icons

[2003-07-12: sashav]
 * added code for fallback in case /tmp is not writable and we need to create
   socket. Fixed workspace_state writing for terms to use SizeInc hints in
   geometry

[2003-07-11: sasha]
 * Implemented 3 more functions: TakeScreenShot, TakeWindowShot and
   TakeFrameShot, as the side effect of debugging root background handling.
   Updated feel.DEFAULT to use those
 * fixed bug in inheritance code where back_icon would get destroyed even if it
   was inherited, thus causing wierd things to happen when same style is
   inherited twice; Added code to mystyle_make_image to ensure that we always
   produce valid ASImage
 * fixed frame canvas mapping when look is changed from no frames to frames

[2003-07-10: sasha]
 * frames debugging
 * created transparency look (colorschemable)
 * frames debugging
 * avoidCover window now pushes other windows out when its   first placed, or
   when its resizing self
 * avoidCover window now pushes other windows out when its   first placed, or
   when its resizing self

[2003-07-09: sasha]
 * Made WinList coming up without the titlebar by default

[2003-07-08: sasha]
 * rewrote mystyle parsing so that modules should parse them properly too;
   Fixed window move resizing , so that AvoidCover windows don't avaoid self
   (reported by Vaevictus); Fixed pointer movement handling in menu, so that if
   submenu is opened and pointer mover real fast - submenu don't disappear;

[2003-07-03: sasha]
 * Fixed AfterSTep segfault on window withdrawing self while being placed

[2003-07-01: sashav]
 * continued development of the xshmimages

[2003-07-01: sasha]
 * Fixed bug in Motif hints handling causing Mozilla to not have decorations -
   function hints where interpreted even if not set
 * fixed uninitialized ximage pointer usage in create_visual_ximage
 * continued development of the xshmimages

[2003-06-30: sasha]
 * fixed shmem autodetection
 * added support X Shared Memory Image extensions ( mostly ) ;
 * fixed shmem autodetection
 * added support X Shared Memory Image extensions ( mostly ) ;
 * added support X Shared Memory Image extensions ( mostly ) ;

[2003-06-28: sashav]
 * Fixed wicked bug in stacking order handling where new window would get put
   into the bottom of the stack instead of to the top of it, while visually
   being on top; Fixed slowness inmenu item selection that has been bothering
   MG_Tak and some other ppl for long time - thank you all for persistence in
   bugging me :); Fixed slowness in window movement/resizing(same as slowness
   in menus :)

[2003-06-27: sashav]
 * Fixed handling of xv's crazy WM_HINTS changing and overal;l hints changing;
   Fixed out of bounds memory access in make_file_name and
   picture_ximage2asimage; completed support in configure for X Shared Memory
   images

[2003-06-27: sasha]
 * added About menu
 * Fixed handling of xv's crazy WM_HINTS changing and overal;l hints changing;
   Fixed out of bounds memory access in make_file_name and
   picture_ximage2asimage; completed support in configure for X Shared Memory
   images

[2003-06-26: sasha]
 * started improving hint change handling
 * fixed semitransparent gradients in Pager
 * Fixed bug in libAfterImage causing garbadge in gradients 1 pixel wide

[2003-06-25: sasha]
 * Fixed transparent gradient drawing to do alphablending instead of allanon;
   Fixed menu to not show underscores; Fixed menu look update; Added feature to
   Wharf to verify that Exec command commands are actually available in PATH;
   Fixed balloons drawing to withdraw them as pointer leaves the window

[2003-06-24: sashav]
 * Updated TTF fonts to the latest version - has glyphs for some new characters

[2003-06-24: sasha]
 * Updated Wharf and WinList to track changes in AfterStep styles and
   olorscheme; Updated look.DEFAULT somewhat
 * Updated TTF fonts to the latest version - has glyphs for some new characters

[2003-06-23: sasha]
 * made afterstep UTF-8 aware.

[2003-06-21: sashav]
 * debugged UTF8 rendering with libAfterImage and Default.ttf font

[2003-06-20: sashav]
 * Fixed bug in unicode character drawing causing segfaults

[2003-06-20: sasha]
 * fixed UTF8 char size calculation
 * Fixed bug in unicode character drawing causing segfaults

[2003-06-19: sasha]
 * Fixed transparency handling when semitransparent gradients are used; Updated
   default colorscheme to have sticky and normal colors being more different
 * added 8 new backgrounds from propaganda set, added Smooth and SimpleTexture
   backgrounds; fixed gradient color generation in colorscheme code to use
   mopre difference
 * rearranging backgrounds

[2003-06-18: sasha]
 * implemented style update and colorscheme update in Pager
 * some improvements to Pager config; Finally fixed segfaulting when window
   being dragged gets destroyed

[2003-06-17: sasha]
 * Fixed broadcasting of the window status change, so modules now know when
   window becomes sticky; Optimized desk/viewport switching to avoid too many
   messages being sent - it all now could be done at once - both desk and
   viewport changes, so that we should never get into desk 10000; Fixed
   handling of as-responce waiting in Pager
 * optimization of window moveresizing and geometry handling, to not broadcast
   too many messages

[2003-06-16: sasha]
 * debugging window moveresizing

[2003-06-15: sashav]
 * applied patch conytributed by cat@zip.com.au to make default values work
   with autoconf 2.50

[2003-06-13: sasha]
 * Fixed bug in wmprops.c where memory was realloced as if it was for char
   instead of long, causing crashes on desktop changes

[2003-06-10: sashav]
 * Fixed Pager's geometry handling when no desk title is used

[2003-06-07: sashav]
 * Changed default Feel to have more sensible EdgeResistance of 800; Fixed
   colormap loading code to properly set default angle; Fixed config loading
   code to reset images when look is changed ( by changing ImageManager );
   Fixed Stick/Unstick transition - it was shifting windows on non-zero
   viewports

[2003-06-06: sashav]
 * Fixed gradient type handling; Fixed PinMenu in feel for button 5; Added
   check for what side should be dragged when window is resized without
   pressing on the frame
 * Fixed gradient type handling; Fixed PinMenu in feel for button 5; Added
   check for what side should be dragged when window is resized without
   pressing on the frame

[2003-06-06: sasha]
 * implemented texture rotation for vertical titlebars
 * Fixed gradient type handling; Fixed PinMenu in feel for button 5; Added
   check for what side should be dragged when window is resized without
   pressing on the frame
 * Fixed gradient type handling; Fixed PinMenu in feel for button 5; Added
   check for what side should be dragged when window is resized without
   pressing on the frame

[2003-06-05: sashav]
 * modified mystyle_make_image to enable vertical images as needed
 *  fixed manual placement so that window's corner is at the mouse position
 * testing cvs emailing
 * testing cvs emailing
 * added missing icon

[2003-06-05: sasha]
 * gradient rotation code implemented for vertical titlebars
 * modified mystyle_make_image to enable vertical images as needed
 *  fixed manual placement so that window's corner is at the mouse position
 * testing cvs emailing
 * testing cvs emailing
 * added missing icon

[2003-06-04: sashav]
 * completed tweaking default look titlebar buttons

[2003-06-04: sasha]
 * created pressed buttons for the default look; Fixed bug in load_file where
   file would get opened twice
 * completed tweaking default look titlebar buttons

[2003-06-03: sasha]
 * redesigning default titlebar buttons
 * Implemented NoFocusOnMap database hint; Added opacity setting to solid tag
   in xml:

[2003-06-02: sasha]
 * minor fixes to xml parser
 * Hopefully fixed transparency handlingwhen window is partially off-screen
   (untested); Added capability to blend image with background even if SHAPED
   type is used;Hopefully improved responce time while dragging window around

[2003-05-31: sashav]
 * changed default colorscheme to Stormy Skies
 * added NeXTish colorscheme and changed default colorscheme color

[2003-05-30: sasha]
 * Mostly done with the default look and colorscheme stuff. Added code to
   generate NeXTish colorscheme as the default
 * Added several new attributes to composite and text tags for: text 3d type,
   align, vailgn ( in asxml handler ); Fixed text foreground image handling in
   asimagexml; Designed new default background as composite of gradient and old
   texture with text on top of it.

[2003-05-29: sasha]
 * Completed debugging of the ascolor app, and implemented suport for color
   schemes in Afterstep proper; Generated couple color schemes

[2003-05-28: sasha]
 * completed debugging colorscheme tools - need to check into way of
   calculating saturation and value

[2003-05-25: sashav]

[2003-05-23: sashav]
 * fixed bug where windows were reparented without consideration for its border
   width. Reported by MG_Tak. May happen in other places where we move top
   level frame of the window

[2003-05-23: sasha]
 * MOre work on colorscheme; It can now be saved and greyscale scheme could be
   generated
 * fixed bug where windows were reparented without consideration for its border
   width. Reported by MG_Tak. May happen in other places where we move top
   level frame of the window

[2003-05-22: sasha]
 * Makefile fixes to make libAfterImage and libAfterBase packageable for RedHat

[2003-05-21: sashav]
 *  fixed bug where unshaded windows would not have any focus

[2003-05-20: sashav]
 * removed XGrabServer from initial placement for better redrawing; Mostly
   fixed flickering and slow viewport changes; Still need to mod Wharf to
   update its clip area

[2003-05-20: sasha]
 * Implemented colorscheme parsing/writing (mostly)
 * removed XGrabServer from initial placement for better redrawing; Mostly
   fixed flickering and slow viewport changes; Still need to mod Wharf to
   update its clip area

[2003-05-19: sashav]
 * fixed compilation bugs in ascolor

[2003-05-19: sasha]
 * Started implementing Color config parsing/writing
 * added handling of button pressing to ascolor; Fixed bug in man page
   installation for libAfterImage reported by MG_Tak
 * fixed compilation bugs in ascolor

[2003-05-16: sashav]

[2003-05-16: sasha]
 * sorted out base config loading

[2003-05-15: sasha]
 * fixed makefiles to properly install data and man pages
 * Fixed Pager crush on startup - reported bu Geoff Burling; Fixed background
   not being displayed if not configured explicitely in look file - reported by
   Geoff Burling; Added DontDrawBackground to look to disabling usage of
   default background; Fixed Wharf's handling of swallowed apps, so that they
   don't get MaxSwallowed by default

[2003-05-09: sasha]
 * added another menu
 * Fixed lots of compilation problems when used with shared libraries; added
   menus to ascolor
 * regenerated configure
 * fixed configure and Makefiles to still build in src/ascp dir even if ascp
   itself will not be built
 * Fixed image storing in xml scripts using id= attribute; Added check for
   minimum text color brightness when whitening it; Added more bars to
   ascolor.c; Fixed bug in Makefiles for shared libraries;
 * fixed compile bugs in parse.c and completed hsv/rgb custom color parsing
 * added ascolor.c to easily preview as color schemes

[2003-05-08: sasha]
 * Adding better color parsing capabilities
 * updated configure script

[2003-05-07: sasha]
 * prototyped FLTK based ascp; Made all the libraries C++ safe
 * prototyped FLTK based ascp; Made all the libraries C++ safe
 * fixed image shortcut files reported by Vaevictus, and completed colorscheme
   calculation code

[2003-05-06: sasha]
 * added csome code to produce nice colorschemes automagically
 * added csome code to produce nice colorschemes automagically

[2003-05-02: sasha]
 * Completed theme installation code and fixed most of the config file to
   correctly set path to local user's dir

[2003-05-01: sasha]
 * trying to get themes untarred

[2003-04-30: sasha]
 * Made theme installation work when theme is not a tarball; Changed theme
   install script to contain two functions - Install and Apply, so we can check
   for files existense prior to running apply script
 * more themes develoipment
 * applied patch from Geoff Burling

[2003-04-29: sasha]
 * theme installation development

[2003-04-25: sasha]
 * started implementing proper theme installation code see
   src/afterstep/theme.c
 * fixed loading of images inside xml scripts to use same PixmapPath as
   everything else
 * added .xpm to filenames of old buttons
 * Got rid of old MyFont cruft; Got rid of global GCs in MyStyles; Fixed
   handling of FontPath and loading of TTF fonts

[2003-04-24: sasha]
 * Fixed base and look files; Need to debug the way ttf fonts are loaded and
   probably get rid of old font stuff
 * updated configure script
 * added subst to configure
 * updated configure script
 * Got rid of #bpp cruft
 * added ttf fonts to be used in default themes: mono and sans sets from
   freefonts foundry ( GPL license ) and Black Chancery public domain font (
   same as in libAfterImage )

[2003-04-23: sasha]
 * converted old background image files into combination of xml and png. That
   should complete updates to old images set
 * completed writing up titlebar buttons in xml

[2003-04-22: sasha]
 * added bunch of xml icons for titlebar buttons; removed fprintf from
   transform.c

[2003-04-21: sasha]
 * generated bunch of dots icons from buttons

[2003-04-18: sasha]
 * improvements and fixes to asimagexml adding new flags to bevel tag and
   fixing handling of IMAGE_PATH env var
 * added missing png files
 * completed creating shortcuts for icons, and converted all the tiles and bars
   into png and xml

[2003-04-17: sashav]

[2003-04-17: sasha]
 * Implemented shortcuts to supply old named icons using new ones

[2003-04-16: sasha]
 * rearranging mini icons
 * updated Makefile and icons
 * updated configure script
 *  fixed missing subst for image_format
 * updated configure script
 *  fixed tabs in makefiles
 * added missing icons
 * Fixin Makefiles for new icons etc
 * added few more icons

[2003-04-15: sasha]
 * added few more icons
 * added bunch of new icons under normal/png

[2003-04-10: sasha]
 * Added bunch of 48x48 icons into normal/png

[2003-04-08: sasha]
 * missing braces in ico import code; Fixed large icons broken by broken
   libAfterImage; Added Bookshelf and Package icons
 * Fixed scaling Up algorithm to put correct last line ( it was putting 4th
   line before last instead); Fixed MS Icon file format reading to allow for
   arbitrary size of images ( it was affecting AndMask not being read
   correctly;

[2003-04-04: sasha]
 * finilized set of 56x large icons
 * fixed handling of incoming module communications where protocol 2 is used (
   wrong size of the variable was used while reading func val and unit)

[2003-04-03: sasha]
 * compiled set of logos
 * added xpm2png conversion script

[2003-04-01: sasha]
 * fixed linux-penguin's commanet

[2003-03-31: sasha]
 * tossing xpms around to free up space for png's
 * moving xpm files around
 * Fixed all the problems with icons not being deiconified on correct viewport,
   icons not shown properly on Pager; shaded windows not shown properly on
   pager

[2003-03-28: sasha]
 * Fixed Icons placement inside iconbox. Need to debug: deiconification
   viewport - windows get restored off screen when current viewport is not 0,0;
   icons are displayed by Pager as full size windows - need to debug that too;
   Need to debug multirow iconbox filling, as well as left-to-right and
   top-to-bottom filling orders
 * Fixed bug where while writing bitmap mask we would forget to unset flag
   indicating that it is 8 bit mask
 * Fixed h_spacing/v_spacing in WinLIst; Changed defaults used for WinList
   styles and bevel; Fixed bug in AfterSTep where PanFrames would get decorated

[2003-03-27: sasha]
 * Fixed handling of menus in ClickToFocus mode; Fixed clearing of ungrabbed
   variable; Fixed window focusing on mapping; Fixed handling of the
   composition method variable in WinList; Fixed handling of MaxWidth setting
   in WinLIst; Added spacing settings to WinList config Updated NEW file
 * Completed ClickToFocus/AutoRaise/ClickToRaise debugging and
   reimplementation; Splid add_window.c into add_window.c and winstatus.c to
   make it mor emanageable

[2003-03-26: sasha]
 * hopefully debugged ClickToFocus/ClickToRaise/AutoRaise stuff - behaviour
   changed thou - ClickToFocus alone will not raise window unless AutoRaise or
   ClickToRaise is specified
 * Fixed segfaulting with 64bit compile due to 32bit values used instead of
   pointers in calls to get_hash_item

[2003-03-25: sashav]
 * Fixed transparency update in Pager , Wharf and hopefully in WinList as well,
   on ackground changes

[2003-03-25: sasha]
 * Fixed broken PinOn button on menu update
 * compilation error on SPARC
 * implemented feature allowing different base files for different screens
 * Implemented changes that should hopefully fix 64 bit port of AfterSTep
 * fixed handling of WharfBevel setting ( it was ignored ); Fixed handling of
   transparency in Wharf and other places, related to teh fact that tbar root
   position may not be up-to-date;
 *  some changes to make code 64-bit safe
 * Fixed transparency update in Pager , Wharf and hopefully in WinList as well,
   on ackground changes

[2003-03-24: sashav]
 * Fixed Wharf behaviour on item selection - we should withdraw everything up
   to the root; Fixed Items order in Wharf subfolders; Fixed Wharf folder
   opening on when ther is no enough space left;

[2003-03-24: sasha]
 * wharf debugging
 * Fixed Wharf behaviour on item selection - we should withdraw everything up
   to the root; Fixed Items order in Wharf subfolders; Fixed Wharf folder
   opening on when ther is no enough space left;

[2003-03-22: sashav]
 * debugged Motif hints handling where _ALL hints was never interpreted;
   debugged name hints handling where we should check if name really has
   changed, otherwise we get into race confition with some older apps such as
   netscape:

[2003-03-22: sasha]
 * debugged Motif hints handling where _ALL hints was never interpreted;
   debugged name hints handling where we should check if name really has
   changed, otherwise we get into race confition with some older apps such as
   netscape:

[2003-03-20: sashav]
 * Fixed Bad match eror in Pager when restacking windows; Fixed BadREsource(0)
   error in Pager when restacking windows; still there is a misterious segfault
   in place_selection in Pager

[2003-03-20: sasha]
 * some work on support for root properties of ExtWM; Fixed bug in Destroy()
   where pressed window would never get forgotten;
 * Fixed Bad match eror in Pager when restacking windows; Fixed BadREsource(0)
   error in Pager when restacking windows; still there is a misterious segfault
   in place_selection in Pager

[2003-03-19: sashav]
 * minor cleanup

[2003-03-19: sasha]
 * drafted list of new features in NEW file
 * Fixed text size miscalculation due to starting counting from second
   character instead of first
 * implemented gaussian blurr for selected channels in ascompose:) WE can now
   easily convert icons into png
 * Fixed bug in function copy/duplication functions where hotkey and unit_vals
   were lost; Fixed bug in moveresize code where curr position was initialized
   to root coordinates even if moveresize was not in the root window; Fixed
   coordinates translation in Pager when applying results of the interactive
   operation; All of the above fixed window movement in Pager :)
 * minor cleanup

[2003-03-18: sashav]
 * yet another fix for click/defer execution foes - this time for complex
   functions

[2003-03-18: sasha]
 * Fixed bug when functions from modules were deffered; Fixed few bugs in
   moveresize when parent is not a root canvas
 * Fixed numerous bugs in Pager, as well as implemented more efficient updating
   of the shape of it; Implemented feature request from Vaevictus where
   AvoidCover would be disabled if window is to big; Fixed root background
   handling to crop images to the display size
 * yet another fix for click/defer execution foes - this time for complex
   functions

[2003-03-17: sasha]
 * fixed handling of moveresizing of dead windows by preempting DestroyNoitify
   events; Fixed window startup desktop setting; Fixed some Ext wm hints
   handling (state);
 * Fixed Vae bug where windows would always start on first desktop regardless
   of the current; Fixed bug where Wharf would not set its name/class and as
   the result would get listed on winlist as empoty bar; Fixed bug where
   viewport was not changed back to 0 0 on restart/shutdown
 * compile bug in event.c

[2003-03-15: sashav]

[2003-03-14: sashav]
 *  fixed handling of Wait command - we now have 30 sec default timeout, so
   that AS would not hung forever; Fixed handling of press/release while
   deffering execution, so that we don't start running additional functions as
   the result of waited for event
 * Fixed a bug in default frame decor where unfocused window would not have
   bevel drawn on sidebar

[2003-03-14: sasha]
 *  fixed handling of Wait command - we now have 30 sec default timeout, so
   that AS would not hung forever; Fixed handling of press/release while
   deffering execution, so that we don't start running additional functions as
   the result of waited for event
 * Implemented function scheduling so we don't have to recurse deep when
   functions are run from whithin functions; Cleaned up and fixed bugs in
   ButtonRElease event handling, so that now all the bars/buttons get depressed
   at the proper time; Implemented window maximization
 * Fixed a bug in default frame decor where unfocused window would not have
   bevel drawn on sidebar

[2003-03-13: sashav]
 * implemented support for legacy root background configuration in asetroot
   file
 * Fixed wait period while running Complex function and waiting for double
   click; fixed segfault and inter-layer stacking problem caused by not
   updating window's layer when its been moved from one list to another

[2003-03-13: sasha]
 * implemented support for legacy root background configuration in asetroot
   file
 * implemented TileButtonOrder fetaure suggested by Vaevictus - use it to set
   what button goes onto what side; Fixed some broken titlebar label layouting
 * got rid of redundand windows.o
 * Fixed wait period while running Complex function and waiting for double
   click; fixed segfault and inter-layer stacking problem caused by not
   updating window's layer when its been moved from one list to another

[2003-03-12: sashav]
 * debugged submenu recently used items feature - set default to 4 submenu
   items;

[2003-03-12: sasha]
 * fixed segfault in stacking order (bogus windows added to layers);
   Implemented shaped Pager; Fixed swallowed window layout in Wharf; Fixed
   label text layout on unequal font size; Fixed subitem layouting; Implemented
   separate style for subitems;
 * debugged submenu recently used items feature - set default to 4 submenu
   items;

[2003-03-11: sashav]
 * amended ASSession code to allow for updating of default files when
   look/feel/back is changed using the menu

[2003-03-11: sasha]
 * Implemented windowlist menu and proportional icon scaling to max size in
   menus; mostly implemented recent submenu items feature - needs debugging;
 * finally eleminated the problem of crashing aterms - type of the pixmap
   property used was wrong
 * amended ASSession code to allow for updating of default files when
   look/feel/back is changed using the menu

[2003-03-10: sashav]
 * added some debug statements to background code

[2003-03-10: sasha]
 * debugged root background handling so that aterms should not crash now;
   Scaled/tiled/clipped backgrounds should reload now; There will be no
   multiple copies of the image kept in AS memory anymore;
 * added some debug statements to background code

[2003-03-07: sasha]
 * updated TODO list
 * completed implementation of the smart/random/tile/placement and WindowBox
   placement management;
 * Implemented and debugged SmartPlacement in conjunction with WindowBox

[2003-03-05: sasha]
 * Implemented separate beveling for focus/sticky/unfocus states; Implemented
   configurable composition methods for titlebar, menu, wharf , WinList

[2003-03-04: sashav]
 * removed files in old locations
 * completed updating includes for new libraries
 * upgraded version, rearranged and renamed libraries to match as-devel;
   updated includes in libAfterConf and libAfterStep

[2003-03-04: sasha]
 * Implemented manual initial placement of windows; Fixed bug in moveresize
   code happening when moveresize is canceled; Fixed bug in AfterStep restart
   code to avoid corrupted memory; Fixed bug in function parsing where
   frunction name would have empty quotes; Added functionality for any texture
   type to be used for superimposition of titlebar buttons on the titlebar
 * compilation fixes related to ASWindow relocation into asinternals.h
 * removed files in old locations
 * completed updating includes for new libraries
 * upgraded version, rearranged and renamed libraries to match as-devel;
   updated includes in libAfterConf and libAfterStep

[2003-03-03: sasha]
 * some work for prototyping of ASWindowBox window placement; added Windowbox
   setting to database options; annded desk, min_layer,max_layer to windowbox
   options
 * Fixed startup of the apps on the wrong viewport; Fixed Submenu poping up on
   different viewport ( Vx swapped with Vy); Made menus sticky by default:
 * lets hope that now we finally fixed shaped window problems

[2003-03-02: sashav]
 * added missing .shared files for lib and src/Config for deps checking
 * Fixed handling of property changes by fixing camvas config invalidation and
   SetShape/ClearShape; Fixed submenu positioning so it is now easier to get to
   submenu with the pointer; Fixed dependancies chacking including headers;

[2003-02-28: sasha]
 * fixed bug in edge scrolling - now it should scroll just fine

[2003-02-27: sasha]
 * fixed off-by 3 bug in determination of the command length for spawning new
   module
 * Fixed one-off bug in command string allocation while spawing child processes
 * Fixed some bugs that appear when windows erroneously attempt to map itself
   twice

[2003-02-26: sashav]
 * Fixed bugs in vector element adding delition; Fixed bugs in MyStyle
   definition parsing; Disable Title updates since its breaking things down for
   now; Fixed DISPLAY var pasing setting;

[2003-02-26: sasha]
 * fixed nasty bugs in event handling code that could crash AS if event is from
   the extention
 * Added SaveWorkspace function to enable taking a snapshots of apps running at
   arbitrary moments
 * Added SaveWorkspace function to enable taking a snapshots of apps running at
   arbitrary moments
 * hopefully fixed segfault experienced by Vaevictus while starting AWharf with
   some apps being iconic
 * Completed backporting Feel.c and asfeel.c; backported function.c; Hopefully
   fixed race condition between AfterStep and Wharf ;
 * Completed backporting Feel.c and asfeel.c; backported function.c; Hopefully
   fixed race condition between AfterStep and Wharf ;
 * compile bug fix due to asfeel.c backport
 * compile bug fix due to asfeel.c backport
 * compile bug fix
 * backported Feel.c from as-devel; split screen.h to asfeel.h and screen.h;
   Fixed bug in Wharf related to swallowing iconic windows without proper icon
   window
 * Fixed bugs in vector element adding delition; Fixed bugs in MyStyle
   definition parsing; Disable Title updates since its breaking things down for
   now; Fixed DISPLAY var pasing setting;

[2003-02-25: sashav]
 *  fixed Wharf using path without replacing env vars for image search

[2003-02-25: sasha]
 * lock_mods handling fix to alle=viate potential segfaults experienced by
   Vaevictus
 * Fixed bug in ConnectAfterSTep where not enough memory was allocated for
   temporary string holding module name; Fixed bug in libAfterBase where we may
   go out of bounds on move_data_down
 * lock_mods handling fix to alle=viate potential segfaults experienced by
   Vaevictus
 * Fixed background scaling where there was no size specified(toscreensize);
   Fixe OpaqueMove/Resize treatment ( it was inversed ); fixed SetShape
   behaviour when window was moved/resized and shape would appear in the wrong
   place, cutting off parts of the window;
 *  fixed Wharf using path without replacing env vars for image search

[2003-02-24: sasha]
 * Fixed menus to get withdrawn when mouse clicked on root window again; That
   could be turned off by new option in feel file : ParsistentMenus; Brought
   back to Wharf feature where there was possible to define individual button
   size; Changed AlignContents option in Wharf to use verbal settings instead
   of numbers; Added WharfBevel option to define how exactly Wharf should be
   3D-drawn;
 * Hopefully fixed gamma correction issue in PNG images
 * Completed redesign and testing of the new WinList2: fixed several layout
   bugs and implemented button pressing, balloons and MouseActions

[2003-02-21: sasha]
 * updated WinList2 and implemented all the features except for MouseAction and
   ShapeToContents; Debugged and it seems to work quite well; updated config
   file with all the new setting;

[2003-02-20: sasha]
 * Fixed segfaults on QuickRestart - so look and feel should now change with no
   problem; There is a bug thou in placing frame decoration canvases - needs to
   be debugged
 * Fixed background switching using the menu where image would not get reloaded
 * Enabled balloons in Wharf; started fixin WinList2
 * Enabled balloons in Wharf; started fixin WinList2

[2003-02-19: sasha]
 * Debugged balloons in Pager; Implemented shaped balloons; Debugged shaped
   frame decorations; Implemented proper TitleBackground for MyFrame;
 * Balloons work in afterstep-proper; Now need to reenable them in Wharf and
   Pager; Removed redundand timer.c from lib - it is now in libAfterBase

[2003-02-18: sasha]
 * Reimplemented balloons and inserted all the needed code into
   afterstep-proper. Don't have time to debug - probably still does not work

[2003-02-14: sasha]
 * Implemented Wharf with multiple columns and rows
 * unneeded debug output was being displayed in normal build - slowing things
   down considerably
 * Further debugging of MyFrames: parsing of corners side fixed; corners are
   made the same as height of bottom canvas;

[2003-02-13: sasha]
 * updated TODO list
 * completed MyFRame implementation except for FIT_LABEL_SIZE bit;

[2003-02-12: sasha]
 * Backported Look parsing using the parser; Implemented new structure for
   MyFrame stuff to include all the thinkable options for align, bevel, and
   whatever in it; Implemented most of the parsing code for new MyFrame stuff;

[2003-02-11: sasha]
 * Fixed frame decor sizing and drawing; Tbar tiles could now be scaled or
   tiled; need to add NormalStyle/FocusStyle to MyFRame and then have
   NormalFrame/StickyFrame setting

[2003-01-22: sashav]
 * fixed envvars setting

[2003-01-21: sasha]
 * Implemented iconbox placement of icons; debugged icon resizing and
   rendering; TODO: icons on desk changes, icon's moving, icon update on hints
   changes, icon look updates;

[2003-01-17: sashav]
 * Fixed bug in window redecoration where nothing would get refreshed if size
   remains the same - added canvas invalidation function

[2003-01-17: sasha]
 * Added checks to menu drawing code to accound for situations when window is
   too small(no visible items) or items are out of the window area; Implemented
   hints tracking code; Hopefully fixed mapping/unmapping/reparenting handling
   - wm_state_transition variable has been added to track what actions should
   be performed on window on map/unmap events; Implemented proper
   iconification/deiconification cod3e - now need to complete icon box code and
   icons should be done; minor cleanups and speedups;
 * Fixed bug in window redecoration where nothing would get refreshed if size
   remains the same - added canvas invalidation function

[2003-01-14: sasha]
 * fixed X errors when windows would be focused while being unmapped and
   non-existant pan frames would get configured
 * updated configure to allo0w disabling the debug output
 * implemented switching off the debug output
 * updated deps
 * unneeded debug message removed
 * Implemented alt-tabbing (window switching) - all 3 modes should now work
   just fine

[2003-01-09: sasha]
 * library cleanup from stale files; ConnectX does not need display_name
   anymore and does not have to be checked; as_fd is no longer needed in
   modules;
 * Compiled new TODO list for ppl to chew on
 * removed useless TODO garbadge

[2003-01-08: sasha]
 * somewhat improved wharf shaping; Implemented alpha blended text labels;
   started updating WinList2 to what it supposed to be

[2003-01-07: sasha]
 * IMplemented shaped windows support in as-proper; Implemented shaped Wharf;
   Debugged labels in Wharf; Fixed bug in image flipping code where color could
   get lost when original uses back_color;

[2003-01-06: sasha]
 * Added some code to handle shaped subwindows - needs some debugging
 * Fixed bugs in as-proper ConfigureNotify handling - now using real window
   size instead of event's window size; Implemented main Wharf folder
   withdrawing; Implemented Swallowing; Implemented Swallowing on top of the
   folder button Implemented different types of wharf button sizing and
   aligning; Implemented shaped Wharf with OSX thinger type of buttons - all
   differently sized

[2003-01-02: sasha]
 * Fixed nasty bug in linked list memory reuse, causing AS to endlessly loop on
   window list iterations; Implemented swallowing by Wharf; Fixed close-on-exec
   bug in CYGWIN preventing AS from properly killing modules; Fixed SET_NAME
   command handling by AS

[2002-12-31: sasha]
 * implemented Wharf folder opening and command execution on mouse press;

[2002-12-30: sasha]
 * got wharf folders to properly display self and animate nicely; Fixed bugs in
   MyStylke property handling where shared pixmaps would get destroyed, yet
   loaded fonts never get freed and show up in memory report; Added function to
   asapp.c to do all the cleanup tasks; minor memory leaks elimination

[2002-12-27: sasha]
 * debugged Wharf config parsing/reading and started implementing Wharf
   folders/buttons
 * completed fixing for new parser - everything should now work as before, only
   faster
 * fixed compilation bugs left over from upgrade to new parser
 * updated deps
 * added code to allow for per-line reading in backported parser so to make it
   play nicely with older config reading in afterstep -proper

[2002-12-26: sasha]
 * started reimplementing Wharf - so far done with config reading; caved in to
   the pressure and backported parser and freestor stuff from as-devel tree -
   shold enable backporting of entire libAfterConf in the future;

[2002-12-24: sasha]
 * completed reimplementation of Pager: MOving of windows now works and with
   snaping to edges too (use Shift+ to disable); Windows could now be resized
   in Pager  - press Ctrl+ prior to pressing mouse button; Transparent desks
   properly update on background changes; Viewport scrolls on Button3 pressess;
   Implemented change desktop command in AfterSTep; fixed transprency updates
   in decor.c
 * moved moveresize.c/h and outline.c to the lib, so that we can use them in
   Pager as well

[2002-12-23: sasha]
 * implemented hiliting of Pager desks; hilitiong of client windows in Pager;
   DeskTitles are now getting pressed; Viewport changes properly move sticky
   windows around; Fixed segfaults in Pager related to removal of clients;
   Fixed segafults in afterstep related to wm props bugs where new desks were
   improperly added/removed; MOveViewport does not update status of sticky
   windows; Fixed bug in handle_canvas_config always returning Y_RESIZED;

[2002-12-20: sasha]
 * implemented protocol for clients to request root background for any
   particular desktop; Enabled Pager to set its background to the actuall
   desktop background's scaled copy; Fixed bug in setting  atom list property -
   all the WM_PROTOCOLS are now set properly

[2002-12-19: sasha]
 * cleaned up and debugged background image handling; fixed clients stacking
   order in Pager; ICCCM ConfigureNotify on frame moves reenabled; proper
   config broadcasting at the time of the actuall ConfigureNotify; stacking
   order gets sent on WindowList request;

[2002-12-18: sasha]
 * implemented somewhat correct root background management scheme - needs to be
   tried with multiple backgrounds switching; implemented root background
   scaling and padding; added ConfigureNotify prehandling prior to desktop
   switching so to get everything reparented in correct position;

[2002-12-17: sasha]
 * began implementing root background handling in as-proper; implemented all
   the needed config parsing code - now need to work out the actuall image
   switching

[2002-12-16: sasha]
 *  cleaned up intermodule communications command set; Implemented
   M_STACKING_ORDER command; Implemented client windows in Pager; fixed bug in
   module.c where wrong mask was checked for; implemented proper window
   stacking in Pager

[2002-12-13: sasha]
 * Added DontRestoreFocus to feel options - forces AS to hide focus on desk
   changes when ClickToFocus is used; began implementing Pager reprtesentations
   of client windows; Made MWM options in feel obsolete - should be disabled on
   per app basis from now on ( see new database options)
 * implemented and hopefully debugged virtual desktop switching; Pager properly
   reflects viewport position; nasty bug in module command execution is fixed -
   scr member of event was not initialized causing random failures and crashes

[2002-12-12: sasha]
 * Implemented Pager page separator grid and current viewport selection; fixed
   transparency changes and root position handling; Fixed module command
   processing by the afterstep - ExecuteFunction actually works now; added
   function to query canvas window geometry

[2002-12-11: sasha]
 * Implemented Pager shading of a single desktop; Implemented vertical desk
   labels in Pager; Implemented actuall desk switching on mouse click in Pager
   - need to debug Afterstep proper for that to work; Implemented proper
   pressing of buttons on the titlebar

[2002-12-10: sasha]
 * debugged Pager drawing and config reading; Implemented more efficient way of
   storing Root image - only needed part of screen will be stored; Added
   Shading button to Pager desks, so that desks could be shaded :); Fixed bug
   in read_as_property where first 4 bytes were left uninitialized;

[2002-12-09: sasha]
 * Implemented desktop representation drawing in Pager; Implemented better pipe
   listening function in ASmodule.c to be used by modules

[2002-12-06: sasha]
 * fixed bug where Session was initialized prior to Scr and everything was
   screwed; Debugged intermodule communications - now commands are parsed
   properly; Implemented module file reading using Session

[2002-12-05: sashav]
 * fixed bug in focusing on second head(typo); Fixed bug in Popups being
   substituted for Nop; Fixed segfault in menu closing; Fixed segfault in
   mystyle freeing;
 * fixed bug in focusing on second head(typo); Fixed bug in Popups being
   substituted for Nop; Fixed segfault in menu closing; Fixed segfault in
   mystyle freeing;

[2002-12-05: sasha]
 * Fixed bug in image flipping where back_color would get lost; Implemented
   menu style in database as Style ASMenu; began working on Pager and WinList2
   to get them to compile and run with new as-proper
 * Completed implementation of pinned menu: fixed bug in decor.c where not all
   tiles would get deleted from the tbar; Implemented withdrawing of menu chain
   when one of them becomes pinned; Implemented proper tbar sizing for menus
 * fixed bug in focusing on second head(typo); Fixed bug in Popups being
   substituted for Nop; Fixed segfault in menu closing; Fixed segfault in
   mystyle freeing;
 * fixed bug in focusing on second head(typo); Fixed bug in Popups being
   substituted for Nop; Fixed segfault in menu closing; Fixed segfault in
   mystyle freeing;

[2002-12-04: sashav]
 * fixed memory corruption in buil_astbar_btn_block and close_asmenu

[2002-12-04: sasha]
 *  sugnificantly improved speed of menu rendering as well as loading time;
   mostly implemented Pinning of the menus - need to debug redecoration of the
   frame window;
 * fixed memory corruption in buil_astbar_btn_block and close_asmenu

[2002-12-03: sashav]

[2002-12-03: sasha]
 * Implemented all the modes of DrawMenuBorders setting; Minipixmaps and arrow
   pixmaps on them menus; Something actually happen when you click on menu
   item; Submenus open when pointer is hovering over arrow pixmap; Vertical
   tilebars and sidebars are working now; Hilite of titlebars and menu items
   are adjustable now;

[2002-12-02: sashav]
 * Fixed root pixmap grabbing using ParentRelative; Fixed label layout moving
   label off alittle bit; Began implementing support for DrawMenuBorders
   setting
 * implemented root background grab when pixmap ID is not set; When Root
   background is unavailable - instead of returning empty image - better
   create some solid ASImage

[2002-12-02: sasha]
 * Fixed root pixmap grabbing using ParentRelative; Fixed label layout moving
   label off alittle bit; Began implementing support for DrawMenuBorders
   setting
 * debugged never layout code; Implemented align/padding of tiles - now text
   label could be aligned right or center ; debugged vertical tbars and buttons
   layout
 * implemented root background grab when pixmap ID is not set; When Root
   background is unavailable - instead of returning empty image - better
   create some solid ASImage

[2002-11-30: sashav]
 * Fixed remains of as-proper to work with new decor stuff

[2002-11-29: sashav]
 * began implementing more flexible structure for tbar data

[2002-11-29: sasha]
 * completed implementing flexible bar layout technology - few fixes to
   as-proper are left, but its almost done
 * began implementing more flexible structure for tbar data

[2002-11-27: sasha]
 * implemented submenu poping on menu item pressing; Implemented menu stack ;
   Implemented disabling items in menu ;

[2002-11-26: sasha]
 * not much of a changes - pressing in menu and started implementing submenus

[2002-11-25: sasha]
 * Began implementing menu item selection; Implemented menu open at pointer
   position

[2002-11-22: sasha]
 * Fixed moving/resizing of shaded windows; Implemented correct recursive
   allowed function check for complex functions; Implemented menu destruction;
   Implemented menu selection on pointer motion - still need to do something
   about submenus; Fixed handling of ButtonRelease events in WaitForClick loop
   - titlebar should be depressed; Fixed bug with window autoraising due to
   unsigned AutoRaiseDelay being assigned -1; Fixed sizing of shaded windows;
   Fixed overlapping check for shaded windows; TODO: Need to see why
   ClientMessage to accept focus gets sent twice; Fixed shaded menu handling to
   not loop endlessly(hopefully);

[2002-11-20: sasha]
 * Implemented most of menu creation, look and data updating, as well as
   scrolling functionality

[2002-11-19: sasha]
 * minor things
 * Implemented window resizing; Implemented Snapping to screen edges and window
   decoration edges with overriding using modifier key; Implemented proper
   restrains on sizing for windows that that have relevant hints set; Fixed
   updating of the client canvas config on ConfigureNotify; Began implementing
   new menus using ASCanvas.

[2002-11-18: sasha]
 * Implemented level counting while doing Grab/UngrabEm; Implemented
   intercative window movement; Fixed FousIn handling to not loose focus while
   mouse is grabbed;Implemented updating of bar's root position when frame is
   only moved, but not resiized.

[2002-11-15: sasha]
 * backported move-resizing code from as-devel - now need to figure out how to
   plug it in to everything else
 * redundand SetMyName() in ASmodule.c
 * Fixed memory leaks in asfont.c,list.c,decor.c and InitLook(); Implemented
   proper cleanup to produce clean memory leak output; Implemented smooth
   shading animation in both directions

[2002-11-13: sasha]
 * Debugged resizing of frame decorations; Fixed segfault in DigestEvent;
   Implemented titlebar button drawing (for horizontal bars only for now);

[2002-11-12: sasha]
 * debugged function execution; window registration and partially
   configurenotify handling

[2002-11-08: sasha]
 * debugged AddWindow, restacking and colormaps; Need to debug ExecFunction -
   it loops endlessly now on InitFunction

[2002-11-07: sasha]
 * fixed remaining compilation problems; updated depenfd files; Fixed Session
   to correctly build config tree and use correct paths; Fixed atoms interning;
   Fixed config reading order; added QuickRestart base and database;Implemented
   function body parsing; debugged to the point that config loads successfuly

[2002-11-06: sasha]
 * Moved MyStyles to use Hash table, Fixed mystyle_property code to use
   wmprops; updated libConfig to use asapp and fixed MyStyle parsing; cleaned
   up bits and pieces and at long last got AfterStep proper to compile cleanly
   cd as-stable! Now its time for some debugging

[2002-11-05: sasha]
 * Completed configure.c update - need to update mystyle.c to use hash table
   instead of list now; ASSession upgraded to handle theme file and multihead
   config properly

[2002-11-04: sasha]
 * completed rewriting afterstep.c and started cleaning up the config handling
   - lastthing I hope
 * fix to configure to not mangle dir names
 * missing files

[2002-11-01: sasha]
 * backported rewritten modules.c and session management code from devel.
   Mostly updated/cleaned AS initialization code; added missing files to CVS

[2002-10-31: sasha]
 * Fixed Frames, backported asapp.c.h, got rid of aftersteplib.h, cleaned up
   headers in lib

[2002-10-30: sasha]
 * making progress to get as to compile - link time errors now

[2002-10-25: sasha]
 * completed updating most of them functions.c

[2002-10-24: sasha]
 * completed backporting aswindow.c; rewrittend add_window.c to use new
   windowlist stuff and continued on with functions.c

[2002-10-23: sasha]
 * some backporting of windowlist functionality from devel to reuse restacking
   functions

[2002-10-22: sashav]

[2002-10-22: sasha]
 * backporting large portion of function/menu handling code from as-devel
   branch

[2002-10-18: sasha]
 * started fixing functions.c; fixed bug in event.c reported by tildouf

[2002-10-17: sasha]
 * Completed events handling rewriting - now off to functions

[2002-10-10: sasha]
 * completed colormap handling, UnmapNotify and EnterNotify handling

[2002-10-09: sasha]
 * painfull work on implementing proper colormap handling

[2002-10-07: sasha]
 * updated HandleMapNotify and HandleUnmapNotify, and started reworking
   Colormap handling

[2002-10-04: sasha]
 * updated Destroy and REstoreWithdrawnLocation from as-devel; cleaned up
   misc.c abit; Updated HandleDestroy and HandleMapRequest

[2002-10-03: sasha]
 * implemented frame hiliting on focusIn, updated 50% event handlers

[2002-10-01: sasha]
 * focusIn?

[2002-09-30: sasha]
 * focusIn?

[2002-09-27: sasha]
 * started fixing event handling - completed event digestion(event time,
   ASWindow, context, widget, etc.; backported event.c/h from as-devel for
   better event time/window handling

[2002-09-25: sasha]
 * getting everything to compile

[2002-09-05: sasha]
 * completed implementation of button/key grabbing/ungrabbing - need to do
   special case of RaiseToClick without ClickToFocus
 * moved keyboard and mouse grabbing into add_window.c and cleaned it up abit
 * moved keyboard and mouse grabbing into add_window.c and cleaned it up abit
 * moved keyboard and mouse grabbing into add_window.c and cleaned it up abit

[2002-09-04: sashav]
 * completed redecorate_window icluding icon image

[2002-09-04: sasha]
 * mostly done with add_window.c - need proper feel stuff ( grabs and such)
 * completed redecorate_window icluding icon image

[2002-09-03: sashav]
 * adde ASIconBox and AWSDesktop, started implementing ASIconBox

[2002-09-03: sasha]
 * implemented creation of canvas for frame, client and icon; got rid of
   Textures
 * adde ASIconBox and AWSDesktop, started implementing ASIconBox

[2002-09-02: sashav]
 * need to rewrite icon handling using ASCanvas as well

[2002-08-31: sashav]
 * discontinued borders.c - moved SetShape and SetFocus to add_window.c;
   Cleaned up all old junk from ASWindow struct

[2002-08-30: sashav]
 * implemented frame size calculation and resing on status change

[2002-08-30: sasha]
 * Started switching over everything to use new canvas/tbar scheme of window
   decorations drawing
 * implemented frame size calculation and resing on status change

[2002-08-29: sasha]
 * implemented move/resizing handling and drawing

[2002-08-28: sashav]
 * added tbar data creation code

[2002-08-28: sasha]
 * keep on working
 * added tbar data creation code

[2002-08-27: sashav]
 * musings

[2002-08-27: sasha]
 * started implementing new ASWindow decorations
 * musings

[2002-08-26: sasha]
 * implemented titlebar button placement structures

[2002-08-23: sashav]
 * prototyped new window decoration elements

[2002-08-23: sasha]
 * started backporting MyFrames from as-devel - created as-stable specific
   MyFrame structure
 * prototyped new window decoration elements

[2002-08-22: sashav]
 * cleaned up most none-state (permanent) flags - now state flags todo

[2002-08-21: sashav]
 * fixed focus handling and titlebar buttons

[2002-08-17: sashav]
 * replaced TITLE, BORDER and VERT_TITLE with relkevant flags from hints;
   Rewrote button handling to use better button numbering (from ashints as
   well)

[2002-08-16: sashav]
 * updated dependancies
 * fixed parser to corretly handle database config

[2002-08-15: sashav]
 * afterstep compiles now, but does not run due to multiple faults - needs
   debuggin

[2002-08-15: sasha]
 * debugging database parsing
 * afterstep compiles now, but does not run due to multiple faults - needs
   debuggin

[2002-08-14: sashav]
 * afterstep now compiles, but some functions needs to be added/reimplemented
   for it to link

[2002-08-13: sashav]
 * further progress in fixing as to compile

[2002-08-10: sashav]
 * fixed decorations.c and afterstep.c

[2002-08-09: sashav]
 * some progress in updating to proper ASHints usage

[2002-08-08: sashav]
 * Merged work in progress - conversion to new fashioned ASHints and ASDatabase
   - AS does not compile

[2002-08-04: sashav]
 * backported database parsing code from as-devel

[2002-08-03: sashav]
 * Switched ASWindowd to use new names stored in ASHints; Implemented support
   for new GNOME/KDE hints for window names

[2002-08-01: sashav]
 * cleanup for new ASHints added

[2002-07-31: sashav]
 * added structures for new ASHints to ASWindow

[2002-07-29: sashav]
 * backported hints.c and asdatabase.c as a prelude to implementing proper
   gravity handling and maybe even support for gnome/KDE

[2002-07-28: sashav]
 * some debugging on the WinList config reading in WinList2 - made it as
   backward compatible as possible

[2002-07-26: sashav]
 * work to read config of the new WinList

[2002-07-24: sashav]
 * implemented shaped decoration drawing - see winlist2 with BackPixmap set to
   125 or 126 for any of the styles

[2002-07-23: sashav]
 * Fixed afterstep proper to use same functions as mystyles for icon loading(
   with shapes and alpha-channel) Fixed bugs in mystyle text drawing; some
   ximage.c functions where bitmap parameter was wrong; Changed titlebar
   buttoins to use MyIcon and MyButton; Changed Frames to use MyIcon with
   shapes and everything; Fixed menu to properly load and unload icons

[2002-07-22: sashav]
 * completed implementation of 8-bit alpha channel pixmaps in libAfterImage;
   added function to hopefully determine the most efficient depth of alpha
   channel (8 or 1); added 8-bit alpha support to icon_t and mystyles; fixed
   bugs in MyStyles cloning of mask; added twm rubberband; fixed Audio (see AS
   ML)

[2002-07-20: sashav]
 * added some functions for export of alpha channel into 8 bit pixmap and back

[2002-07-18: sashav]
 * debugging shaped images in modules

[2002-07-17: sashav]
 * Added focused/sticky display to WinList2; Fixed bevel width; Fixed window
   adding;

[2002-07-16: sashav]
 * Parameter check bugfix in marge_layers in libAfterImage; Rewrote WinList
   layout, to do it two steps

[2002-07-15: sashav]

[2002-07-12: sashav]
 *  prototyped updating of transparency

[2002-07-09: sashav]
 * further improvemet of tbar drawing in winlist2

[2002-07-08: sashav]
 * implemented canvas drawing and debugged large part of WinList2 redrawing
   code

[2002-07-06: sashav]
 *  back to hacking WinLIst2 to implement TrueType font rendering

[2002-06-24: allanon]
 *  o re-ordered a bit of code so that the width and height attributes of
   <scale> could use variables defined by children of the tag

[2002-05-24: sashav]
 * compilation warning

[2002-05-22: allanon]
 *  o added support for multi-bit-depth displays like those found on Solaris
   boxes: 8bpp root window, with 24bpp possible to afterstep; note that
   asetroot still does not support this situation, so transparency modes    do
   not work  o moved around audit.h includes to allow AS to be compiled with
   --enable-audit again

[2002-05-20: sashav]
 * fixed all of the color bugs I could find - let me know if you find any more

[2002-05-18: sashav]
 * added configure option to enable reusing loaded font by modules (old way)

[2002-05-16: sashav]
 * fixed several bugs and got it practically ready for the general use

[2002-05-10: sashav]
 *  added main window creation code and prototyped WinList config stuff

[2002-05-07: sashav]
 * implemented generic winlist data handling

[2002-05-03: sashav]
 * backported wmprops and clientprops code for maybe support for KDE/GNOME

[2002-05-01: sashav]
 * preoared WinList to be converted to use TRueType fonts
 * fixed bug in style parsing

[2002-04-30: sashav]
 * Hopefully fixed problem with tinting color by adding another texture
   type(149); added more texture types to enable image scaling (127,150-165),
   added usage of image_manager to load images

[2002-04-28: sashav]
 * fixed text colors on non-24bpp displays

[2002-04-27: sashav]
 * fixed compilation of everything

[2002-04-26: sashav]
 * fixed bug in Wharf where apps where launched on wrong screen in multihead
   config; Implemented prototype for automated titlebar rendering

[2002-04-25: sashav]
 * started implementing new tbar drawing
 * more includes cleanup
 *  cleaned up headers and fixed Makefiles
 *  got rid of asimagelib
 * added custom GetColor for Scroll - will have to be rewritten at some point
   ab=nyways, no nee dto waste too much time on it now

[2002-04-24: sashav]
 * more cleanups - Ident now works

[2002-04-23: sashav]
 * Fixed Pager to use correct color parsing; Added ARGB2PIXEL converters for
   pseudo-color modes; Removed GCs from Wharf

[2002-04-21: sashav]
 * fixed Wharf to (hopefully) work with libAfterImage. Fixed several minor bugs
   in libAfterImage

[2002-04-21: allanon]
 * makeastheme.pl now checks the root window bitdepth first, if possible; this
   is the ideal thing to do, but may not always work, so it falls back to the
   old depths line detection if necessary

[2002-04-19: sashav]
 * more wharf work. Added xpm_data2ASImage()

[2002-04-18: sashav]
 * Updated Pager to use libAfterImage; pending work on Wharf; added
   mystyle_make_image function and Scr.RootImage

[2002-04-16: sashav]
 * slightly improved logic of gradient drawing to account for completely messed
   up offsets

[2002-04-15: sashav]
 * Converted asetroot to use libAfterImage for image loading and
   transformations
 * synced with as-devel/libAfterBase
 * synced with as-devel/libAfterImage

[2002-04-13: sashav]
 * Reimplemented MyStyles using libAfterImage - include ssome changes to
   MyStyle data structure. Tinting now works both ways - darkens and lightens.
   all 15 blending methods should work now. half of the modules needs fixing to
   compile

[2002-04-11: sashav]
 * updated references to mailing lists in Readme files

[2002-04-09: sashav]
 * Syncronized with devel tree - xml vars, stdout image export

[2002-04-09: geoff]

[2002-04-07: geoff]
 * Consolidated include files, global variable declarations from Scroll.c &
   GrabWindow.c into header file.(Geoff)
 * Consolidated include files, global variable declarations from Scroll.c &
   GrabWindow.c into header file. (Geoff) Removed nocolor() function, as it
   appeared not to be used.
 * Consolidated include files, global variable declarations from Scroll.c &
   GrabWindow.c into header file.

[2002-04-03: sashav]
 * Added self diag code. Fixed bug in libAfterImage where Mask was incorrectly
   exported into ximage

[2002-04-03: sasha]
 * compile error
 * fixed minor compilation problems
 * fixed blatant bug in Makefiles for libraries
 * Added self diag code. Fixed bug in libAfterImage where Mask was incorrectly
   exported into ximage

[2002-04-03: allanon]
 * Added variables to the XML image parsing.

[2002-03-31: sashav]
 * Enabled AS to read image files using libAfterImage; switched to use even
   more stuff from libAfterBase - fs.c in particular

[2002-03-30: sashav]
 * IN the middle of updating AS with libAfterImage and libAfterBase. Things may
   not work here

[2002-03-29: sashav]
 * added cvsignore

[2002-03-28: sashav]
 * fixed libAfterWidegt to get asclook to compile again
 * Completed pixmap manipulation functions port from old libafterimage

[2002-03-27: sashav]
 * compile warnings
 * Alpha portability fixes
 * Alpha portability fixes
 * Alph portability fixes
 * portability fixes

[2002-03-26: sashav]
 *  fixed lousy bug in tiling code where data was coming out randomly

[2002-03-23: sashav]
 * almost done with pixmap.c

[2002-03-22: geoff]

[2002-03-20: geoff]

[2002-03-19: sashav]
 * implemented draw_unicode_text and draw_utf8_text and get_text_size for those
   as well
 * minor tweaks to asvector.c

[2002-03-18: geoff]

[2002-03-17: sashav]
 * Locale support for TTF fonts mostly completed - need to add
   draw_text_unicode and draw_text_utf8

[2002-03-17: geoff]
 * Sound file missing from distribution.(Geoff)
 * Added entry to message table to bring source file into compliance with
   include/module.h. Redefined RPLAY macro, removing cruft.
 * Sound file missing from distribution. (Geoff)

[2002-03-15: sashav]
 * right smack in the middle of unicode debugging, loosing bloody glyphs
   somewhere :(

[2002-03-12: sashav]
 * hopefully completed locale string parsing

[2002-03-11: sashav]
 * adding decoder for locale names

[2002-03-10: sashav]
 * Implemented large portion of locale/unicode support in text drawing

[2002-03-09: sashav]
 *  completed implementing char to unicode conversion

[2002-03-08: sashav]
 * added test container for vector draving

[2002-03-02: sashav]
 * fixed missing argument in query_screen_visual macro

[2002-03-02: allanon]
 *  o fixed segfault when no valid image is generated at all  o xml_print() now
   indents xml so it's more readable

[2002-03-01: sashav]
 * implemented 8-bit mask output into XImage and reverse mask decoding into
   alpha channel from attached mask XImage
 * Fixed compilation warning in Wharf in regards to get/set_flags(); Upgraded
   version

[2002-02-26: sashav]
 *  done with ximage tiling code, now we can use XImages instead of encoded
   ARGB data

[2002-02-24: geoff]
 * Fixed last minute typo.
 * Groff mangled part of this manpage. Rewrote passage to fix this.

[2002-02-23: sashav]
 * applied patch fixing -h flag in Tile from Geoff Burling

[2002-02-22: sashav]
 * made possible to use XImage data directly for other transformations - need
   to complete scanline tiling code and add trigger disabling DATA_UNUSABLE
   flag

[2002-02-21: sashav]
 * started adding decoding capabilities for ASImages that only has XImage/ARGB
   data
 * added colormap parameter to create_asvisual_from_id, so that custom created
   colormap could be passed for libAfterImage to use from calling app.

[2002-02-20: sashav]
 * minor portability fixes
 * minor portability fixes

[2002-02-19: sashav]
 * Added xml2ASImage input filter. Changed gradient drawing code to not assume
   ascending order of offsets.

[2002-02-18: sashav]
 * converted ascompose to use xml code from asimagexml.c and did some cursory
   debuggin

[2002-02-16: sashav]
 * completed asimagexml - now to convert ascompose to use it and do some funky
   debuggin for meory corruption/leaks and other features :)

[2002-02-12: sashav]
 * mostly done with asimagexml refactoring

[2002-02-11: sashav]
 * added asimagexml - input filter that allows to perform complex
   transformation on image transparently for the app and based on supplied XML
   file.

[2002-02-06: sashav]

[2002-02-06: geoff]

[2002-01-22: geoff]

[2002-01-18: geoff]
 * cvs -f -d :pserver:geoff@65.164.201.4:/home/cvsroot ci
 * editted usage() output to include -f switch and short/long switches

[2002-01-17: sashav]
 * Fixed bug in ascompose where command line argument could be freed. Fixed bug
   where wrong destruction function has been used in image hash in ascompose.
 * Fixed segfault when opening XPMs with greater then 256 colors. Hopefully
   satisfied stupid gcc 3.0.3 when it stumbles upon printf() with ifdefs
   inside.

[2002-01-16: sashav]
 * Fixed bug in DefaultGeometry handling where check for USPosition/Size should
   have been negated. Fixed compilation bug in lib/parse.c Fixed minor typho in
   afterstep man page.

[2002-01-15: sashav]
 * Updated ChangeLogs
 * updated docs
 * updated deps and configure scripts
 * Upped version number for libAfterImage and libAfterBase
 * Upped version number for libAfterImage and libAfterBase
 * Upped version number for libAfterImage and libAfterBase

[2002-01-14: sashav]
 * added missing AS_HASHABLE and show_progress
 * added missing AS_HASHABLE and show_progress
 * added missing show_debug into afterbase.c/.h
 * added missing show_debug into afterbase.c/.h
 * Completed portability fixing of the day
 * Compilation warnings
 * Compilation warnings
 * Fixed Embarrasing bug in MAX macro - it was working the same as MIN :)
 * Removed unneeded debug code
 * Fixed embarrasing bug in MAX macro - it really worked the same as MIN :)
   *GRRRRR*
 * debugging on 64bit big emdian machine
 * XParseGeometry requires unsigned int*
 * XParseGeometry requires unsigned int*
 * Added mandatory libm , since we now need exp() from gaussian blurr
 * Added mandatory libm , since we now need exp() from gaussian blurr
 * XParseGeometry expects pointers to unsigned int
 * DOS format somehow creeped in :(
 * datatype portability issues
 * __FUNCTION__ macro portability issues
 * Hopefully bomb-proof freetype detection
 * Hopefully bomb-proof freetype detection
 * Hopefully bomb-proof freetype detection
 * Some dumb compilers just don't know what to do about void*.
 * Hopefully fixed compilation problems on some stupid compilers that don't
   understand typeof().
 * Fixed compilation problems when sign-safe minmax was causing problems on old
   compilers.
 * Fixed compilation problems of compilers that does not support __FUNCTION__
   define.
 * Fixe compile problem with (void*) pointer math
 * prototyped ASCommManager - for the generic even/input loop handling

[2002-01-11: sashav]

[2002-01-10: sashav]
 * fixed compilation bug in afterstep.c
 * Updated ChnageLogs for libAfterImage and libAfterBase
 *  Fixed bug in bevel drawing where right solid line would not be drawn
 * added XGCValues to xwrap code
 * updated libs configure script with new version and correct help/options
 * Fixed makefile to install ascompose man page into correct location, since it
   is an app it should go into man1
 * included safemalloc.h into socket.c to avoid warnings
 * updated man pages

[2002-01-09: sashav]
 * Completed documenting libAfterImage's latest additions.

[2002-01-08: sashav]
 * Completed documenting ascompose.c Regenerated .HTML docs

[2002-01-07: sashav]
 * done with about 50% of ascompose documentation.
 * minor debugging of multihead background changing

[2002-01-06: sashav]
 *  added patches from Jan Fedak for menu hotkeys and default window placement

[2002-01-03: geoff]
 * Fixed grammatical & punctuation errors.

[2001-12-31: sashav]
 * Fixed HSV and HLS colorspaces to correctly assign meaningfull HUE values
   with straight mapping onto 360 degree colorcircle with red being 0, green
   120 and blue 240 degrees. Fixed adjust_asimage_hsv to correctly translate
   degrees. debugged <hsv> tag in ascompose. Added ARGB32_RED16 macro and the
   likes.
 * added HSV transformation

[2001-12-28: sashav]
 * Fixed alpha handling in allanon and add methods of blender.c Fixed minor
   bugs in ascompose related to clip_height handling in composite tag.

[2001-12-27: sashav]
 * greateluy improved ascompose fixed bug when colormap had 128 entries in gif
   transparency

[2001-12-26: sashav]
 * Added compress, replace and delay attributes to save tag in ascompose.

[2001-12-25: sashav]
 * debugged GIF and XPM transparency

[2001-12-24: sashav]
 * Fixed bug in PNG with alpha writing, where alpha channel could get lost.
   Fixed bug in Gif reading where extensions where lost. Updated ascompose to
   use show_progress/error instead of plain printf fixed libAfterBase to
   compile

[2001-12-23: geoff]

[2001-12-20: sashav]
 * minor things

[2001-12-18: sashav]
 * Lots of work for proper implementation of scrollbars. Since we need
   interwidget messaging - started implementing messaging, That moved onto
   proper implementation of socket FIFO and that in turn led to addition of
   ASBiDirList datatype with appropriate methods.
 * Completed updating Pager for new scheme of theme support

[2001-12-16: sashav]
 * added support for Theme file at non-cf dir and theme-override file in AS
   dir. Started moving Pager to use it correctly - 50done

[2001-12-14: sashav]
 * Lots of fixes for session handling, look/feel loading and non-default-visual
   handling
 * Fixed visual detection code to not create new Colormap when Default Visual
   is in use.
 * Fixed Visual Autodetection code to correctly create windows for visuals
   other then default visual.

[2001-12-13: sashav]
 * applied patch to get AfterSTep to change icon when title is changing
 * applied patch to get AfterSTep to change icon when title is changing
 * updated man pages; fixed maximization under xinerama; updated ChangeLog;

[2001-12-12: sashav]
 * Added ability to specify preferred Visual ID via env. variable
   AFTERIMAGE_VISUAL_ID

[2001-12-10: owsla]
 * Fixes from Geoff Burling <llywrch@agora.rdrop.com>

[2001-12-07: sashav]
 * When scale_asimage is called with quality set to POOR it will not
   interpolate pixels, but merely duplicate existing ones. When scaling down is
   perfomed it will it will keep averaging pixels values nevertheless. Added
   tiling_range to ASImageOutput to allow filling of portion of the image with
   the same scanline. Fixed bug in enlarging algorithm causing corruption of
   the image near the right edge.

[2001-12-06: sashav]
 * Fixed minor compilation problems reported by Reiner Rohlfs.
 *  added ARGB2pixel conversion for 16/15bpp; Fixed bug where root position of
   window was not updated on move

[2001-12-05: sashav]
 * Added destroy_asgrid function for grid cleanup.
 * Fixed bugs in merge_asimage and bevel drawing causing segfaults and wrong
   images when negative destination is used.
 * fixed bug in merge_aslayers that was not traversing layers list correctly

[2001-12-04: sashav]
 * continued debugging of image rendering with varying dest position in layers

[2001-12-03: sashav]
 * Fixed desktop background loading and fetching by look. Made Look loader to
   skip image loading when imman is NULL, while handling root backgrounds.
 * Removed unneeded ASVisual arg from clone_asimage.
 * Completed rewriting bevel rendering. It should now correctly trim bevel when
   requested to do so.

[2001-11-30: sashav]
 * More rendering/look debugging. Fixed Titlebuttons handling. Started
   rewriting bevel drawing to enable drawing of bevel on clipped images when
   some parts of the bevel maybe outside of the clip rectangle.

[2001-11-29: sashav]
 * Extensive debugging of new rendering code.

[2001-11-28: sashav]
 * Implemented actiuall dubblebuffered drawing. Fixed all the compile time bug
   - need to get asclook to actually draw something.

[2001-11-27: sashav]
 * Updated deps files

[2001-11-25: sashav]
 * Added check for correct libPNG

[2001-11-21: sashav]
 * Fixed nasty bug causing wierdness under CYGWIN - basically assumption that
   all we have is 256 FDs is incorrect - all we really need is max(cmd_fd,Xfd)

[2001-11-20: sashav]
 * Added desktop layout to ornaments - incomplete
 * ByteOrder debugging - fixed misaligned green channel in ASImage-> XImage
   conversion in MSBFirst != BigEndian configuration
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * ByteOrder debugging
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes
 * portability and compilation fixes

[2001-11-19: sashav]
 * Fixed nasty bug in event handler when connection from module would be
   attempted even when there is no intput on the pipe.

[2001-11-15: sashav]
 * Debugged Vector data drawing code and added optimizations for repetitive
   data.
 * Debugged Vector data drawing code and added optimizations for repetitive
   data.

[2001-11-14: sashav]
 * Added new fixes from Fons Rademaker Implemented ASImage support for data in
   vector of doubles with additional pallette to translate into real ARGB.
 * added automated check for MMX support to libAfterImage

[2001-11-13: sashav]

[2001-11-08: sashav]
 * Implemented Wharf, Pager and WinList prototypes in asclook; Fixed Layout
   handling of empty cells, Added AvoidCover handling to movement of windows;
   fixed grid generation

[2001-11-05: sashav]
 * Implemented and debugged snapping to edges of interface elements while
   moving window

[2001-11-02: sashav]
 * implemented buildup of ASGrid from Layout
 *  Applied next batch of diffs from Fons Rademakers. Fixed several cuel bugs
   in libAfterWidget, causing memory corruption. Changed ASHashableValue to be
   simply unsigned long - for portability.

[2001-10-26: sashav]
 * moved widget event handling into widgetevent.c/.h
 * blunder in set_application_name
 * Added patches for compilation into C++ proggrams ( contributed by Fons
   Rademakers) Implemented export filter into TIFF. Hopefully fixed library
   order when compiling apps from libAfterImage

[2001-10-22: sashav]
 * Added viewport changing functionality

[2001-10-17: sashav]
 * Updated ASWMDecor and ASDesktop to possibly have an owner, such as desktop
   for decor and root for desktop. Updated asclook to use ASDesktop and Client.

[2001-10-12: sashav]
 * Moved per-desktop look/feel management into session.c. Made asclook compile
   and debugged libAfterImage's use of AS_ASSERT.

[2001-10-10: sashav]
 * Added missing string_destroy into afterbase.c
 * Added missing remove_hash_item into afterbase.c
 * Fixed Makefile to work without libAfterBase
 * Updated ChangeLogs
 * completed update of the documentation for libAfterImage
 * updated documentation and deps
 * Fixed configure script to be able to compile libAfterImage and libAfterBase
   at once

[2001-10-09: sashav]
 * Updated most of the libAfterImage inline documentation. ascmap.h is left to
   do.

[2001-10-05: allanon]
 * fixed "click on empty button which used to contain a swallowed window will
   respawn that window" functionality; it didn't work unless the button had an
   associated action

[2001-10-04: sashav]
 * rather finalized ASWMDecor to degree that we need to fix AS proper to go
   further. Started implementing ASDesktopWidget.

[2001-10-03: sashav]
 * Much debugging of the inheritance implementation; Titlebar now updates
   sidebar with the new size. Fixed bugs where call_cllas_ has not been used
   with attach/detach functions.
 * fixed compile problems

[2001-10-02: sashav]
 * Debugged WMDecor to the degree that it shows up just fine. Added
   WF_SlaveFocus flag to widgets; Added ASHandlebarWidget Added size tracking
   to widgets. Changed all occurences of Sidebar to Handlebar
 * updated man page

[2001-10-01: sashav]
 * If second parameter of WindowDesk is 10000 then first is treated as desk
   number relative to the current desk.
 * completed updating libAfterImage to work with no X display; cleaned up in
   preparation for release

[2001-09-29: sashav]
 * done implementing xinerama-aware initial window placement; upgraded to
   latest autoconf.

[2001-09-28: sashav]
 * Updated Sasha Vasko e-mail address
 * Updated e-mail address
 * started implementing Xinerama support

[2001-09-26: sashav]
 * Added reference to the widget owner to Basic Widget instead of useless
   event_mask. Added attach/detach function to automate process of subwidget
   attachement
 * synchin
 * nothing really

[2001-09-23: sashav]
 * fixed file availability check for look/feel private to screens other then 0

[2001-09-22: sashav]
 * implemented separate Feel/Look/background and Init/Restart functions for
   each screen, while running in Multihead config with no Xinerama

[2001-09-18: sashav]
 * Added Event handling to extract event class/mask window uniformly (
   collected code from trace.h, mywidget.h, eventloop.h ) Rewrote widget
   reshaping. Dropped stacking order - parts pointers should represent stacking
   order. Added default handler for ConfigureNotify for widgets Implemented
   context search of pointer events.

[2001-09-14: sashav]
 * Implemented  widget's layout re-layouting and started working on event
   handling. Fixed several bugs in layout.c and added few calls to have control
   over element's sizes
 * Updated socket creation code to use $TMPDIR env. var to guess where /tmp is
   located.
 * debugged ascp to the degree that all the panels are shown correctly

[2001-09-13: sashav]
 * Added visibility to newly created basic widgets. Upgraded to typesafe
   MIN/MAX using prototype from the LInux kernel. Fixed libAfterImage to do
   type-safe MIN/MAX.
 * Completed rewriting Mystyles handling in ASCP - now needs to be debugged

[2001-09-06: allanon]

[2001-09-05: sashav]
 * Fixed layout.c to include correct config.h
 * Fixed reversed cursor assignments while executing functions. Updated Feel
   files accordingly.
 * Fixed reversed cursor assignments while executing functions

[2001-09-04: allanon]
 *  o (libAfterImage) added blur_asimage_gauss() to do a gaussian blur; this
   function currently only supports horizontal blurs  o (ascompose) added
   <blur> as an undocumented feature, for testing only

[2001-09-03: sashav]
 * rewritten RELoadScreenConfig a bit to make it more ASCP friendly. Added
   BaseConfig2MyEnvironment, Made ExtractPath non-destructive.

[2001-09-01: sashav]
 * moved ascp into libAfterConf and begun work on getting it fixed for recent
   changes to libAfterSTep/Image. Fixed main.c and lib.c

[2001-08-31: sashav]
 * Moved more size/layout management code into layout.c
 * Moved most of the layout functionality into the  libAfterBase and untied it
   from the MyWidgets Supposedly we don't really need generic MyWidgets - more
   of ready to use widgets. generic layouting and rendering has been moved out
   of it now, we pretty much get stripped down things to the level where its no
   longer usefull in its generic form.

[2001-08-30: sashav]
 * Fixed Transparency in asrender - several bugs in mytexture.c that was. Added
   MyBackground and DeskBack to look configuration. added
   release_asimage_by_name to asimage.c
 * added cvsignore to libAfterImage/apps
 * Implemented AS customized geometry parsing function; Added stub for
   XParseGeometry; Fixe astile and asscale to compile without X

[2001-08-29: sashav]
 * Rewrote window hierarchy handling in asrender, and started implementing
   transparency handling
 * further configure, Makefile and code cleanup to get it to compile without X

[2001-08-28: sashav]
 * minor fix in sleep.c
 * Fixed numerous bugs in libAfterImage of various severity. Got asclook to
   render default look correctly.
 * tweaks and debugging

[2001-08-28: allanon]
 *  o (ascompose) finalized and documented inherited attributes of <composite>:
      crefid, x, y, and tint  o (ascompose) added support for compiling
   --without-x  o (ascompose) new command-line option --root-window; when
   given, the    final result image of ascompose will be drawn to the root
   window    instead of a new window
 *  o (ascompose) started adding support for --without-x  o (ascompose) changed
   the default text spacing to 3; this needs to be    an option instead

[2001-08-27: sashav]
 * fixed freetype detection
 * disabled memory allocation limitation with DEBUG_ALLOC in safemalloc.c
 * freetype compilation fixes
 * fixed magic number usage in ASImage

[2001-08-25: sashav]
 * fixed asrender and asclook to actually render default look properly and not
   segfault in pad_asimage
 * fixed  ability to load several TRuyeType fonts with different point size
 * added vert and horizontal spacing for fonts; Added ability to load several
   TRuyeType fonts with different point size

[2001-08-25: allanon]
 *  o (ascompose) fixed x,y handling for <composite>; yes, i know i still
   haven't documented them - they're obviously not ready yet :)

[2001-08-22: sashav]
 * completed library configure cleanup - adding aslook subdir

[2001-08-21: sashav]

[2001-08-21: allanon]

[2001-08-20: sashav]
 * fixed nasty bug where if dst_x = 0 - and top image is smaller then bottom
   one - merge_layer generates garbadge
 * Added image cloning/padding functionality to libAfterImage

[2001-08-19: sashav]

[2001-08-17: sashav]
 * Added code for Buttons, Icons and empty items to asrennderer. Fixed bugs in
   image referencing using ImageManager. Added render_pad_align_image.

[2001-08-16: sashav]
 * Fixed utterly ugly bug in image decompression code where first position in
   channel  data get corrupted with the data from adjusten channels. Fixe
   mytexture tile generation to simply set image's background to back_color.
   Added copy_asimage_channel
 * Moved back_color into ASImage to maintain image consistency between
   subsequent decodings and encodings. Changed back_color to solid_color in
   ASImageLayer, to use it only when image is NULL. Updated everything
   accordingly. Changed asimage2ximage to restore missing scanlines based on
   image's back_color.
 * updated ascompose to use init_image_layer for layer initialization - it was
   missing back_color to be set to default. Updated init_image_layer
   accordingly

[2001-08-15: sashav]

[2001-08-15: allanon]
 *  o (ascompose) made <composite> attrib "op" optional  o (ascompose) added
   "merge" to <composite>  o (ascompose) added "keep-transparency" to
   <composite>  o (ascompose) added "refid" to all of the options that support
   width    and height options  o (ascompose) made <tile> attrib "width" and
   "height" optional  o (ascompose) added new tag <text> and documentation to
   README  o (ascompose) added new tag <bevel> and documentation to README  o
   (ascompose) added new tag <solid> and documentation to README  o (ascompose)
   now uses refcounts to deallocate images when possible

[2001-08-14: sashav]
 * Fixed corners drawing while drawing the inline of the bevel. Fixed
   ImageDecoder to allow for im meber to be NULL, but back_color - not 0
   Improved merge_layers to only merge portions of scanlines that overlap -
   without padding top scanline. Updated all blenders accordingly.
 * Fixed parsing of Pad portion of MyBackground structure.
 * Fixed parsing of Align portion of MyBackground structure.
 * added bevel with solid inlines; Fixed gradiented bevel drawing on very large
   distances; updated deps

[2001-08-13: sashav]
 * Implemented create/init_image_layers Implemented AddLabel in asrenderer
   Fixed mystyle_draw_text

[2001-08-10: sashav]
 * added sanity checks to bevel parameter. Need to fix bevel increment
   calculations for inline.
 * Split asimage.c into 3 files - asimage.c, transform.c and ximage.c, with
   asimage.h being split up accordingly. Fixed bug in create_asimage code to
   check for validity of compression parameter. Fixed introduced bug in
   merge_layers where we forgot to skip first layer in the main loop.

[2001-08-10: allanon]
 *  o sync commit so sasha can see a problem with <bevel>

[2001-08-09: sashav]
 * Mostly implemented window background rendering and layers merging in
   asrender code.

[2001-08-08: sashav]
 * Changed license of libAfterBase and libAfterImage to LGPL

[2001-08-08: allanon]
 *  o (ascompose) reordered usage message to be alphabetical  o (ascompose)
   upped version to 1.2  o (ascompose) added automagical output format
   detection based on extension  o (ascompose) added id parameters to all xml
   tags  o (ascompose) added <recall> and <save> xml tags, and docs to README

[2001-08-07: sashav]
 * Started implementing ASRenderer code. Adding and deleting windows so far.
 * Updated ascompose with ability to save images into any supported file
   format(kowalski) Also added ability to write out image without displaying it
   first.
 * Fixed bug found by k0walski where file export filters would return False
   even if save was successful.
 * Fixed bug in shading animation code where number of steps is very large
 * Updated MyTexture, MyLook and MyStyle to use libAfterImage. Rewrote session
   management a bit for saner look/feel management. Added CursorManager code.
   Added asclook app to libAfterConf to provide for preview of arbitrary looks.
   Fixed several bugs in Image loading code.

[2001-07-26: sashav]
 * Finally brought giflib to its knees by implementing lots of cludges to work
   around its bugs. Thank god gif's colormap is stored uncompressed! Now
   libAfterImage can both read and write multiimage gif files. HipHip Hooray!

[2001-07-25: sashav]
 * playing cat and mouse with giflib bugs - and there are plenty of those.
   We'll need to move portions of it into libAfterImage to ease the pain.
 * Minor cleanup in gif writer

[2001-07-24: sashav]
 * no message
 * fixed several bugs in colormap generation, and implemented gif output filter
   ( sort of )

[2001-07-23: sashav]
 * completed colormapping code allowing for different degrees of dithering

[2001-07-22: sashav]
 * polished colormap calculation quite a bit and made it to allocate just the
   right amount of colors by adding more passes

[2001-07-20: sashav]
 * completed implementation of quantization and colormapping of images.
   Debugged, but still can be optimized for speed.

[2001-07-19: sashav]
 * Implemented some experimetal code to create colormapped images and allow for
   dithering and optimum color selection.

[2001-07-17: sashav]
 * Rewrote MyLook from config generation . Updated MyStyles to use ASImages and
   ASFonts

[2001-07-16: sashav]
 * Added image reference to libAfterImage Fixed font dereferencing ( see
   release_font() ). Started implementation of libAfterImage interface in
   libAfterStep.

[2001-07-13: sashav]
 * Added get_drawable_size to afterbase.c (damn allanon :) Added define for
   mystrcmp Added check for libAfterBase presence before setting output
   threshold in asmerge
 * Fixed clobbered variable in export.c; Fixed missing SHOW/START_TIME in
   afterbase.h.in Added MMX notice to README's.
 * Updated docs to reflect recent API changes
 * Upped library version to 0.81
 * Fixed libAfterImage to compile nicely when libAfterBase is not available
 * cleanup commit
 * added mirroring capability to asflip

[2001-07-13: allanon]
 *  o added <mirror> xml tag to ascompose, and documentation in README

[2001-07-12: sashav]
 * Implemented mirror_asimage() for image mirroring (as you could have guessed
   :)
 * fixed compile bug in ASImage2gif
 * Added templaites for image export filters. Implemented RGB and greyscale
   JPEG image writing. Implemented  RGB and greyscale PNG image writing with or
   without alpha channel. Added usefull SHOW_TIME and START_TIME macros to
   libAfterBase

[2001-07-11: sashav]
 * disabled doc.html generation on make install - that was stupid to try and do
   that.
 * Added final astext tutorial comments. Reupdated documentation.
 * final fix to installation and Makefiles
 * added afterimag.h to incs
 * fixed headers locating in /usr/local/include
 * fixed installation of afterimage-libs script
 * fixed standalon configure run
 * fixed doc installation in Makefile
 * fixed doc installation in Makefile
 * fixed doc installation in Makefile
 * fixed doc installation in Makefile
 * fixed doc installation in Makefile
 * updated Makefile to install include files as well
 * fixed configure in libAfterImage to have separate enablers for static and
   shared libs

[2001-07-11: allanon]
 * added ascompose, an XML-based image composition tool

[2001-07-10: sashav]
 * Updated documentation abit to refelect recent code changes and make it
   easier to link from main index page.
 * fixed bug in xpm parser where spaces would get treated incorrectlt in
   colormap; added READMEs;

[2001-07-09: sashav]
 * Added functionality to move_asimage_channel to be able to move to arbitrary
   channels from arbitrary channels. Added documenting comments to astext.c and
   fixed text layout abit.
 * Fixed parse_argb_color. Added options to astile and asflip for easier
   operation. Fixed asgrad to treat gradient type well, if gradient is not
   specified. Added few more points to asgrad sample gradient to create better
   illusion of the rainbow.
 * Added report of the scale factor to asscale
 * Changed astile to tile to twice the size of the image
 * Fixed bug in 3D text rendering causing us to skip scanline inbetween lines
   of text. Added sample image  rose512.jpg, and TTF font: test.ttf. Added nice
   defaults to all the sample apps, so that ppl can see libAfterImage in its
   full beauty.
 * Adde Usage to all the examples. Fixed segfault in asscale. Added error
   message on image file not found. Added texturized text sample images.

[2001-07-08: sashav]
 * fixed parse_argb_color to check for dpy not being NULL - to avoid segfaults,
   babe
 * added usage display to asflip and asgrad and fixed some other places where
   parse_argb_color would be called prior to dpy initialized
 * added clocking to draw_text; added usage and more sophisticated usage to
   astext

[2001-07-07: sashav]
 * fixed 3D drawing and implemented all 6 modes

[2001-07-06: sashav]
 * fixed glyph compression again; Started implementing 3D text.
 * Fixed bug in asimage.c where fake_im was not initialized; Corrected glyph
   compression code
 * asfont fixin
 * fixed layers merging to correctly draw the background layer when image is
   missing; Fixed spacing calculations, while drawing text

[2001-07-05: sashav]
 * Temporarily plugged bug in layer merging descovered by allanon, when
   bottommost layer does not have any image in it.
 * Reimplemented image output to allow for flexible support for many image
   formats - right now it could be ASImage itself, XImage, mask XImage and
   ARGB32. Surprisingly that simplified code quite abit. Fixed ugly bug in
   create_asimage. Completed and debugged astext tutorial.
 * fixed text size calculations; fixed (almost) bevel drawing  - need to think
   about what to do with clip_width/height in Layer specs

[2001-07-04: sashav]
 * fixed lots of bugs in glyph compressing and rendering, still something is
   wrong with size calculation func. Added move_asimage_channel to swap
   channels on images

[2001-07-03: sashav]
 * implemented astext properly
 * implemented asgrad, asflip and astext. Althou astext still needs some work.
 * added prototypes for asflip, asgrad and astext examples/tutorials/testapps
   to the libAfterIMage suit

[2001-07-02: sashav]
 * Completed ASMerge implementation. Used it to debug all the merging routines.
   Everything works perfect now. Added doc/html/asmerge.html - another
   tutorial. Added list_scanline_merging function to blender.c so that we can
   show descriptions on different merging methods.
 * Completed ASMerge implementation. Used it to debug all the merging routines.
   Everything works perfect now. Added doc/html/asmerge.html - another
   tutorial. Added list_scanline_merging function to blender.c so that we can
   show descriptions on different merging methods.
 * Added ASMerge example, and added translator from function name to function
   for scanline merging/blending.

[2001-07-01: sashav]
 * added check for xpm.h needing X11/ in front of it; Upgraded version to
   1.8.9; rebuild config accoringly.

[2001-06-29: sashav]
 * Added ASScale and ASTile examples with documentation and stuff. Fixed bug in
   asimage.c causing artifacts when image is tiled with TOP quality. cleabed up
   cvsignore in include/
 * fixed and simplified configure script for examples to libAfterImage. Have a
   good day :)

[2001-06-28: sashav]
 * Added documenting comments to asview.c so it generates nice little Tutorial
   as the result. Added lots of X functions to xref files, so now all the
   source code is very nicely crossreferenced. Added references to asview to
   other headers etc.

[2001-06-27: sashav]
 * Completed documenting asfont.h Added afterimage.h with library overview got
   rid of old doc files added freetype and X11 xrefs so that docs are nicely
   crosslinked with X docs

[2001-06-26: sashav]
 * asfont.h documentation  50% done
 * added Makefile targets fopr autogeneration of documentation in man and HTML
   formats. Added installation procedure for those.

[2001-06-25: sashav]
 * Documented blender.h and import.h - asfont.h to go. Also it sound like a
   good idea to add afterimage.h with overview notes about libAfterImage and
   references to components.

[2001-06-24: sashav]
 * completed fixing libraries includes
 * rewrote libraries includes generation; fixed freetype checking to skip old
   garbadge left over in X11R6 dir

[2001-06-23: allanon]

[2001-06-22: sashav]
 * Completed documenting asimage.h and asvisual.h. asfont.h and import.h to go
 * fixed libAfterImage include to always use -I gcc flag

[2001-06-21: sashav]
 * MOre documentation writing - ASImage.h is almost done.
 *  got asview to compile cleanly and find all the relevant libraries - need to
   think about simplifying configure scripts and headers there

[2001-06-21: owsla]
 * added stop_image_output() to asimage2mask_ximage()
 * change show_system_error() output based on `man perror`

[2001-06-20: sashav]
 * asimage.html and asimage.man updates
 * Implemented proper generation of mask XImage (1bpp)

[2001-06-19: sashav]
 * more doc
 * Implemented ARGB->pixel conversion for 32 and 24 bit True color visual Fixed
   parse_argb_color to correctly treat 12 digit color value as 48bit RGB. More
   libAfterImage documenting
 * Fixed bug in find_file preventing it from finding files when not NULL search
   path is specified. Fixed bug in asimage2pixmap causing it to use wrong gc
   variable. Added more documentation to asimage.h and respectively to
   asimage.html

[2001-06-18: sashav]
 * Added lots of self documenting comments to libAfterImage/asimage.h to allow
   for automagic documentation generation using robodoc package. Seems to be
   the only package that works decently.

[2001-06-17: sashav]
 * started implementing sample repository of example libAfterImage apps

[2001-06-15: sashav]
 * Added prototypes of the man pages for libAfterImage

[2001-06-14: sashav]
 * added MMX enabling switch to libAfterImage configure
 * Completed Pseudo-color support with colormap allocation and ximage handling.
   Added create_asimage and destroy_asimage for convinience. Added missing
   stuff to libAfterImage/afterbase.h to make it completely independant.
   libAfterImage thus should be ready for release - only to write up some docs
   :)

[2001-06-13: sashav]
 * completed flip-flopping code. Added show_debug to show_* series in
   libAfterBase/output.c started working on collor allocation on PseudoColor
   visuals

[2001-06-12: sashav]
 * completed implementation of image alpha beveling. completed implementation
   of image flipping - need some cleanup thou to allow for tiling.

[2001-06-11: sashav]
 * fixed configure to produce correct dependencies
 *  fixed configure to correctly create dependacy info
 * no message
 * Hopefully fixed memory allocations audit on libAfterBase.
 * Added ASImageBevel to allow for transparent bevelling of images while
   merging layers. Hopefully fixed X libs in configure script - need to rerun
   autoconf
 *  added configclean target to the top level makefile; fixed libraries
   makefiles to correctly generate .depend files
 *  fixed configure scripts to not do extra checks when invoked from one
   another

[2001-06-11: owsla]

[2001-06-10: sashav]
 * got rid of old image loading stuff. LoadImageWithMask moved into resources.h
   and is now simple shortcut to libAfterImage loader

[2001-06-09: sashav]
 * made test to compile; Fixed several bugs in libAfterImage; optimized 2bpp
   handling in xpm code; builtin xpm handler is about 2 times as fast as libXpm
   on small images and 5 times on larger ones

[2001-06-08: sashav]
 * configure fixes
 * updated configure scripts
 * further progress - src/test compiles now, but need to redo
   libAfterImage/configure
 * fixed compilation bug in import.c
 * rebuilt configure scripts
 * updated configure scripts to reflect addition of the xpm parsing code
 * Completed custom xpm implementation. Needs to be debugged thou.
 * hopefully fixed main configure script to gracefully handle libraries
   configuration as well. MOved configure.h and some other headers into include
   dir, so it could be used by modules

[2001-06-07: sashav]
 * Fixed MyName requests in selfdiag.c; Added xpm.c to implement custom xpm
   handling code - appears to be rather simple and effective. Most of the
   things are implemented, except for top level routine.
 * cleaned configure script for libafterimage. added afterimage-libs script to
   print list of LD_FLAGS for linking with libafterimage

[2001-06-06: sashav]
 * fixed bug found by allanon when asimage2ximage would produce black ximage
   due to unset flags in scanline

[2001-06-05: sashav]
 * fixed 50% of libAfterStep files to compile. added functions.c to hold all
   the function processing miscelanea cleaned up includes on the way.
 * Aggregated module library code into ASmodule.c  - soon to be renamed into
   module.c. readaspacket.c, Xmodule.c are now gone. Rewritten packet reading
   code to use socket_* interface from libAfterBase, with correct endiannes
   handling of the data - need to fix src/afterstep/module.c too, and maybe
   move some code from there into libAfterStep/module.c.

[2001-06-04: sashav]
 * started documenting libAfterImage
 * fixed bug in configure --with-jpeg
 * added missing .depend
 * sorted out compilation problems, and test now builds with new libAfterImage

[2001-06-04: owsla]
 * updated configure
 * updated the .cvsignore files

[2001-06-03: sashav]
 * got libAfterImage to compile

[2001-06-02: sashav]
 * hopefully resolved libAfterImage dependancy on libAfterBase

[2001-06-01: sashav]
 * separated libAfterImage files from the rest of the crowd
 * started up libAfterImage

[2001-05-31: sashav]
 * forgot to add socket files
 * Implemented libAfterBase/socket.c to perform all the network communication
   stuff. It implements socket setup, buffered writes of int and string data,
   effective protocol implementation for non-blocking reading.
 * fixed configure scripts to correctly compile everything

[2001-05-30: sashav]
 * Prototyped ASRenderer interface
 * completed fixing old lib files to compensate for file relocation. There
   needs to be something done to Mkaefiles and configure to correctly set up
   include paths and libraries.

[2001-05-29: sashav]
 * added output.c to libAfterImage to do all the show_* stuff. added astype.h
   to define all the basic types fixed most of the files to compile
 * post relocation cleanup in process - several things merged together into
   fs.c and os.c
 * updated to reflect location change

[2001-05-28: sashav]
 * Split ASVisual from ScreenInfo and rearranged ARGB32. Added ASGradient to
   asimage.h and made gradient_t to be a synonym to it. That should allow for
   better library independancy - visual will go with libAfterImage while
   ScreenInfo will move into libAfterStep , or, possibly will split up even
   more. Goal is to make libAfterImage completely independant from everything
   else.
 * Created prototype for the new library structure - libAfterBase. There will
   be two more libraries : libAfterImage and libAfterStep. This is to split
   generic and non-generic code and allow for libraries to be used separately
   - as a preparation for libAfterImage release as a stand-alone library.)

[2001-05-23: allanon]
 * Updated FSF snail mail address.

[2001-05-12: sashav]
 * added code to check for valid channels while flipping

[2001-05-10: sashav]
 * Completed gradients drawing code. Started  on flipping code. Added direction
   reverse to output method.

[2001-05-09: sashav]
 * Implemented vertical gradient drawing. sorted out relationship between
   channel numbering and ARGB32 component order - its the same now.
 * fixed mono line encoding to add zero terminator at the end; fixed scanline
   back_color initialization to have alpha at 0xFF; fixed decoration layouting
   to not use stack memory in linked list; fixed property event handler to
   initialize variable to NULL; Afterstep now starts , althou does not do
   anything usefull

[2001-05-08: sashav]
 * coded gradients drawing using ASImages with smoothing and dithering - works
   very blasted fast. Fixed numerous include's issues

[2001-05-07: sashav]
 * fixed create_screen_window for InputOnly windows fixed bug in screen
   initialization where Colormap ID would get lost fixed bug in desktop
   creation code where desktop->scr would never get initialized. Added
   show_progress function to work similarly to show_warning/error Rearranged
   thresholds for output verbosity Added stdargs.h  to import.c - suggested by
   Sean Dague

[2001-05-04: sashav]
 * completed ASFont implementation as needed at the moment - there will need to
   be some work done in order to adapt it to locale support.( as well as in
   several other places). changed glyph compression algorithm once again to run
   length encode only 0s and FFs, and store rest in raw format. That allows to
   cut down on memory since we don't use 2 bytes anymore. 3 step antialiasing
   works now. Off to image rotation and gradient drawing.

[2001-05-03: sashav]
 * Improved glyph compression algorithm so now it actually reduces size, even
   on ery small fonts. Tryed to implement additional glyph smoothing, but
   something is wrong - disabled for now.

[2001-05-02: sashav]
 * fixed font drawing to group glyphs as close together as possible - make for
   much nicer effect.
 * debugged X11 fonts loading and drawing. Still need to do something about
   negative left bearings - ought to really offset a pen to overlap charcters

[2001-05-01: sashav]
 * Implemented antialiasing for native X  fonts - still needs some debuggin.

[2001-04-30: sashav]
 * added RLE compression to the font glyph cache. added character range
   specification for the font. added right-to-left writing order on per font
   basis.

[2001-04-27: sashav]
 * implemented text drawing using precached TTF fonts -- needs addition of
   locale support in future. Fixed image merging to do clipping correctly.
   Added image background color
 * fixed freetype headers problems and a bug in font hashing

[2001-04-26: sashav]
 * started implementing font manager and freetype support

[2001-04-25: sashav]
 * moved scanline merging functions into separate file
 * fixed most blending function so not to tresspass alpha channel boundaries.
   Added tint_scanlines and implemented dissipation
 * fixed bug in image loading where piexls would get shifted by one to the
   right. added 14 image blending functions - almost matching that of the
   GIMP's capabilities, except for multiply and divide modes, which I don't see
   much sense in. Added RGB->HSV->RGB and RGB->HLS->RGB conversion functions.

[2001-04-24: sashav]
 * cleaned up output/encoding functionality. Added quality parameters to
   dynamically adjust quality on per image basis. Implemented alpha blending
   and generic layer merging framework.

[2001-04-23: sashav]
 * debugged tiling functionality and optimized it so not to do repeated
   compression on the same data. Added compression ratio specification on per
   image basis. OPtimized buffer copy to use 32bit data transfer. Implemented
   tinting( as a part of tiling process ).
 * debugging tiler

[2001-04-22: sashav]
 * added tile_image() - needs debugging
 * ASImageDecoder

[2001-04-20: sashav]
 * added TIFF import and implemented generic image loading function with search
   capabilities and subimage loading. Fixed two more bugs in image scaling.
 * added GIF import filter; added configure code to detect gif and tiff
   libraries

[2001-04-19: sashav]
 * .CUR is the same as .ICO only type = 2
 * Added support for .PNM, .PPM, .ICO, .BMP image file formats - TIFF and GIF
   to go

[2001-04-18: sashav]
 * xcf image loading now works, but only gets you first layer with the same
   size as whole image. Need to implement layers merging for ASImages to get
   complete support for GIMP's xcf files
 * fixed bug in xcf channel loading - theer are no such thing as channel type

[2001-04-17: sashav]
 * most of the preparation work for xcf reading is done - now off to actually
   create ASImage from it. added code to poupulate ASScanline with 0's where
   data is not available;

[2001-04-16: sashav]
 *  minor quality tweaks in rations 1-2 scaling up. Started implementing
   ASImageDecoder for automatic tinting/tiling
 * IMplemented JPEG input filter for ASImage. Fixed long standing bug in image
   scaling causing wierdness in scaling UP with small ratios. Started
   implemntation of XCF file reader.

[2001-04-15: sashav]
 * implemented png file reader and fixed blatant bug in scale image up where
   first line got garbadge in it

[2001-04-14: sashav]

[2001-04-13: sashav]
 * compilation fixes
 * Implemented xpm loading into asimage. Updated asimage to correctly use
   ScreenInfo. implemented create_screen_pixmap and create_screen_ximage
 * fixed test abit to not spit lots of warnings

[2001-04-12: sashav]
 * converted asfeel, backgrounds, mywidget, and others to use ScreenInfo.
   libafterstep and libasGUI now compiles clean, althou libasGUI will need to
   be cleaned up to use ASImage for most of the stuff instead of old pixmap
   based drawing.

[2001-04-11: sashav]
 * converted mytexture.c to be multyscreen aware - althou when ASImage is done
   that will have to be switched to use ASImages instead of all the funky
   Pixmap stuff. GetColor is no longer needed, GetShadow and GetHilite moved to
   mystyles.c - get rid of lib/getcolor.c

[2001-04-10: sashav]
 * multihead support work in progress - colors are internally stored as 32bit
   ARGB values. and converted to pixels based on each screen - need to add GC
   creation code to ScreenInfo code. parse_argb_color is implemented and should
   be used instead of XParseColor.

[2001-04-08: sashav]
 * fixed bugs in scaling down code with ratio > 2; It appears that you can
   create windows with different visual only if you create new colormap and
   allocate border color from it as well. Fixed screen.c accordingly. We keep
   black and white pixels and colormap in ScreenInfo now - should use it
   instead of X macros

[2001-04-06: sashav]
 * implemented workaround for some stupid X servers that denys you your
   constitutional right to use whatever Visual you like.
 * couple bugfixes for new visual handling code. moved ximage->scanline->ximage
   code from asimage.c to screen.c still need to implement PseudoClor handling
 * hopefully fixed bug in 2x scaling up code

[2001-04-05: sashav]
 * no message
 * reworked ScreenInfo abit to include visual info. Added screen.c to
   libafterstep to collect together all the Screen/display related stuff -
   ConnectX, MyXErrorHandle, and several new things : init_screen and
   destroy_screen. nolock_mods has been moved outside of the ScreenInfo as it
   is per-display and not per-screen stuff. all_screens global variable holds
   pointers to all ScreenInfo structrures for available screens. Added
   query_visual_info to try and obtain best possible visual for AfterStep to
   use. Need to move ximage->as->ximage conversion stuff into screen.c.
   ConnectX now takes only one parameter - pointer to ScreenInfo is
   discontinued
 * same old Ximage cleanup

[2001-04-04: sashav]
 * asimage->ximage debugging again - this time about 50% performance increase.
 * more optimization to ximage output algorithm - that was the last of it I'm
   sick and tired from this stuff

[2001-04-03: sashav]
 * Some tweaks to XImage writing code to speed things up - we were spending
   upto 30% of time writing XImages - unacceptable.
 * fixed bug in line interpolation causing stripy artifacts in scaling up
 * fixed bug in line interpolation causing stripy artifacts in scaling up
 * mmx debugged

[2001-04-02: sashav]
 * Added some MMX inline assembly to image scaling code to hopefully make it
   faster -  need to verify if that indeed is the case.
 * fix to mystyle drawing as applyed to empty menu drawing
 * aaa

[2001-04-01: sashav]
 * scaling speed optimizations

[2001-03-31: sashav]
 * debugged new scaling code - scale up is rather nice even with huge ratio -
   check out src/test

[2001-03-30: sashav]
 * Implemented complete scaling Up procedure for arbitrary ratio - if it'll
   work then similar stuff will go for 1-2 and 2-3 ratios. Added
   reshape_winlist to WinList to actually generate layout of titlebars based on
   WinList data and store pointers to them in appropriate place in WMDecor
   structures. It now needs to be debugged as a prototype for other modules.
 * debugged scaling down algorithm  - it now works and scale things down rather
   nicely. Thus we have a proof of concept and can proceed on to scaling up -
   which is mopstly implemented already

[2001-03-29: sashav]
 * completed implementation of scaling down of ASImages. Added dithering
   capabilities to ASImage->XImage conversion to hopefully produce better
   results on 16bpp and 15bpp Fixed bug in ASWinLIst message processing to
   create WinList if it did not exist. Fixed Bug in afterstep to initialize
   handlers in main window list to correct functions.
 * defined structure of high level scaling API

[2001-03-28: sashav]
 * Added AS message reading/partiall handling to new WinList. Moved
   get_window_* functions into aswinlist.c Changed the way process_message is
   called - it now takes ASMessage * as a param. Made everything compiling.
 * some theory investigation into up scaling algorithms with smoothing

[2001-03-27: sashav]
 * the best variant of compression algorithm - average compression ratio is
   about 75for highly random images(nature) and 30for regular images (naked
   body, etc.); no off to more exciting things

[2001-03-26: sashav]
 * no message
 * fixed compression code

[2001-03-24: owsla]
 * removed static keyword from libasimage_decode_line, this was preventing it
   from being exported in the lib, which made the test program fail

[2001-03-23: sashav]
 * optimized asimage decompression algorithm scaling down algorithm
   implemented/.
 * extensive asimage debugging - compression now seems to work fine

[2001-03-22: sashav]
 * Completed implementation of Pixmap->ASImage->Pixmap cycle Now off to
   debugging and implementing of scaling/alpha-blending/etc.
 * added timeouts to asetroot for displaying window; added flush_wmprops_data
   to remove specifyed properties - updated asetroot to use it. fixed rather
   nasty bug in asvector causing memory corruption in modules code; Fixed error
   handling in LoadImage

[2001-03-21: sashav]
 * Fixed module connection code to corrently use WMProps to get socket
   filename. Fixed afterstep initialization to setup modules only after WMProps
   initialized.
 * Updated asetroot to use ASWMProps for background property reading/writing.
   Added even handler to wmprops.c to handle property change events for root
   and selection windows - need to do the same for client properties as well (
   maybe?) . Added set_as_background to wmprops.c for asetroot to use. Added
   set_client_names and set_client_hints to clientprops.c for use by modules.
   Added set_text_property to facilitate conversion into UTF8 of text
   properties where needed. Added encode_atom_list to allow for easy
   translation from bitset into atom list. Updated asetroot to use new
   set_client_* functions for hints. ( it now is Extended WM specs compliant as
   needed).

[2001-03-20: sashav]
 * Fixed Cursor grabbing code to use correct cursor IDs. Fixed auditing code to
   not count memory cached in freed pool. Added destruction code for LayoutDef.
   Fixed default DecorLayouts to put things in the right places. Numerous fixes
   in LayoutDef generation code. Window decorations seems to be correct now.
   Added checks to several places in mystyles to check for non-zero pixmap
   size. There still is wierd bug in menuwindow causing X errors on menu close.
 * fixed several memory corruption bugs in myicon_create, mylook_init and
   ashash. Added flush_ashash_memory_pool to free up memory so that audit shows
   relevant data. added cleanup_mode to audit to disable invalid opointer
   reports (if needed)

[2001-03-19: sashav]
 * hmm, catching bugs in new layout code - making progress - AS now segfaults
   due to some obscure memory corruption. :)

[2001-03-13: sashav]
 * Improved owsla's fix to counter bug - xdestroyimage should not really be
   deallocating NULL memory

[2001-03-11: owsla]
 * Fixed bug that caused Total deallocs to be higher than Total allocs, this
   happened because count_find_and_extract() did not have an alternative if
   remove_hash_item() failed.
 * Added a pretty line break in spool_unfreed_mem()

[2001-03-08: sashav]
 * no message

[2001-03-06: sashav]
 * almost done with ornament layout generation code - smaller part of frame
   layout left. reverted ASHashKey back to unsigned short - when it was changed
   to unsigned int - no idea.

[2001-02-22: sashav]
 * Fixed crashing bugs in aswindow.c(restack_window()) and Xmodule.c(
   My_XErrorHandler()) Standardized titlebar resizing/respacing functions and
   now use it in both WMIcon and WMDecor. Fixed icons being black on second
   inocification - needed to resize layouts in fix_icon_size. Icon title now is
   drawn not smaller then icon itself.

[2001-02-15: sashav]
 * Completed implementation of function validation in asfeel.c; Fixed cursor
   grabbing in ExecuteComplexFunction to use actuall cursor ID instead on
   number. Supposedly got icon mapping/unmapping right this time.
   Iconification/deiconification actually works now, but fails on reentry -
   i.e. iconify->deiconify->iconify - needs some more debugging. Fixed memory
   corruption in winlist menu.

[2001-02-14: sashav]
 * playing with mywmicon and widgets. Implmented event bubbling up to higher
   level widgets if not handled by a widget. Implemented some memory
   conservation when allocating memory for MyLayourElems. Implemented memory
   preallocation caching for ASHashItem.

[2001-02-01: sashav]
 * extensive debugging of window initial mapping and subsequent withdrawal.
   Windows are now decorated and destroyed correctly. Multiple reparenting/
   messaging/destruction bugs fixed. Placement fixed when window is decorated
   after AS startup and is using USPosition. Menus needs some debugging.
 * event debugging

[2001-01-30: sashav]
 * Added mystrdup/mystrndup to memory audit code, since they are so generic;
   Fixed memory leaks in asdatabase.c(match_list), Feel.c(key binding and
   EdgeScroll), CaptureAllWindows (read_32prop_list), few other places.
   Implemented cleanup procedures for all the static data (aswindows.c,
   clientprops.c, modules.c, wmprops.c,mystyles.c); Fixed workspace session
   saving code to correctly recognize and workaround geometry. AfterSTep has no
   visible memory leaks as of now.

[2001-01-29: sashav]
 * removed config reading from the pipe - was causing some compile time
   problems, and updated README.nl
 * Changed memory audit to use hash tables instead of linked list - its blazing
   fast now. Added add_hash_item to memory audit recognizeable functions -
   makes it much more usefull. Need to do the same for strdup functions.

[2001-01-28: sashav]
 * Drawing in spaces between titlebar and client is fixed - new option
   BorderColor has to be added to MyStyles. Several memory leaks fixed - in
   menus, destruction of disabled elements in mywidgets, etc.

[2001-01-26: sashav]
 * nailed down this memory corruption bug - VECTOR_TAIL was not working very
   good - forgot to multiply by unit size. Now lets fnd out with this huge
   number of pipes in linux 2.4 - 1024 - event loop has to be rewritten to
   yield sufficient performance there

[2001-01-25: sashav]
 * Side/lowbar is now appearing. Manhunt is underway for some nasty memory leak
   bug causing memory allocations of some random (very large) sizes. Added
   print_mem_stats_info to audit.c to enable output of short version of memory
   allocation status.
 * Fixed initial placement of clients; Fixed initial layer. Fixed X errors on
   initial feel load;

[2001-01-24: sashav]
 * finally got frame decoration to draw - topmost frame was never mapped.
   improved abit decor initialization code to avoid redundand calculations.
   Fixed bug in afterstep main to change desktop correctly when AS is restarted
 * updated debugging log
 * Fixed memory audition for new property reading/allocation functions :
   XListProperties, XGetTextProperty, XAllocClassHint, XAllocSizeHints; added
   LOCAL_DEBUG_CALLER_OUT macro to enable runtime caller backtracing.

[2001-01-21: sashav]
 *  implemented ASHints serialization - need to implement decerealization next.

[2001-01-18: sashav]
 * Implemeted Circulation/warping code. Some more cleanup in functions.c.

[2001-01-16: sashav]
 * Updated DeferExecution to use ASEvent and cleaned up a bit; Changed
   ExecFunction to use ASEvent - still alot to do here. Changed
   check_allowed_menu_func to use mask as an argument instead of ASWindow
   pointer. Fixed SaveOpenedWindows in afterstep.c. changed spawn_child to not
   add & at the end of cmdline if requested to not fork. Made KeyboardShortcuts
   to compile. Disabled most of the event handlers to not participate in
   compile for now. Fixed colormaps.c to use ASEvent. Added match_string_list
   to regexp.c. Added pattern2ASWindow to aswindow.c to facilitate pattern
   matching of window names.

[2001-01-12: sashav]
 * Got desktop.c to compile. Added set_desktop_num_prop and
   set_current_desk_prop to wmprops.c to facilitate updates of all those pesky
   compatibility properties on root window. Added set_client_state and
   set_client_desk in clientprops.c to enable update of the window state
   properties as per Gnome and ExtWM specs. Added change_window_state() to
   aswindow.c to provide unified interface to changing window status. Moved
   Reparent/Map/UnmapIt to aswindow.c and renamed them to be reparent_window,
   map_window, unmap_window - seems to be more consistent. Updated hints and
   clientprops to latest ExtWM specs - ICON_NAME and SKIP_PAGER added. Started
   cleaning up events.c

[2001-01-10: sashav]
 * fixed bug in hash table sorting, that was causing endless looping and
   out-of-bounds memory access

[2001-01-07: sashav]
 * implemented singleton launcher in lib/asapp. Switched background drawing and
   sound playing to use it.

[2001-01-04: sashav]
 * some more afterstep.c cleanup. Added set_as_module_socket to wmprops.c
   Removed get_virtual_root from Xmodule.c - should use wmprops now. minor
   cleanup of src/afterstep/module.c - needs way more work.
 * implemented ASWMProps strructure and some essential reading procedures.
   asproperty is gone and code is consolidated with xprop.c/.h

[2001-01-03: sashav]
 * implemented selections mechnismus. Implemented some Window Manager
   compatibility properties added property writing functions to xprop.c

[2001-01-02: sashav]
 * added forgotten xprop.c to Makefile
 * some more development in afterstep.c - spawining children is updated.
   Rearranged hints/properties in libafterstep to allow for more modular
   approach - properties on client windows are separated from the properties on
   root window. All the string code consolidated into mystring.c. Gort rid of
   CatString3 and CopyString. Implemented MakeSessionDataFile to build
   filenames of icons, etc. in ASCP.

[2000-12-28: sashav]
 * Added automated check for -V command line parameter to ASModule.c for use by
   modules

[2000-12-27: sashav]
 * completed session saving into file code - Window Maker sucks! rearranged
   CaptureAllWindows. add_window now allows to add window based on its
   WM_STATE.
 * fixed print_simple_backtrace to work around buggy gcc. Got rid of wild.c -
   moved into regexp.c

[2000-12-26: sashav]
 * Implemented show_error/warning and DEBUG_OUT/LOCAL_DEBUG_OUT. Implemented
   stack backtracing from failed X calls without signals. Converted old code in
   libasGUI to use new output routines. Compilation problem fixed related to
   removal of misc.h.

[2000-12-22: sashav]

[2000-12-21: sashav]
 * renamed ShutDown.xpm to shutdown2.xpm
 * restacking developments
 * added -fPIC

[2000-12-15: sashav]

[2000-12-14: sashav]
 * ChangeLog and configure fixed for the new version
 * Some new basic ASWindow evelopment
 * ASVector developed and tested - seems to be working just fine.
 * Removed short term memory allocation code since it is useless anyways and
   was causing some compilation problems on older compilers.
 * socket fix to make AS 1.8 work with CYGWIN under Windows NT/9x

[2000-12-13: sashav]
 * dynamic_buffer changed to ASVector with the goal to make it more general
   purpose and use in different places. Started work on ASWindowList

[2000-12-12: sashav]
 * completed transition to libasGUI. King is dead - Long Live The King
 * libasimage has been renamed to libasGUI

[2000-12-11: sashav]
 * Exposure and ConfigureNotify handling is correct now. Fixed bugs in
   MyLookInit and CheckPixmapCache.

[2000-12-08: sashav]
 * Debugged stanradr decoration layouting; Fixed rotation of the icons; Added
   option for each text letter to be rotated individually

[2000-12-06: sashav]
 * Assorted debugging

[2000-11-27: sashav]
 * Libraries compile, but BackPixmap needs debugging

[2000-11-24: owsla]

[2000-11-23: owsla]
 * _'s fixed

[2000-11-17: sashav]
 * completely implemented new ASFeel utilization. Still needs work to implement
   autoexec execution. Got rid of all the old config reading crap

[2000-11-16: sashav]
 * Keyboard and Mouse bindings fixin. There could be several bindings for the
   same context for the single control - but with different mods. That forces
   us to alter algorithm used previously. But indeed it turned out to be more
   memory intensive, but easier to code approach.

[2000-11-13: sashav]
 * Applying ASFeel to afterstep

[2000-11-07: sashav]
 * Keyboard and Mouse bindings parsing implemented

[2000-11-02: sashav]
 * Menu Drawing completed, started menu events handler config->pixmap
   conversion part of asetroot has been moved out into libasimage ( for ASCP )
   myscandir incorporated into the dirtree.c: myscandir.c and myscandir.h
   removed.

[2000-10-31: sashav]

[2000-10-30: sashav]
 * ASFeel_debugging
 * added functions for libAsConfig to read menu from directory, standard menu,
   fixed menu. Imlemented menu loading for ASFeel added asfeel.c file to
   libafterstep Definied data structures to hold keyboard and mouse bindings
   Moved is_executable_in_path to libafterstep Hopefully fixed look/feel
   changing and different looks/feels per desktop added get_window_feel,
   get_desktop_look, get_desktop_feel functions

[2000-10-20: sashav]

[2000-10-18: sashav]

[2000-10-16: sashav]
 * Implemented XImage caching using resource manager. Implemented resource
   duplication using resource manager.

[2000-10-13: sashav]
 * Implemented MyStyle storage using Hash tables - needs some  more work

[2000-10-12: sashav]
 * Added PLAY_SOUND message and function Implemented dynamically growing
   buffers and used them in module communications

[2000-10-11: sashav]
 * Fixed Compilation problems with RedHat 7.0 use of unautorised gcc - take2
 * Fixed Compilation problems with RedHat 7.0 use of unautorised gcc

[2000-10-10: sashav]

[2000-09-22: sashav]
 * added feature (lib/global.c) allowing for levels of verbose output Added
   database printing functions Added database building code into InitDatabase
   Fixed few stupid bugs in regexp compilation code.

[2000-09-21: sashav]
 * finalized Style database storage, management and matching code - added
   asdatabase to the libafterstep

[2000-09-19: sashav]

[2000-09-18: sashav]
 * fixed TITLE and added stuff to print out hints for windows
 * Added safecalloc so now we can get preinitialized memory from OS

[2000-08-31: sashav]
 * Added_ReadFlagItem_function

[2000-08-24: sashav]

[2000-08-23: sashav]
 * style_record

[2000-08-22: sashav]
 * name_record
 * regexp_moved_into_libafterstep
 * regexp_added_to_lib_afterstep

[2000-08-16: sashav]
 * MyFrames_config_almost_done

[2000-08-15: sashav]
 * ASContextIsGone
 * option_ashahs_value_WharfForder_bug_fix

[2000-08-11: sashav]

[2000-08-10: sashav]
 * parser_using_ashash

[2000-08-06: sashav]

[2000-08-02: sashav]

[2000-07-31: sashav]

[2000-07-30: sashav]
 * added_resources_manager_implemented_color_resources

[2000-07-29: sashav]
 * completed_ashash_code

[2000-07-28: sashav]
 * as_hash_almost_complete

[2000-07-26: sashav]
 * ashash_added

[2000-07-23: sashav]

[2000-07-19: sashav]
 * better_selfdiag_and_session_test

[2000-06-28: sashav]
 * LookOldOptsDone

[2000-06-11: sashav]
 * SignalHandler

[2000-06-07: sashav]

[2000-06-01: sashav]
 * RestackWindow

[2000-05-18: sashav]

[2000-05-16: sashav]

[2000-05-15: sashav]
 * asImageFromXImageTest

[2000-04-30: allanon]
 * o added runtime options for X call tracing o fixed outline (non-opaque)
   resizes

[2000-04-29: sashav]
 * Look_now_compiles

[2000-04-26: sashav]

[2000-04-25: allanon]
 * Initial revision
